# pydsm
Python package for computation of synthetic waveforms in spherically homogeneous transversely isotropic (VTI) media using the Direct Solution Method (DSM; [Kawai et al. 2006](https://doi.org/10.1111/j.1365-246X.2005.02829.x)).<br/><br/>
Documentation and tutorials can be found [here](https://afeborgeaud.github.io/dsmpy/).

## INSTALLATION
1) From the Terminal, clone the pydsm git repository:
```
git clone git@github.com:afeborgeaud/pydsm.git
```

2) Set the PYTHONPATH
```export PYTHONPATH="$PYTHONPATH:<path_of_pydsm_folder>"```  
- Warning: at the moment, the pydsm folder must be named `pydsm' for the python imports to work (not, e.g., pydsm-master)

3) Install [Anaconda (python 3)](https://www.anaconda.com/products/individual)

4) Using ```conda```, install the following python packages required to run *pydsm*:
```shell
# create environment pydsm (or any other name)
conda create -n pydsm python=3.7
# install dependencies
conda install -n pydsm numpy mpi4py pandas matplotlib -y
conda install -n pydsm -c conda-forge obspy geographiclib -y
```

5) Activate the pydsm conda environment. *pydsm* should be run within this enviroment (otherwise, you might miss some dependencies)
```
conda activate pydsm
```

6) Check that pydsm has been setup succesfully:
```
python -c "import pydsm"
```
Note: Fortran sources for the DSM will be compiled the first time *pydsm* is imported. Python libraries are created from the DSM Fortran sources using numpy.f2py and the gfortran compiler. If you get compilation errors, check the following:
- gfortran >= 4.8 is required for succesful compilation, since we use the optimization flag '-Ofast'
- If you have gfortran <4.8, you should change the compiler flag from '-Ofast' to '-O3' in ```<path_of_pydsm_folder>/pydsm/__init__.py```

## GETTING STARTED
Before getting started, you should at least run ```python test_tipsv.py``` and ```python test_tish.psv``` located in in ```<path_of_pydsm_folder>/pydsm/tests```. These scripts check pydsm against pre-computed synthetics using the DSM (Fortran).

## EXAMPLES OF USAGE
1) Running pydsm using pydsm input file (run on multiple CPUs).
A template input file is in ```<path_of_pydsm_folder>/pydsm/tests/input_files/template.txt```:
```shell
sac_files ~/git/pydsm/tests/sac_files/*T
output_folder ~/git/pydsm/tests/sac_files
# duration of synthetics (in seconds)
tlen 3276.8
# number of points of frequency-domain synthetics
# minimum period Tmin = tlen / nspc (s)
nspc 256 
# sampling frequency for time-domain synthetics
sampling_hz 20
# prem, ak135
seismic_model prem 
# 0: P-SV+SH, 1: P-SV, 2: SH (default: 0)
mode 0
# 0: quiet, 1: talkative, 2: debug (default: 0)
verbose 0
```

To run this input file on 2 CPUs:
1) open a Terminal 
2) change the current directory to the pydsm directory
3) paste:
```shell
mpiexec -n 2 python pydsm/main.py tests/input_files/template.txt
```

2) Running pydsm from your python script.
Below is an example of python script using pydsm to compute synthetics:
```python
from pydsm import dsm, seismicmodel
from pydsm.event import Event
from pydsm.station import Station
from pydsm.utils.cmtcatalog import read_catalog
# load gcmt catalog
catalog = read_catalog()
# get event from catalog
event = Event.event_from_catalog(
    catalog, '200707211534A')
# define station FCC
stations = [
    Station(
        name='FCC', network='CN',
        latitude=58.7592, longitude=-94.0884), 
    ]
# load (anisotropic) PREM model
seismic_model = seismicmodel.SeismicModel.prem()
tlen = 3276.8 # duration of synthetics (s)
nspc = 256 # number of points in frequency domain
sampling_hz = 20 # sampling frequency for sythetics
# create input parameters for pydsm
input = dsm.PyDSMInput.input_from_arrays(
    event, stations, seismic_model, tlen, nspc, sampling_hz)
# compute synthetics in frequency domain calling DSM Fortran
output = dsm.compute(input)
output.to_time_domain() # perform inverse FFT
us = output.us # synthetics. us.shape = (3,nr,tlen)
ts = output.ts # time points [0, tlen]
# brackets can be used to access component and station
u_Z_FCC = output['Z', 'FCC_CN']
# to plot a three-component record section, use
output.plot()
plt.show()
# to write synthetics to SAC files, use
output.write(root_path='.', format='sac')
```

3) Running pydsm using a (Fortran) DSM input file.
Methods are provided to run pydsm using an input file for the (Fortran) DSM:
```python
from pydsm import dsm, rootdsm_sh
parameter_file = rootdsm_sh + 'AK135_SH.inf'
inputs = dsm.PyDSMInput.input_from_file(parameter_file, mode=2)
outputs = dsm.compute(inputs, mode=2)
outputs.to_time_domain()
us = outputs.us    # us.shape = (3,nr,tlen)
ts = outputs.ts    # len(ts) = tlen
stations = outputs.stations        # len(stations) = nr
components = outputs.components    # len(components) = 3
```

SUBROUTINE GLU( A, N, N1, B, EPS, WK, IP, IER )
!        GLU, GLUSUB
!               COPYRIGHT : H.HASEGAWA, AUG. 26 1989 V.1
!
!               SOLVES SIMULTANEOUS LINEAR EQUATIONS
!               BY GAUSSIAN ELIMINATION METHOD.
!
!        INPUT - -
!             A(N1,N)  R *8  : 2-DIM. ARRAY CONTAINING THE COEFFICIENTS.
!             N        I *4  : ORDER OF MATRIX.
!             N1       I *4  : SIZE OF ARRAY A.
!             B(N)     R *8  : 1-DIM. ARRAY CONTAINING THE RIGHT-HAND
!                              SIDE VECTOR.
!             EPS      R *8  : PARAMETER TO CHECK SINGULARITY OF THE
!                              MATRIX. ( STANDARD VALUE 3.52D-15 )
!        OUTPUT - -
!             A(N1,N)        : RESULT OF GAUSSIAN ELIMINATION.
!             B(N)           : SOLUTION.
!             IP(N)    I *4  : PIVOT NUMBER.
!             IER      I *4  : = 0,  FOR NORMAL EXECUTION.
!                              = 1,  FOR SINGULAR MATRIX.
!                              = 2,  FOR SINGULAR ORIGINAL MATRIX.
!                              = 3,  FOR INVALID ARGUEMENT.
!        WORKING  -
!             WK(N)    R *8  : 1-DIM. ARRAY.
! modified : Kensuke Konishi 2018 in Paris
    use parameters
    implicit none
    INTEGER:: N,N1
    INTEGER:: IP(N),IER
    double precision:: EPS
    COMPLEX(dp)::A(N1,N),B(N),WK(N)
    INTEGER:: I,J,K,IPK
    COMPLEX(dp):: AMAX,AIK,W,T
    !             LEFT-HAND SIDE
    IF( EPS<0 ) EPS = 3.52D-15
    IF( N1<N .OR. N<=0 )  THEN
        IER = 3
        WRITE(*,*) '  (SUBR. GLU)  INVALID ARGUMENT.  N1, N =', N1, N
        RETURN
    END IF
    !  CHECK ORIGINAL MATRIX.
    WK(1:n) = cdabs(A(1:n,1))

    DO J = 2, N
        WK(1:n) = DMAX1( cdabs( WK(1:n) ), cdabs(A(1:n,J)) )
    enddo
    DO I = 1, N
        IF( cdabs( WK(I) )<EPS )  THEN
            IER = 2
            WRITE(*,*) '  (SUBR. GLU)  ORIGINAL MATRIX IS SINGULAR.'
            RETURN
        END IF
    enddo

    IER = 0
    DO K = 1, N
        !  FIND MAXIMUM ELEMENT IN THE K-TH COLUMN.
        AMAX = cdabs(A(K,K))
        IPK = K
        DO I = K+1, N
            AIK = cdabs(A(I,K))
            IF( cdabs( AIK )>cdabs( AMAX ) )  THEN
                IPK = I
                AMAX = AIK
            END IF
        enddo
        IP(K) = IPK

        IF( cdabs( AMAX )>EPS )  THEN
            IF( IPK/=K )  THEN
                W = A(IPK,K)
                A(IPK,K) = A(K,K)
                A(K,K) = W
            END IF
            ! COMPUTE ALFA
            DO I = K+1, N
                A(I,K) = -A(I,K)/A(K,K)
                WK(I) = A(I,K)
            enddo

            DO J = K+1, N
                IF( IPK/=K )  THEN
                    W = A(IPK,J)
                    A(IPK,J) = A(K,J)
                    A(K,J) = W
                END IF
                ! GAUSSIAN ELIMINATION
                T = A(K,J)

                A(K+1:N,J) = A(K+1:N,J) + WK(K+1:N)*T

            enddo
        ! MATRIX IS SINGULAR.
        ELSE
            IER = 1
            IP(K) = K

            A(k+1:n,K) = 0

            WRITE(*,*) '  (SUBR. GLU)  MATRIX IS SINGULAR AT K =', K
            RETURN
        END IF
    enddo
    !  RIGHT-HAND SIDE
    !	ENTRY GLUSUB( A, B )
    ENTRY GLUSUB( A, N, N1, B, EPS, WK, IP, IER )
    !  FORWARD ELIMINATION PROCESS
    DO K = 1, N
        IF( IP(K)/=K ) THEN
            W = B(IP(K))
            B(IP(K)) = B(K)
            B(K) = W
        END IF

        T = B(K)
        B(K+1:N) = B(K+1:N) + A(K+1:N,K)*T
    enddo
    !   BACKWARD SUBSTITUTION PROCESS
    B(N) = B(N)/A(N,N)
    DO K = N-1, 1, -1
        T = B(K+1)
        B(1:k) = B(1:k) - A(1:k,K+1)*T
        B(K) = B(K)/A(K,K)
    enddo
    RETURN
END

subroutine tish(re,ratc,ratl,tlen,np,omegai,imin,imax, &
   nzone,vrmin,vrmax,rrho,vsv,vsh,qmu, &
   r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output,write_to_file, &
   outputu)
!------------------------------------------------------------------------
!  ************** tish.f ****************
! Computation of SH synthetic seismograms
! in transversely isotropic media for anisotropic PREM
! using modified DSM operators & modified source representation.
! Synthetics for shallow events can be computed.
!
!                                                 2002.10 K.Kawai
!------------------------------------------------------------------------
    use parameters
    implicit none
! ----------------------------<<variables>>----------------------------
! write to files?
    logical, intent(in) :: write_to_file
! variable for the trial function
    integer nnlayer,nlayer(maxnzone)
    integer l,m
    real(dp) ra(maxnlay+maxnzone+1),gra(3),plm(3,0:3,maxnr)
    complex(dp) bvec(3,-2:2,maxnr)
! variable for the structure
    integer, intent(in) :: nzone
    integer ndc,vnp
    real(dp) rmin,rmax
    real(dp), intent(in) :: vrmin(maxnzone),vrmax(maxnzone)
    real(dp), intent(in) :: rrho(4,maxnzone),vsv(4,maxnzone),vsh(4,maxnzone)
    real(dp), intent(in) :: qmu(maxnzone)
    real(dp) vra(maxnlay+2*maxnzone+1)
    real(dp) rho(maxnlay+2*maxnzone+1)
    real(dp) ecL(maxnlay+2*maxnzone+1)
    real(dp) ecN(maxnlay+2*maxnzone+1)
    real(dp) gvra(3),grho(3),gecL(3),gecN(3)
    complex(dp) coef(maxnzone)
! variable for the periodic range
    integer, intent(in) :: np,imin,imax
    real(dp), intent(in) :: tlen,omegai
    complex(dp):: comega2
    real(dp) omega
    complex(dp) u(3,maxnr)
! variable for the source
    integer spn,ns
    real(dp), intent(in) :: r0,mt(3,3),eqlat,eqlon
    real(dp) spo,mu0
! variable for the station
    integer, intent(in) :: nr
    integer ir
    real(dp), intent(in) :: theta(maxnr),phi(maxnr)
    real(dp), intent(in) :: lat(maxnr),lon(maxnr)
! variable for the matrix elements
    complex(dp) a0( 2,maxnlay+1 ), a2( 2,maxnlay+1 )
    complex(dp)  a( 2,maxnlay+1 )
    real(dp) t( 4*maxnlay )
    real(dp) h1( 4*maxnlay ),h2( 4*maxnlay )
    real(dp) h3( 4*maxnlay ),h4( 4*maxnlay )
    real(dp) gt(8),gh1(8),gh2(8),gh3(8),gh4(8)
    complex(dp) aa(4),ga(8),ga2(2,3),gdr(3)
    complex(dp) g( maxnlay+1 )
! variable for the file
    character*80, intent(in) :: output(maxnr)
! variable for grid spacing
    real(dp) tmpr(maxnlay+1)
    real(dp) gridpar(maxnzone),dzpar(maxnzone),vmin(maxnzone)
    real(dp), intent(in) :: re,ratc,ratl
    real(dp) maxamp
    integer kc,lsuf,ismall,llog
! variable for the stack point
    integer isp(maxnzone),jsp(maxnzone),ins
! other variables
    integer i,j,ii,jj,nn,ier
    real(dp) eps,work( 4*maxnlay ),lsq
    complex(dp) dr(maxnlay+1),z(maxnlay+1)
    complex(dp) cwork( 4*maxnlay )
    integer ltmp(2),iimax

    integer,parameter:: lda=2
    data eps/ -1.d0 /

    complex(dp), intent(out) :: outputu(3,nr,imin:imax)

! --- computing the required parameters ---
! computing and checking the parameters
    rmin = vrmin(1)
    rmax = vrmax(nzone)
    ndc = nzone - 1

    if ( r0 < rmin .or. r0 > rmax ) then
        write(*,*) 'Location of the source is improper.'
        return
    endif

! --------------------------------------------------------------------
    iimax = imax
    if( (rmax-r0) < shallowdepth) then ! option for shallow events
! computing of the number and the location of grid points
        iimax = int(tlen * 2)
        call calgrid( nzone,vrmin,vrmax,vsv,rmin,rmax, &
            iimax,1,tlen,vmin,gridpar,dzpar )
        call calra ( nnlayer,gridpar,dzpar,nzone,vrmin,vrmax, &
            rmin,rmax,nlayer,ra,re )
! --- checking the parameter
        if ( nnlayer>maxnlay ) then
            write(*,*) 'The number of grid points is too large.'
            return
        endif
! computing the stack points
        call calsp( ndc,nlayer,isp,jsp )
! computing the source location
        call calspo( ndc,vrmax,nnlayer,r0,rmin,rmax,ra,isp,spo,spn )
! computing grids for source computations
        call calgra( isp,ra,r0,spn,spo,gra )
! ******************* Computing the matrix elements *******************
! computing the structure grid points
        call calstg( nzone,rrho,vsv,vsh, nnlayer,nlayer,ra,rmax, &
        vnp,vra,rho,ecL,ecN)
        call calgstg( spn,rrho,vsv,vsh,gra,gvra,rmax,grho,gecL,gecN,r0,mu0 )
        do i=1,ndc+1
            call calmatc( nlayer(i),vnp,vra,rho,2,0,0,ra( isp(i) ),t( jsp(i) ),work( jsp(i) ) )
            call calmatc( nlayer(i),vnp,vra,ecL,2,1,1,ra( isp(i) ),h1( jsp(i) ),work( jsp(i) ) )
            call calmatc( nlayer(i),vnp,vra,ecL,1,1,0,ra( isp(i) ),h2( jsp(i) ),work( jsp(i) ) )
            call calmatc( nlayer(i),vnp,vra,ecL,0,0,0,ra( isp(i) ),h3( jsp(i) ),work( jsp(i) ) )
            call calmatc( nlayer(i),vnp,vra,ecN,0,0,0,ra( isp(i) ),h4( jsp(i) ),work( jsp(i) ) )
            call caltl( nlayer(i),vnp,vra,rho,ra( isp(i) ),work( jsp(i) ) )
            t(jsp(i):jsp(i)+4*nlayer(i)-1)=(t(jsp(i):jsp(i)+4*nlayer(i)-1)&
             +work(jsp(i):jsp(i)+4*nlayer(i)-1))/2
            call calhl( nlayer(i),vnp,vra,ecL,ra( isp(i) ),work( jsp(i) ) )
            h3(jsp(i):jsp(i)+4*nlayer(i)-1)=(h3(jsp(i):jsp(i)+4*nlayer(i)-1)&
             +work(jsp(i):jsp(i)+4*nlayer(i)-1))/2
            call calhl( nlayer(i),vnp,vra,ecN,ra( isp(i) ),work( jsp(i) ) )
            h4(jsp(i):jsp(i)+4*nlayer(i)-1)=(h4(jsp(i):jsp(i)+4*nlayer(i)-1)&
             +work(jsp(i):jsp(i)+4*nlayer(i)-1))/2
        enddo
        call calmatc( 2,3,gvra,grho,2,0,0,gra,gt, work )
        call calmatc( 2,3,gvra,gecL ,2,1,1,gra,gh1,work )
        call calmatc( 2,3,gvra,gecL ,1,1,0,gra,gh2,work )
        call calmatc( 2,3,gvra,gecL ,0,0,0,gra,gh3,work )
        call calmatc( 2,3,gvra,gecN ,0,0,0,gra,gh4,work )
        call caltl( 2,3,gvra,grho,gra,work )
        gt(1:8)=(gt(1:8)+work(1:8))/2

        call calhl( 2,3,gvra,gecL, gra,work )
        gh3(1:8)=(gh3(1:8)+work(1:8))/2

        call calhl( 2,3,gvra,gecN, gra,work )
        gh4(1:8)=(gh4(1:8)+work(1:8))/2

        nn = nnlayer + 1
        ns = isp(spn) + dint(spo)
        ins = 4 * ns - 3

        llog = 0
        do ii=1,2 ! omega-loop
            if(ii==1) then
                if(imin==0) then
                    i=1
                else
                    i=imin
                endif
            endif
            if(ii==2) i=imax
            omega = 2 * pi * dble(i) / tlen
            comega2 = dcmplx( omega, -omegai ) * dcmplx( omega, -omegai )

            call callsuf(omega,nzone,vrmax,vsv,lsuf)
            call calcoef( nzone,omega,qmu,coef )

            a0(1:lda,1:nn)=0
            a2(1:lda,1:nn)=0
            do j=1,ndc+1
                !cala0
                cwork(jsp(j):jsp(j)+4*nlayer(j)-1)= comega2*(t(jsp(j):jsp(j)+4*nlayer(j)-1))&
                -coef(j)*(h1(jsp(j):jsp(j)+4*nlayer(j)-1)-h2(jsp(j):jsp(j)+4*nlayer(j)-1)&
                +h3(jsp(j):jsp(j)+4*nlayer(j)-1)-2*h4(jsp(j):jsp(j)+4*nlayer(j)-1))
                call overlap( nlayer(j),cwork(jsp(j)),a0( 1,isp(j) ) )
                !cala2
                cwork(jsp(j):jsp(j)+4*nlayer(j)-1)=-coef(j)* h4(jsp(j):jsp(j)+4*nlayer(j)-1)
                call overlap( nlayer(j),cwork(jsp(j)),a2( 1,isp(j) ) )
            enddo

            kc = 1
            ismall = 0
            maxamp = -1
            ltmp(ii) = maxlmax
            do l=0,maxlmax ! l-loop
                if( ismall>20 ) then
                    if(ltmp(ii)>l) ltmp(ii) = l
                    exit
                endif

               ! initialize
                tmpr(1:maxnlay+1) = 0.d0
                lsq = dsqrt( l*(l+1d0) )
! computing the coefficient matrix elements
! --- Initializing the matrix elements
                a(1:lda,1:nn)=0
                ga2(1:lda,1:3)=0

                ! Computing the coefficient matrix 'a' in the solid part. cala
                a(1:2,1:nn) = a0(1:2,1:nn) + l*(l+1) * a2(1:2,1:nn)

                !c Computing the coefficient matrix 'a' in the solid part. calga
                aa(1:4) = comega2 * t(ins:ins+3)&
                - coef(spn) * ( h1(ins:ins+3)-h2(ins:ins+3)+h3(ins:ins+3)+dble(l*(l+1)-2)*h4(ins:ins+3) )
                ga(1:8)=comega2*gt(1:8)&
                - coef(spn)*( gh1(1:8)-gh2(1:8)+gh3(1:8)+(l*(l+1)-2)*gh4(1:8) )


                call overlap( 2,ga,ga2 )

                do m=-2,2 ! m-loop
                    if (  m/=0 .and. iabs(m)<=iabs(l) ) then
                        g(1:nn)=0
                        call calg2( l,m,spo,r0,mt,mu0,coef(spn),ga,aa,ga2,gdr,g(isp(spn)) )
                        if( mod(l,100)==0) then
                            if ( m==-2 .or. m==-l ) then
                                call dclisb0( a,nn,1,lda,g,eps,dr,z,ier)
                            else
                                call dcsbsub0( a,nn,1,lda,g,eps,dr,z,ier)
                            endif
                            !sum up c of the same l
                            tmpr(1:nn) = tmpr(1:nn) + cdabs(g(1:nn))
                        else
                            if ( m==-2 .or. m==-l ) then
                                call dclisb( a(1,kc),nn-kc+1,1,lda,ns-kc+1 &
                                     ,g(kc),eps,dr,z,ier)
                            else
                                call dcsbsub( a(1,kc),nn-kc+1,1,lda,ns-kc+1 &
                                     ,g(kc),eps,dr,z,ier)
                            endif
                        endif

                        if( mod(l,100)==0) call calcutd(nzone,nlayer,tmpr,ratc,nn,ra,kc)
                        call calamp(g(nn),l,lsuf,maxamp,ismall,ratl)
                    endif
                enddo ! m-loop
            enddo ! l-loop
        enddo ! omega-loop
        iimax = dble(max(ltmp(1),ltmp(2))) * tlen / lmaxdivf
    endif ! option for shallow events

! computing of the number and the location of grid points
    call calgrid( nzone,vrmin,vrmax,vsv,rmin,rmax,iimax,1,tlen,vmin,gridpar,dzpar )
    call calra ( nnlayer,gridpar,dzpar,nzone,vrmin,vrmax,rmin,rmax,nlayer,ra,re )
! --- checking the parameter
    if ( nnlayer>maxnlay ) then
        write(*,*) 'The number of grid points is too large.'
        return
    endif
! computing the stack points
    call calsp( ndc,nlayer,isp,jsp )
! computing the source location
    call calspo( ndc,vrmax,nnlayer,r0,rmin,rmax,ra,isp,spo,spn )
! computing grids for source computations
    call calgra( isp,ra,r0,spn,spo,gra )
! ******************* Computing the matrix elements *******************
! computing the structure grid points
    call calstg( nzone,rrho,vsv,vsh,nnlayer,nlayer,ra,rmax,vnp,vra,rho,ecL,ecN)
    call calgstg( spn,rrho,vsv,vsh,gra,gvra,rmax,grho,gecL,gecN,r0,mu0 )
    do i=1,ndc+1
        call calmatc( nlayer(i),vnp,vra,rho,2,0,0,ra( isp(i) ),t( jsp(i) ),work( jsp(i) ) )
        call calmatc( nlayer(i),vnp,vra,ecL,2,1,1,ra( isp(i) ),h1( jsp(i) ),work( jsp(i) ) )
        call calmatc( nlayer(i),vnp,vra,ecL,1,1,0,ra( isp(i) ),h2( jsp(i) ),work( jsp(i) ) )
        call calmatc( nlayer(i),vnp,vra,ecL,0,0,0,ra( isp(i) ),h3( jsp(i) ),work( jsp(i) ) )
        call calmatc( nlayer(i),vnp,vra,ecN,0,0,0,ra( isp(i) ),h4( jsp(i) ),work( jsp(i) ) )
        call caltl( nlayer(i),vnp,vra,rho,ra(isp(i)),work( jsp(i) ) )
        t(jsp(i):jsp(i)+4*nlayer(i)-1)=(t(jsp(i):jsp(i)+4*nlayer(i)-1)&
             +work(jsp(i):jsp(i)+4*nlayer(i)-1))/2
        call calhl( nlayer(i),vnp,vra,ecL,ra( isp(i) ),work( jsp(i) ) )
        h3(jsp(i):jsp(i)+4*nlayer(i)-1)=(h3(jsp(i):jsp(i)+4*nlayer(i)-1)&
             +work(jsp(i):jsp(i)+4*nlayer(i)-1))/2
        call calhl( nlayer(i),vnp,vra,ecN,ra( isp(i) ),work( jsp(i) ) )
        h4(jsp(i):jsp(i)+4*nlayer(i)-1)=(h4(jsp(i):jsp(i)+4*nlayer(i)-1)&
             +work(jsp(i):jsp(i)+4*nlayer(i)-1))/2
    enddo
    call calmatc(2,3,gvra,grho,2,0,0,gra,gt, work)
    call calmatc(2,3,gvra,gecL,2,1,1,gra,gh1,work)
    call calmatc(2,3,gvra,gecL,1,1,0,gra,gh2,work)
    call calmatc(2,3,gvra,gecL,0,0,0,gra,gh3,work)
    call calmatc(2,3,gvra,gecN,0,0,0,gra,gh4,work)
    call caltl( 2,3,gvra,grho,gra,work )
    gt(1:8)=(gt(1:8)+work(1:8))/2

    call calhl( 2,3,gvra,gecL,gra,work )
    gh3(1:8)=(gh3(1:8)+work(1:8))/2

    call calhl( 2,3,gvra,gecN,gra,work )
    gh4(1:8)=(gh4(1:8)+work(1:8))/2

! ******************** Computing the displacement *********************
    nn = nnlayer + 1
    ns = isp(spn) + dint(spo)
    ins = 4 * ns - 3

    llog = 0
    do i=imin,imax ! omega-loop
        u( 1:3,1:nr )=0

        if ( i/=0 ) then
            omega = 2 * pi * i / tlen
            comega2 = dcmplx( omega, -omegai ) * dcmplx( omega, -omegai )
            call callsuf(omega,nzone,vrmax,vsv,lsuf)

            plm(1:3,0:3,1:nr)=0

            call calcoef( nzone,omega,qmu,coef )

            a0( 1:lda,1:nn )=0
            a2( 1:lda,1:nn )=0
            do j=1,ndc+1
!cala0
                cwork(jsp(j):jsp(j)+4*nlayer(j)-1)= comega2*(t(jsp(j):jsp(j)+4*nlayer(j)-1))&
                -coef(j)*(h1(jsp(j):jsp(j)+4*nlayer(j)-1)-h2(jsp(j):jsp(j)+4*nlayer(j)-1)&
                +h3(jsp(j):jsp(j)+4*nlayer(j)-1)-2d0*h4(jsp(j):jsp(j)+4*nlayer(j)-1))
                call overlap( nlayer(j),cwork(jsp(j)),a0( 1,isp(j) ) )
                cwork(jsp(j):jsp(j)+4*nlayer(j)-1)=-coef(j)*( h4(jsp(j):jsp(j)+4*nlayer(j)-1) )
                call overlap( nlayer(j),cwork(jsp(j)),a2( 1,isp(j) ) )
            enddo

            kc = 1
            ismall = 0
            maxamp = -1
            llog = maxlmax
            do l=0,maxlmax ! l-loop
                if( ismall>20 ) then
                    if(llog>l) llog = l
                    cycle
                endif

                tmpr(1:maxnlay+1) = 0
                lsq = dsqrt( l*(l+1d0) )
! ***** Computing the trial function *****
                do ir=1,nr
                    call calbvec( l,theta(ir),phi(ir),plm(1,0,ir),bvec(1,-2,ir) )
                enddo
! computing the coefficient matrix elements
                a(1:lda,1:nn)=0
                ga2(1:lda,1:3)=0

                !c Computing the coefficient matrix 'a' in the solid part. cala
                a(1:2,1:nn) = a0(1:2,1:nn) + l*(l+1) * a2(1:2,1:nn)

                !c Computing the coefficient matrix 'a' in the solid part. calga
                aa(1:4)=comega2*t(ins:ins+3)-coef(spn)*(h1(ins:ins+3)-h2(ins:ins+3)+h3(ins:ins+3)+(l*(l+1)-2)*h4(ins:ins+3))
                ga(1:8)=comega2*gt(1:8)- coef(spn)*( gh1(1:8)-gh2(1:8)+gh3(1:8)+(l*(l+1)-2)*gh4(1:8))
                call overlap( 2,ga,ga2 )

                do m=-2,2 ! m-loop
                    if ( m/=0 .and. iabs(m)<=iabs(l) ) then
                        g(1:nn)=0
                        call calg2( l,m,spo,r0,mt,mu0,coef(spn),ga,aa,ga2,gdr,g( isp(spn) ) )
                        if( mod(l,100)==0) then
                            if ( m==-2 .or. m==-l ) then
                                call dclisb0( a,nn,1,lda,g,eps,dr,z,ier)
                            else
                                call dcsbsub0( a,nn,1,lda,g,eps,dr,z,ier)
                            endif
                            tmpr(1:nn) = tmpr(1:nn) + cdabs(g(1:nn))
                        else
                            if ( m==-2 .or. m==-l ) then
                                call dclisb( a(1,kc),nn-kc+1,1,lda,ns-kc+1 &
                                ,g(kc),eps,dr,z,ier)
                            else
                                call dcsbsub( a(1,kc),nn-kc+1,1,lda,ns-kc+1 &
                                 ,g(kc),eps,dr,z,ier)
                            endif
                        endif

                        if( mod(l,100)==0) call calcutd(nzone,nlayer,tmpr,ratc,nn,ra,kc)

                        call calamp(g(nn),l,lsuf,maxamp,ismall,ratl)
                        u(2:3,1:nr) = u(2:3,1:nr) + g(nn) * bvec(2:3,m,1:nr) / lsq
                    endif
                enddo          ! m-loop
            enddo             ! l-loop
        endif
! ************************** Files Handling **************************
        outputu(1:3,1:nr,i) = u(1:3,1:nr)
    enddo                   ! omega-loop

    if (write_to_file) then
        write(*,*) "kakikomimasu"
        do ir = 1 ,nr
            open(1,file=output(ir),status='replace',access='stream',form='unformatted', convert='big_endian')
            write(1) tlen,np,1,3,omegai,lat(ir),lon(ir),eqlat,eqlon,r0

            do i= imin, imax
                write(1) i,dble(outputu(1,ir,i)),dimag(outputu(1,ir,i))
                write(1) dble(outputu(2,ir,i)),dimag(outputu(2,ir,i))
                write(1) dble(outputu(3,ir,i)),dimag(outputu(3,ir,i))
            enddo
            close(1)
        enddo
    endif
    return
end subroutine tish

program main

   use parameters
   implicit none

   character(len=160) :: parameter_file

   integer np
   integer imin
   integer imax
   integer nzone
   integer nr
   real(dp) :: tlen
   real(dp) :: omegai
   real(dp) :: re
   real(dp) :: ratc
   real(dp) :: ratl
   real(dp) :: vrmin(maxnzone)
   real(dp) :: vrmax(maxnzone)
   real(dp) :: qmu(maxnzone)
   real(dp) :: rho(4,maxnzone)
   real(dp) :: vsv(4,maxnzone)
   real(dp) :: vsh(4,maxnzone)
   real(dp) :: r0
   real(dp) :: mt(3,3)
   real(dp) :: lat(maxnr)
   real(dp) :: lon(maxnr)
   real(dp) :: theta(maxnr)
   real(dp) :: phi(maxnr)
   real(dp) :: eqlat
   real(dp) :: eqlon
   character(len=80) :: output(maxnr)
   complex(dp), allocatable, dimension(:,:,:) :: outputu
   logical :: write_to_file = .true.

   ! read input parameters
   call get_command_argument(1, parameter_file)
   call pinput_tish(parameter_file, &
      re,ratc,ratl,tlen,np,omegai,imin,imax, &
      nzone,vrmin,vrmax,rho,vsv,vsh,qmu, &
      r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output)

   allocate(outputu(3,nr,imin:imax))

   ! main loop
   write(*,*) 'Enter main loop'
   call tish(re,ratc,ratl,tlen,np,omegai,imin,imax, &
      nzone,vrmin,vrmax,rho,vsv,vsh,qmu, &
      r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output,write_to_file,outputu)
   write(*,*) 'Done!'

end program main

subroutine tipsv(re,ratc,ratl,tlen,np,omegai,imin,imax, &
   nzone,vrmin,vrmax,rrho,vpv,vph,vsv,vsh,eta,qmu,qkappa, &
   r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output,write_to_file,&
   outputu)
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!c  ************** tipsv.f ****************
!c Computation of PSV synthetic seismograms
!c in transversely isotropic for anisotropic PREM
!c using modified DSM operators & modified source representation.
!c Synthetics for shallow events can be computed.
!c                                                 2002.12  K.Kawai
!c -> f90 Kensuke Konishi 2020 May 5
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    use parameters
    implicit none
! ---------------------------<< constants >>---------------------------
! write to files?
    logical, intent(in) :: write_to_file
! ---------------------------<< variables >>---------------------------
! variable for the trial function
    integer nlayer(maxnzone)
    integer nslay,nllay
    integer inlayer,jnlayer,jnslay,jnllay
    integer l,m
    double precision ra(maxnlay+maxnzone+1),plm(3,0:3,maxnr)
    complex(dp) bvec(3,-2:2,maxnr)
! variable for the structure
    integer nzone,isl,ill,nsl,nll
    integer iphase(maxnzone),ndc,vnp
    double precision rmin,rmax
    double precision,intent(in):: vrmin(maxnzone),vrmax(maxnzone)
    double precision,intent(in):: rrho(4,maxnzone), vpv(4,maxnzone),vph(4,maxnzone)
    double precision,intent(in):: vsv(4,maxnzone),vsh(4,maxnzone),eta(4,maxnzone)
    double precision,intent(in):: qmu(maxnzone),qkappa(maxnzone)
    double precision vra(maxnlay+2*maxnzone+1)
    double precision rho(maxnlay+2*maxnzone+1)
    double precision kappa(maxnlay+2*maxnzone+1)
    double precision ecKx(maxnlay+2*maxnzone+1) !3*Kx=3A-4N
    double precision ecKy(maxnlay+2*maxnzone+1) !3*Ky=3F+2N
    double precision ecKz(maxnlay+2*maxnzone+1) !3*Kz=2F+C
    double precision mu(maxnlay+2*maxnzone+1)
    double precision ecL(maxnlay+2*maxnzone+1)
    double precision ecN(maxnlay+2*maxnzone+1)
    double precision rhoinv(maxnlay+2*maxnzone+1)
    double precision kappainv(maxnlay+2*maxnzone+1)
    complex(dp) coef1(maxnzone),coef2(maxnzone),coef(maxnzone)
! variable for the periodic range
    integer np,imin,imax
    double precision tlen,omega,omegai
    complex(dp) u(3,maxnr)
! variable for the source
    integer spn,ns
    double precision,intent(in):: r0,mt(3,3),eqlat,eqlon
    double precision:: spo,ecC0,ecF0,ecL0
    complex(dp) ya(4),yb(4),yc(4),yd(4)
! variable for the station
    integer,intent(in):: nr
    double precision,intent(in):: theta(maxnr),phi(maxnr)
    double precision,intent(in):: lat(maxnr),lon(maxnr)
!c variable for the matrix elements
    complex(dp) a0(4,2*(2*(maxnslay+1)+(maxnllay+1)+maxnzone))
    complex(dp) a1(4,2*(2*(maxnslay+1)+(maxnllay+1)+maxnzone))
    complex(dp) a2(4,2*(2*(maxnslay+1)+(maxnllay+1)+maxnzone))
    complex(dp) a(4,2*(maxnslay+1) + (maxnllay+1) )
    complex(dp) c(2, (maxnslay+1) + (maxnllay+1) )
    double precision t(8*maxnslay )
    double precision h1x(8*maxnslay ),h1y( 8*maxnslay ),h1z( 8*maxnslay )
    double precision h2L(8*maxnslay ),h2N( 8*maxnslay )
    double precision h3ax(8*maxnslay )
    double precision h3ay(8*maxnslay ),h3az( 8*maxnslay )
    double precision h4aL(8*maxnslay ),h4aN( 8*maxnslay )
    double precision h5ax(8*maxnslay ),h5ay( 8*maxnslay ),h5az( 8*maxnslay )
    double precision h6aL(8*maxnslay ),h6aN( 8*maxnslay )
    double precision h3x(8*maxnslay ),h3y( 8*maxnslay ),h3z( 8*maxnslay )
    double precision h4L(8*maxnslay ),h4N( 8*maxnslay )
    double precision h5x(8*maxnslay ),h5y( 8*maxnslay ),h5z( 8*maxnslay )
    double precision h6L(8*maxnslay ),h6N( 8*maxnslay )
    double precision h7x(8*maxnslay ),h7y( 8*maxnslay ),h7z( 8*maxnslay )
    double precision h8L(8*maxnslay ),h8N( 8*maxnslay )
    double precision h3mx(-2:1,2*(maxnslay+maxnzone) )
    double precision h3my(-2:1,2*(maxnslay+maxnzone) )
    double precision h3mz(-2:1,2*(maxnslay+maxnzone) )
    double precision h5mx(-1:2,2*(maxnslay+maxnzone) )
    double precision h5my(-1:2,2*(maxnslay+maxnzone) )
    double precision h5mz(-1:2,2*(maxnslay+maxnzone) )
    double precision h4m1L(-1:2,2*(maxnslay+maxnzone) )
    double precision h4m1N(-1:2,2*(maxnslay+maxnzone) )
    double precision h4m2L(-2:1,2*(maxnslay+maxnzone) )
    double precision h4m2N(-2:1,2*(maxnslay+maxnzone) )
    double precision h6m1L(-1:2,2*(maxnslay+maxnzone) )
    double precision h6m1N(-1:2,2*(maxnslay+maxnzone) )
    double precision h6m2L(-2:1,2*(maxnslay+maxnzone) )
    double precision h6m2N(-2:1,2*(maxnslay+maxnzone) )
    double precision p1(8*maxnllay ),p2( 8*maxnllay ),p3( 8*maxnllay )
    complex(dp) g(2*(maxnslay+1) + (maxnllay+1) )
    complex(dp) d((maxnslay+1) + (maxnllay+1) )
    !c variable for the file
    character*80 output(maxnr)
    !c variable for the stack point
    integer isp(maxnzone)
    integer issp(maxnzone)
    integer ilsp(maxnzone),jssp(maxnzone)
    integer jsp(maxnzone)
    integer ksp(maxnzone),lsp(maxnzone)
    integer isdr,jsdr,ildr
    ! variables for the gridding
    integer jjdr(maxnzone),kkdr(maxnzone)
    integer jdr,kdr
    double precision vmin(maxnzone),gridpar(maxnzone),dzpar(maxnzone)
    ! variables for l cut off
    complex(dp) tmpc(2*(maxnslay+1) + (maxnllay+1))
    integer sufzone,ismall,kc,lsuf,llog
    double precision maxamp,ratc,ratl,re
    ! variables for the numerical integration
    complex(dp) anum(4,4,10),bnum(4,4,10)
    ! other variables
    integer i,j,ii,nn,lda,ir,ier,itmp,jtmp,mtmp,kkdr0,nn0
    integer ll(12),lli(12),llj(12)
    double precision eps,work(8*maxnslay),l2,lsq
    complex(dp) z( 2*(maxnslay+1) + (maxnllay+1) )
    complex(dp) w( 2*(maxnslay+1) + (maxnllay+1) )
    complex(dp) cwork( 2*(16*maxnslay + 4*maxnllay) )
    integer ltmp(2),iimax

    data lda/ 4 /
    data eps/ -1.d0 /
    complex(dp), intent(out) :: outputu(3,nr,imin:imax)

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! *************** Inputting and computing the parameters ***************
! --- inputting parameter ---
    ! --- computing the required parameters ---
    ! counting of the nsl and nll
    call calnl( nzone,vsv,iphase,nsl,nll )
    ! computing and checking the parameters
    rmin = vrmin(1)
    rmax = vrmax(nzone)
    ndc = nzone - 1

    if ( r0<rmin .or. r0>rmax ) stop 'Location of the source is improper.'

    iimax = imax

    if( (rmax-r0)<shallowdepth) then ! option for shallow events
        ! computing of the number and the location of grid points
        iimax = int(tlen * 2.d0)
        call calgrid( nzone,vrmin,vrmax,vpv,vsv,rmin,rmax,iimax,1,tlen, vmin,gridpar,dzpar )
        call calra(inlayer,jnlayer,jnslay,jnllay,dzpar,nzone,vrmin,vrmax,iphase,rmin,nslay,nllay,nlayer,ra,re )
        ! --- checking the parameter
        if ( inlayer > maxnlay ) stop 'The number of grid points is too large.'
        if ( nslay > maxnslay ) stop 'The number of the grid points in the solid is too large.'
        if ( nllay > maxnllay ) stop 'The number of the grid points in the liquid is too large.'
        if ( jnlayer > 2*maxnlay ) stop 'The number of the total grid points is too large.'
        if ( ( jnslay > 2*maxnslay ).or.( jnllay>2*maxnllay ) ) stop 'The number of the total grid points is too large.'
        ! computing the stack points
        call calsp(ndc,nsl,nll,iphase,nlayer,nllay,&
                isp,jsp,ksp,issp,ilsp,lsp,jssp,isdr,jsdr,ildr,jdr,kdr )
        ! computing the source location
        call calspo(vrmax,iphase,inlayer,r0,rmin,rmax,ra,isp,spo,spn )
        ! ******************* Computing the matrix elements *******************

    ! computing the structure grid points
    call calstg( nzone,rrho,vpv,vph,vsv,vsh,eta,nlayer,ra,rmax,&
                vnp,vra,rho,kappa,ecKx,ecKy,ecKz,mu,ecL,ecN,r0,spn,ecC0,ecF0,ecL0 )

    rhoinv(1:vnp)=1.d0/rho(1:vnp)
    kappainv(1:vnp)=1.d0/kappa(1:vnp)
    isl = 0
    ill = 0
    do i=1,ndc+1
        if ( iphase(i)==1 ) then
            isl = isl + 1
            itmp = isdr+issp(isl)
            call calmatc( nlayer(i),vnp,vra,rho,2,0,0,ra(isp(i)), t(itmp) )
            call caltl( nlayer(i),vnp,vra,rho,ra(isp(i)),work(itmp) )
            t(itmp:itmp+4*nlayer(i)-1)=(t(itmp:itmp+4*nlayer(i)-1)+work(itmp:itmp+4*nlayer(i)-1))/2d0
            call calmatc( nlayer(i),vnp,vra,ecKx,0,0,0,ra(isp(i)),h1x(itmp) )
            call calhl( nlayer(i),vnp,vra,ecKx,ra(isp(i)),work(itmp) )
            h1x(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h1x(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecKy,0,0,0,ra(isp(i)),h1y(itmp) )
            call calhl( nlayer(i),vnp,vra,ecKy,ra(isp(i)),work(itmp) )
            h1y(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h1y(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecKz,0,0,0,ra(isp(i)),h1z(itmp) )
            call calhl( nlayer(i),vnp,vra,ecKz,ra(isp(i)),work(itmp) )
            h1z(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h1z(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecL,0,0,0,ra(isp(i)),h2L(itmp) )
            call calhl( nlayer(i),vnp,vra,ecL,ra(isp(i)),work(itmp) )
            h2L(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h2L(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecN,0,0,0,ra(isp(i)),h2N(itmp) )
            call calhl( nlayer(i),vnp,vra,ecN,ra(isp(i)),work(itmp) )
            h2N(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h2N(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecKx,1,0,1,ra(isp(i)),h5ax(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKy,1,0,1,ra(isp(i)),h5ay(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKz,1,0,1,ra(isp(i)),h5az(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecL,1,0,1,ra(isp(i)),h6aL(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecN,1,0,1,ra(isp(i)),h6aN(itmp) )
            call mtrnp( nlayer(i),h5ax(itmp),h3ax(itmp) )
            call mtrnp( nlayer(i),h5ay(itmp),h3ay(itmp) )
            call mtrnp( nlayer(i),h5az(itmp),h3az(itmp) )
            call mtrnp( nlayer(i),h6aL(itmp),h4aL(itmp) )
            call mtrnp( nlayer(i),h6aN(itmp),h4aN(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKx,2,1,1,ra(isp(i)), h7x(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKy,2,1,1,ra(isp(i)), h7y(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKz,2,1,1,ra(isp(i)), h7z(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecL,2,1,1,ra(isp(i)), h8L(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecN,2,1,1,ra(isp(i)), h8N(itmp) )
        else
            ill = ill + 1
            itmp = ildr+ilsp(ill)
            call calmatc( nlayer(i),vnp,vra,rhoinv,2,1,1,ra(isp(i)),p1(itmp) )
            call calmatc( nlayer(i),vnp,vra,rhoinv,0,0,0,ra(isp(i)),p2(itmp) )
            call calhl( nlayer(i),vnp,vra,rhoinv,ra(isp(i)),work(itmp) )
            p2(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+p2(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,kappainv,2,0,0,ra(isp(i)),p3(itmp) )
            call caltl( nlayer(i),vnp,vra,kappainv,ra(isp(i)),work(itmp) )
            p3(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+p3(itmp:itmp+4*nlayer(i)-1))/2
        endif
    enddo
 !  Computing the modified operator of the 1st derivative
    call caltstg( nzone,rrho,vpv,vph,vsv,vsh,eta,nlayer,ra,rmax,vra,kappa,ecKx,ecKy,ecKz,mu,ecL,ecN )
    isl = 0
    do i=1,ndc+1
        if ( iphase(i)==1 ) then
            isl = isl + 1
            itmp = isdr+issp(isl)
            jtmp = isp(i)+i-1
            call calh5( nlayer(i),vra(jtmp),ecKx(jtmp),ra(isp(i)),work(itmp) )
            h5x(itmp:itmp+4*nlayer(i)-1)= h5ax(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call calh5( nlayer(i),vra(jtmp),ecKy(jtmp),ra(isp(i)),work(itmp) )
            h5y(itmp:itmp+4*nlayer(i)-1)= h5ay(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call calh5( nlayer(i),vra(jtmp),ecKz(jtmp),ra(isp(i)),work(itmp) )
            h5z(itmp:itmp+4*nlayer(i)-1)= h5az(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call calh5( nlayer(i),vra(jtmp),ecL(jtmp),ra(isp(i)),work(itmp) )
            h6L(itmp:itmp+4*nlayer(i)-1)= h6aL(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call calh5( nlayer(i),vra(jtmp),ecN(jtmp),ra(isp(i)),work(itmp) )
            h6N(itmp:itmp+4*nlayer(i)-1)= h6aN(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call mtrnp( nlayer(i),h5x(itmp),h3x(itmp) )
            call mtrnp( nlayer(i),h5y(itmp),h3y(itmp) )
            call mtrnp( nlayer(i),h5z(itmp),h3z(itmp) )
            call mtrnp( nlayer(i),h6L(itmp),h4L(itmp) )
            call mtrnp( nlayer(i),h6N(itmp),h4N(itmp) )
            itmp = jsdr+jssp(isl)
            call calhm1( nlayer(i),vra(jtmp),ecKx(jtmp),ra(isp(i)),h5mx(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecKy(jtmp),ra(isp(i)),h5my(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecKz(jtmp),ra(isp(i)),h5mz(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecL(jtmp),ra(isp(i)),h6m1L(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecN(jtmp),ra(isp(i)),h6m1N(-1,itmp) )
            call calhm2( nlayer(i),vra(jtmp),ecL(jtmp),ra(isp(i)),h6m2L(-2,itmp) )
            call calhm2( nlayer(i),vra(jtmp),ecN(jtmp),ra(isp(i)),h6m2N(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h5mx(-1,itmp),h3mx(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h5my(-1,itmp),h3my(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h5mz(-1,itmp),h3mz(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h6m1L(-1,itmp),h4m2L(-2,itmp))
            call mtrnp2( nlayer(i),1,2,h6m1N(-1,itmp),h4m2N(-2,itmp))
            call mtrnp2( nlayer(i),2,1,h6m2L(-2,itmp),h4m1L(-1,itmp))
            call mtrnp2( nlayer(i),2,1,h6m2N(-2,itmp),h4m1N(-1,itmp))
        endif
    enddo

    do ii=1,2              ! omega-loop
        if(ii==1) then
            if(imin==0) then
                i=1
            else
                i=imin
            endif
        endif
        if(ii==2) i=imax
        if ( i/=0 ) then
            omega = 2.d0 * pi * dble(i) / tlen
            call callsuf(omega,nzone,vrmax,vsv,lsuf)
            call calcoef( nzone,omega,qmu,qkappa,coef1,coef2,coef )
            mtmp = isp(spn) + int(spo)
            if ( spo==int(spo) ) mtmp = mtmp - 1
                call calabnum( omega,omegai,rmax,rrho(1,spn),vpv(1,spn),vph(1,spn),&
                              vsv(1,spn),vsh(1,spn),eta(1,spn),ra(mtmp),r0,coef1(spn),coef2(spn),anum(1,1,1),bnum(1,1,1) )
                !c computing the matrix elements independent of l
                isl = 0
                ill = 0
                do j=1,ndc+1
                    if ( iphase(j)==1 ) then
                        isl = isl + 1
                        itmp = isdr+issp(isl)
                        jtmp = jdr+jsp(j)
                        mtmp = kdr+ksp(j)
                        call cala0( nlayer(j),omega,omegai,t(itmp),h1x(itmp), &
                                            h2L(itmp), h2N(itmp),h3ay(itmp),&
                                            h4aL(itmp),h4aN(itmp),h5ay(itmp),&
                                            h6aL(itmp),h6aN(itmp),h7y(itmp),h7z(itmp),&
                                            h8L(itmp), h8N(itmp),coef1(j),coef2(j),cwork(jtmp) )
                        call overlapa( nlayer(j),cwork(jtmp),a0(1,mtmp) )
                        call cala1( nlayer(j),h1x(itmp),&
                                            h2L(itmp),h2N(itmp),h3y(itmp),&
                                            h4L(itmp),h4N(itmp),h5y(itmp),&
                                            h6L(itmp),h6N(itmp),coef1(j),coef2(j),cwork(jtmp) )
                        call overlapa( nlayer(j),cwork(jtmp),a1(1,mtmp) )
                        call cala2(nlayer(j),h1x(itmp),h2L(itmp),h2N(itmp),coef1(j),coef2(j),cwork(jtmp))
                        call overlapa( nlayer(j),cwork(jtmp),a2(1,mtmp) )
                        jtmp = jsdr+jssp(isl)
                        call calhml( nlayer(j),coef1(j),coef2(j),&
                             h3my(-2,jtmp),h5my(-1,jtmp),h4m1L(-1,jtmp),h4m2N(-2,jtmp),&
                             h6m1N(-1,jtmp),h6m2L(-2,jtmp),a1(1,mtmp) )
                    else
                        ill = ill + 1
                        itmp = ildr+ilsp(ill)
                        jtmp = jdr+jsp(j)
                        mtmp = kdr+ksp(j)
                        call calb0( nlayer(j),omega,omegai,p1(itmp),p3(itmp),coef(j),cwork(jtmp))
                        call overlapb( nlayer(j),cwork(jtmp),a0(1,mtmp) )
                        call calb2( nlayer(j),omega,omegai,p2(itmp),cwork(jtmp))
                        call overlapb( nlayer(j),cwork(jtmp),a2(1,mtmp) )
                endif
            enddo

            maxamp = -1.0
            ismall = 0
            ltmp(ii) = maxlmax
            kc = 1
            do l=0,maxlmax   ! l-loop
                ! initialize
                tmpc(1:maxnlay+1) = dcmplx(0.d0)
                if ( ismall>20 ) then
                    if(ltmp(ii)>l) ltmp(ii) = l
                    exit
                endif
                l2 = dble(l)*dble(l+1)
                lsq = dsqrt( l2 )
                !    c computing the coefficient matrix elements
                 !   c --- renewing  mdr
                if (  mod(l,50)==0  ) then
                    !call calmdr( omega,l,nzone,vrmax,vmin,rmax,sufzone )
                    call calspdr( nzone,iphase,nlayer,jjdr,kkdr )
                    nn = kkdr(nzone) + 2 * nlayer(nzone) + 1
                endif
                ! computing the matrix elements
                call cala( ndc,iphase,nlayer,kkdr,kdr,ksp,&
                                    l2,lsq,nn,a0,a1,a2,a )
                ! computing the boundary condition elements
                call calbc( ndc,vrmax,iphase,kkdr,a )

                jtmp = kkdr(spn) + 2 * int(spo)
                mtmp = isp(spn) + int(spo)
                if ( spo==int(spo) ) then
                    jtmp = jtmp - 2
                    mtmp = mtmp - 1
                endif
                call calya( anum(1,1,1),bnum(1,1,1),l2,ra(mtmp),r0,ya,yb,yc,yd )
                do m=-2,2     ! m-loop
                    if ( iabs(m)<=iabs(l) ) then
                ! computing the excitation vector
                        g(1:nn)=0
                        call calg( l,m,coef1(spn),coef2(spn),lsq,&
                                               ecC0,ecF0,ecL0,ya,yb,yc,yd,&
                                               ra(mtmp),r0,mt,g(jtmp) )
                        if ( l==0 ) then
                            !c rearranging the matrix elements for l=0
                            call rea2( nn,a,g,c,d,nzone,iphase,kkdr,spn,kkdr0,nn0 )
                            !c computing the expansion coefficient
                            itmp=1
                            if ( rmin==0.d0 ) itmp=2
                            ns = kkdr0 + ( nint(spo) - 1 )
                            call dcsymbdl( c(1,itmp),1,nn0-itmp+1,1,eps,z(itmp),w(itmp),ll,lli,llj,ier )
                            call dcsbdlv( c(1,itmp),d(itmp),1,nn0-itmp+1,ns-itmp+1,z(itmp))
                        else
                            !c computing the expansion coefficient
                            itmp=1
                            if ( rmin==0.d0 ) itmp=3
                            ns = kkdr(spn) + 2 * ( nint(spo) - 1 )
                            if( mod(l,100)==0) then
                                if ( ( m==-2 ).or.( m==-l ) )&
                                 call dcsymbdl( a(1,itmp),3,nn-itmp+1,6,eps, z(itmp),w(itmp),ll,lli,llj,ier )

                                call dcsbdlv0( a(1,itmp),g(itmp),3,nn-itmp+1,z(itmp))
                                ! sum up c of the same l
                                tmpc(1:nn) = tmpc(1:nn) + g(1:nn)
                            else
                                if ( kc<3 ) kc = 3
                                itmp = kc
                                if ( ( m==-2 ).or.( m==-l ) )&
                                 call dcsymbdl( a(1,itmp),3,nn-itmp+1,6,eps,z(itmp),w(itmp),ll,lli,llj,ier )

                                call dcsbdlv( a(1,itmp),g(itmp),3,nn-itmp+1,ns-itmp+1,z(itmp))
                            endif
                            !c computing ampratio
                            call calamp( g(nn-1),l,lsuf,maxamp,ismall,ratl )

                            if( mod(l,100)==0) call calcutd(nzone,nlayer,tmpc,ratc,nn,iphase,ra,kkdr,kc)

!                                c computing the displacement
                        endif
                    endif
                enddo         ! m-loop
            enddo            ! l-loop
        endif
    enddo                  ! omega-loop
        iimax = dble(max(ltmp(1),ltmp(2))) * tlen / lmaxdivf
    endif                     ! option for shallow events

    call calgrid( nzone,vrmin,vrmax,vpv,vsv,rmin,rmax,iimax,1,tlen, vmin,gridpar,dzpar )
    call calra(inlayer,jnlayer,jnslay,jnllay,&
         dzpar,nzone,vrmin,vrmax,iphase,rmin,nslay,nllay,nlayer,ra,re )
    !c --- checking the parameter
    if ( inlayer>maxnlay ) stop 'The number of grid points is too large.'
    if ( nslay>maxnslay ) stop 'The number of the grid points in the solid is too large.'
    if ( nllay>maxnllay ) stop 'The number of the grid points in the liquid is too large.'
    if ( jnlayer>2*maxnlay ) stop 'The number of the total grid points is too large.'
    if ( ( jnslay>2*maxnslay ).or.( jnllay>2*maxnllay ) ) stop 'The number of the total grid points is too large.'
    !c computing the stack points
    call calsp(ndc,nsl,nll,iphase,nlayer,nllay,&
         isp,jsp,ksp,issp,ilsp,lsp,jssp,isdr,jsdr,ildr,jdr,kdr )
!    c computing the source location
    call calspo(vrmax,iphase,inlayer,r0,rmin,rmax,ra,isp,spo,spn )

    !c ******************* Computing the matrix elements *******************
   !    c computing the structure grid points
    call calstg(nzone,rrho,vpv,vph,vsv,vsh,eta,nlayer,ra,rmax,&
         vnp,vra,rho,kappa,ecKx,ecKy,ecKz,mu,ecL,ecN,r0,spn,ecC0,ecF0,ecL0 )
    !call calinv( vnp,rho,kappa,rhoinv,kappainv )
    rhoinv(1:vnp) = 1.d0 / rho(1:vnp)
    kappainv(1:vnp) = 1.d0 / kappa(1:vnp)
    isl = 0
    ill = 0
    do i=1,ndc+1
        if ( iphase(i)==1 ) then
            isl = isl + 1
            itmp = isdr+issp(isl)
            call calmatc( nlayer(i),vnp,vra,rho,2,0,0,ra(isp(i)), t(itmp) )
            call caltl( nlayer(i),vnp,vra,rho,ra(isp(i)),work(itmp) )
            t(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+t(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecKx,0,0,0,ra(isp(i)),h1x(itmp) )
            call calhl( nlayer(i),vnp,vra,ecKx,ra(isp(i)),work(itmp) )
            h1x(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h1x(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecKy,0,0,0,ra(isp(i)),h1y(itmp) )
            call calhl( nlayer(i),vnp,vra,ecKy,ra(isp(i)),work(itmp) )
            h1y(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h1y(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecKz,0,0,0,ra(isp(i)),h1z(itmp) )
            call calhl( nlayer(i),vnp,vra,ecKz,ra(isp(i)),work(itmp) )
            h1z(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h1z(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecL,0,0,0,ra(isp(i)),h2L(itmp) )
            call calhl( nlayer(i),vnp,vra,ecL,ra(isp(i)),work(itmp) )
            h2L(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h2L(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecN,0,0,0,ra(isp(i)),h2N(itmp) )
            call calhl( nlayer(i),vnp,vra,ecN,ra(isp(i)),work(itmp) )
            h2N(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+h2N(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,ecKx,1,0,1,ra(isp(i)),h5ax(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKy,1,0,1,ra(isp(i)),h5ay(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKz,1,0,1,ra(isp(i)),h5az(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecL,1,0,1,ra(isp(i)),h6aL(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecN,1,0,1,ra(isp(i)),h6aN(itmp) )
            call mtrnp( nlayer(i),h5ax(itmp),h3ax(itmp) )
            call mtrnp( nlayer(i),h5ay(itmp),h3ay(itmp) )
            call mtrnp( nlayer(i),h5az(itmp),h3az(itmp) )
            call mtrnp( nlayer(i),h6aL(itmp),h4aL(itmp) )
            call mtrnp( nlayer(i),h6aN(itmp),h4aN(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKx,2,1,1,ra(isp(i)), h7x(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKy,2,1,1,ra(isp(i)), h7y(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecKz,2,1,1,ra(isp(i)), h7z(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecL,2,1,1,ra(isp(i)), h8L(itmp) )
            call calmatc( nlayer(i),vnp,vra,ecN,2,1,1,ra(isp(i)), h8N(itmp) )
        else
            ill = ill + 1
            itmp = ildr+ilsp(ill)
            call calmatc( nlayer(i),vnp,vra,rhoinv,2,1,1,ra(isp(i)),p1(itmp) )
            call calmatc( nlayer(i),vnp,vra,rhoinv,0,0,0,ra(isp(i)),p2(itmp) )
            call calhl( nlayer(i),vnp,vra,rhoinv,ra(isp(i)),work(itmp) )
            p2(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+p2(itmp:itmp+4*nlayer(i)-1))/2
            call calmatc( nlayer(i),vnp,vra,kappainv,2,0,0,ra(isp(i)),p3(itmp) )
            call caltl( nlayer(i),vnp,vra,kappainv,ra(isp(i)),work(itmp) )
            p3(itmp:itmp+4*nlayer(i)-1)=(work(itmp:itmp+4*nlayer(i)-1)+p3(itmp:itmp+4*nlayer(i)-1))/2
        endif
    enddo
    !c Computing the modified operator of the 1st derivative
    call caltstg( nzone,rrho,vpv,vph,vsv,vsh,eta,nlayer,ra,rmax,vra,kappa,ecKx,ecKy,ecKz,mu,ecL,ecN )
    isl = 0
    do i=1,ndc+1
        if ( iphase(i)==1 ) then
            isl = isl + 1
!           !call submat( nlayer(i),h6aN(itmp),work(itmp),h6N(itmp) )

            itmp = isdr+issp(isl)
            jtmp = isp(i)+i-1
            call calh5( nlayer(i),vra(jtmp),ecKx(jtmp),ra(isp(i)),work(itmp) )
 !           call submat( nlayer(i),h5ax(itmp),work(itmp),h5x(itmp) )
       h5x(itmp:itmp+4*nlayer(i)-1)= h5ax(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call calh5( nlayer(i),vra(jtmp),ecKy(jtmp),ra(isp(i)),work(itmp) )
!            call submat( nlayer(i),h5ay(itmp),work(itmp),h5y(itmp) )
       h5y(itmp:itmp+4*nlayer(i)-1)= h5ay(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call calh5( nlayer(i),vra(jtmp),ecKz(jtmp),ra(isp(i)),work(itmp) )
!            call submat( nlayer(i),h5az(itmp),work(itmp),h5z(itmp) )
        h5z(itmp:itmp+4*nlayer(i)-1)= h5az(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
            call calh5( nlayer(i),vra(jtmp),ecL(jtmp),ra(isp(i)),work(itmp) )
!            call submat( nlayer(i),h6aL(itmp),work(itmp),h6L(itmp) )
             h6L(itmp:itmp+4*nlayer(i)-1)= h6aL(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)

            call calh5( nlayer(i),vra(jtmp),ecN(jtmp),ra(isp(i)),work(itmp) )
!            call submat( nlayer(i),h6aN(itmp),work(itmp),h6N(itmp) )
            h6N(itmp:itmp+4*nlayer(i)-1)= h6aN(itmp:itmp+4*nlayer(i)-1)-work(itmp:itmp+4*nlayer(i)-1)
           call mtrnp( nlayer(i),h5x(itmp),h3x(itmp) )
            call mtrnp( nlayer(i),h5y(itmp),h3y(itmp) )
            call mtrnp( nlayer(i),h5z(itmp),h3z(itmp) )
            call mtrnp( nlayer(i),h6L(itmp),h4L(itmp) )
            call mtrnp( nlayer(i),h6N(itmp),h4N(itmp) )
            itmp = jsdr+jssp(isl)
            call calhm1( nlayer(i),vra(jtmp),ecKx(jtmp),ra(isp(i)),h5mx(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecKy(jtmp),ra(isp(i)),h5my(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecKz(jtmp),ra(isp(i)),h5mz(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecL(jtmp),ra(isp(i)),h6m1L(-1,itmp) )
            call calhm1( nlayer(i),vra(jtmp),ecN(jtmp),ra(isp(i)),h6m1N(-1,itmp) )
            call calhm2( nlayer(i),vra(jtmp),ecL(jtmp),ra(isp(i)),h6m2L(-2,itmp) )
            call calhm2( nlayer(i),vra(jtmp),ecN(jtmp),ra(isp(i)),h6m2N(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h5mx(-1,itmp),h3mx(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h5my(-1,itmp),h3my(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h5mz(-1,itmp),h3mz(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h6m1L(-1,itmp),h4m2L(-2,itmp) )
            call mtrnp2( nlayer(i),1,2,h6m1N(-1,itmp),h4m2N(-2,itmp) )
            call mtrnp2( nlayer(i),2,1,h6m2L(-2,itmp),h4m1L(-1,itmp) )
            call mtrnp2( nlayer(i),2,1,h6m2N(-2,itmp),h4m1N(-1,itmp) )
        endif
    enddo
!    c ******************** Computing the displacement *********************

    llog = 0
    do i=imin,imax            ! omega-loop
        u(1:3,1:nr)=0
        if ( i/=0 ) then
            omega = 2.d0 * pi * i / tlen
            call callsuf(omega,nzone,vrmax,vsv,lsuf)

            plm(1:3,0:3,1:nr)=0
            call calcoef( nzone,omega,qmu,qkappa,coef1,coef2,coef )
            mtmp = isp(spn) + int(spo)
            if ( spo==int(spo) ) mtmp = mtmp - 1
            call calabnum( omega,omegai,rmax,rrho(1,spn),vpv(1,spn),vph(1,spn),vsv(1,spn),vsh(1,spn),&
             eta(1,spn),ra(mtmp),r0,coef1(spn),coef2(spn),anum(1,1,1),bnum(1,1,1) )
!            c computing the matrix elements independent of l
            isl = 0
            ill = 0
            do j=1,ndc+1
                if ( iphase(j)==1 ) then
                    isl = isl + 1
                    itmp = isdr+issp(isl)
                    jtmp = jdr+jsp(j)
                    mtmp = kdr+ksp(j)
                    call cala0( nlayer(j),omega,omegai,t(itmp),h1x(itmp),&
                     h2L(itmp),h2N(itmp),h3ay(itmp),&
                     h4aL(itmp),h4aN(itmp),h5ay(itmp),&
                     h6aL(itmp),h6aN(itmp),h7y(itmp),h7z(itmp),&
                     h8L(itmp),h8N(itmp),coef1(j),coef2(j),cwork(jtmp) )
                    call overlapa( nlayer(j),cwork(jtmp),a0(1,mtmp))
                    call cala1( nlayer(j),h1x(itmp),&
                     h2L(itmp),h2N(itmp),h3y(itmp),&
                     h4L(itmp),h4N(itmp),h5y(itmp),&
                     h6L(itmp),h6N(itmp),coef1(j),coef2(j),cwork(jtmp) )
                    call overlapa( nlayer(j),cwork(jtmp),a1(1,mtmp) )
                    call cala2( nlayer(j),h1x(itmp),h2L(itmp),h2N(itmp),coef1(j),coef2(j),cwork(jtmp))
                    call overlapa( nlayer(j),cwork(jtmp),a2(1,mtmp) )
                    jtmp = jsdr+jssp(isl)
                    call calhml( nlayer(j),coef1(j),coef2(j),&
                     h3my(-2,jtmp),h5my(-1,jtmp),&
                     h4m1L(-1,jtmp),h4m2N(-2,jtmp),h6m1N(-1,jtmp),h6m2L(-2,jtmp),a1(1,mtmp) )
                else
                    ill = ill + 1
                    itmp = ildr+ilsp(ill)
                    jtmp = jdr+jsp(j)
                    mtmp = kdr+ksp(j)
                    call calb0( nlayer(j),omega,omegai,p1(itmp),p3(itmp),coef(j),cwork(jtmp) )
                    call overlapb( nlayer(j),cwork(jtmp),a0(1,mtmp) )
                    call calb2( nlayer(j),omega,omegai,p2(itmp),cwork(jtmp))
                    call overlapb( nlayer(j),cwork(jtmp),a2(1,mtmp) )
                endif
            enddo
            maxamp = -1
            ismall = 0
            llog = maxlmax
            kc = 1
            do l=0,maxlmax      ! l-loop
                tmpc(1:maxnlay+1) = 0  ! initialize
                if ( ismall>20 ) then
                    if(llog>l) llog = l
                    exit
                endif
                l2 = dble(l*(l+1))
                lsq = dsqrt( l2 )
                !c computing the coefficient matrix elements
                !c --- renewing  mdr
                if (  mod(l,50)==0  ) then
                    call calspdr( nzone,iphase,nlayer,jjdr,kkdr )
                    nn = kkdr(nzone) + 2 * nlayer(nzone) + 1
                endif
                !c ***** Computing the trial function *****
                do ir=1,nr
                    call calbvec( l,theta(ir),phi(ir),plm(1,0,ir),bvec(1,-2,ir) )
                enddo
!              c computing the matrix elements
                call cala( ndc,iphase,nlayer,kkdr,kdr,ksp,l2,lsq,nn,a0,a1,a2,a )
!                c computing the boundary condition elements
                call calbc( ndc,vrmax,iphase,kkdr,a )

                jtmp = kkdr(spn) + 2 * int(spo)
                mtmp = isp(spn) + int(spo)
                if ( spo==int(spo) ) then
                    jtmp = jtmp - 2
                    mtmp = mtmp - 1
                endif
                call calya( anum(1,1,1),bnum(1,1,1),l2,ra(mtmp),r0,ya,yb,yc,yd )
                do m=-2,2        ! m-loop
                    if ( iabs(m)<=iabs(l) ) then
                        !c computing the excitation vector
                        g(1:nn)=0
                        call calg( l,m,coef1(spn),coef2(spn),lsq,ecC0,ecF0,ecL0,ya,yb,yc,yd,ra(mtmp),r0,mt,g(jtmp) )
                        if ( l==0 ) then
!                            c rearranging the matrix elements for l=0
                            call rea2( nn,a,g,c,d,nzone,iphase,kkdr,spn,kkdr0,nn0 )
                            !c computing the expansion coefficient
                            itmp=1
                            if ( rmin==0.d0 ) itmp=2
                            ns = kkdr0 + ( nint(spo) - 1 )
                            call dcsymbdl( c(1,itmp),1,nn0-itmp+1,1,eps,z(itmp),w(itmp),ll,lli,llj,ier )
                            call dcsbdlv( c(1,itmp),d(itmp),1,nn0-itmp+1,ns-itmp+1,z(itmp))
                            !c computing the displacement
                            u(:,1:nr)=d(nn0)*bvec(:,m,1:nr)
                        else
                            !c computing the expansion coefficient
                            itmp=1
                            if ( rmin==0.d0 ) itmp=3
                            ns = kkdr(spn) + 2 * ( nint(spo) - 1 )
                            if( mod(l,100)==0) then
                                if (  m==-2 .or. m==-l ) then
                                    call dcsymbdl( a(1,itmp),3,nn-itmp+1,6,eps,z(itmp),w(itmp),ll,lli,llj,ier )
                                endif
                                call dcsbdlv0( a(1,itmp),g(itmp),3,nn-itmp+1,z(itmp))
                                 ! sum up c of the same l
                                tmpc(1:nn) = tmpc(1:nn) + g(1:nn)
                            else
                                if ( kc<3 ) kc = 3
                                itmp = kc
                                if ( ( m==-2 ).or.( m==-l ) )&
                                 call dcsymbdl( a(1,itmp),3,nn-itmp+1,6,eps,z(itmp),w(itmp),ll,lli,llj,ier )
                                call dcsbdlv( a(1,itmp),g(itmp),3,nn-itmp+1,ns-itmp+1,z(itmp))
                            endif
                            !c computing ampratio
                            call calamp( g(nn-1),l,lsuf,maxamp,ismall,ratl )
                            if( mod(l,100)==0)&
                             call calcutd(nzone,nlayer,tmpc,ratc,nn,iphase,ra,kkdr,kc)

                            !c computing the displacement calu
                            u(1,1:nr) = u(1,1:nr) + g(nn-1) * bvec(1,m,1:nr)
                            u(2:3,1:nr) = u(2:3,1:nr) + g(nn) * bvec(2:3,m,1:nr) / lsq
                        endif
                    endif
                enddo            ! m-loop
            enddo               ! l-loop
        endif
        outputu (1:3,1:nr,i)=u(1:3,1:nr)
    enddo                   ! omega-loop

!c ************************** Files Handling **************************
    if (write_to_file) then
        write(*,*) "kakikomimasu"
        do ir=1,nr
            open(unit=1,file=trim(output(ir)),status='replace',form='unformatted',access='stream',convert='big_endian')
            write(1) tlen,np,1,3,omegai,lat(ir),lon(ir),eqlat,eqlon,r0

            do i= imin,imax
                write(1) i, dble(outputu(1,ir,i)), dimag(outputu(1,ir,i))
                write(1) dble(outputu(2,ir,i)), dimag(outputu(2,ir,i))
                write(1) dble(outputu(3,ir,i)), dimag(outputu(3,ir,i))
            enddo
            close(1)
        enddo
        write(*,*) "Ivalice looks to the horizon"
    endif

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    return
 end subroutine tipsv


 program main

   use parameters
   implicit none

   character(len=160) :: parameter_file

   integer np
   integer imin
   integer imax
   integer nzone
   integer nr
   real(dp) :: tlen
   real(dp) :: omegai
   real(dp) :: re
   real(dp) :: ratc
   real(dp) :: ratl
   real(dp) :: vrmin(maxnzone)
   real(dp) :: vrmax(maxnzone)
   real(dp) :: qmu(maxnzone),qkappa(maxnzone)
   real(dp) :: rho(4,maxnzone)
   real(dp) :: vpv(4,maxnzone),vph(4,maxnzone),vsv(4,maxnzone),vsh(4,maxnzone),eta(4,maxnzone)
   real(dp) :: r0
   real(dp) :: mt(3,3)
   real(dp) :: lat(maxnr)
   real(dp) :: lon(maxnr)
   real(dp) :: theta(maxnr)
   real(dp) :: phi(maxnr)
   real(dp) :: eqlat
   real(dp) :: eqlon
   character(len=80) :: output(maxnr)
   complex(dp), allocatable :: outputu(:,:,:)
   logical :: write_to_file = .true.

   ! read input parameters
   call get_command_argument(1, parameter_file)
   print*,parameter_file

   call pinput_tipsv(parameter_file, &
      re,ratc,ratl,tlen,np,omegai,imin,imax, &
      nzone,vrmin,vrmax,rho,vpv,vph,vsv,vsh,eta,qmu,qkappa, &
      r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output)

   allocate(outputu(3,nr,imin:imax))

   ! main loop
   write(*,*) 'Enter main loop'

   call tipsv(re,ratc,ratl,tlen,np,omegai,imin,imax, &
      nzone,vrmin,vrmax,rho,vpv,vph,vsv,vsh,eta,qmu,qkappa,&
      r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output,write_to_file,&
      outputu)
   write(*,*) 'Done!'
   write(*,*) outputu(3,1,20)


end program main

!----------------------------------------------------------
!                           TRIAL FUNCTION                             *
!----------------------------------------------------------
subroutine calbvec( l,theta,phi,plm,bvec )
!----------------------------------------------------------
! Evaluating the value of toroidal harmonics (fully normalized)
! at each station whose latitude and longitude are theta and phi.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: l,m,i
    double precision:: theta,phi,x,plm(3,0:3),fact,coef
    complex(dp):: bvec(3,-2:2),expimp

    x = dcos( theta )
    do m=0,min0(l,3)
        call calplm( l,m,x,plm(1,m) )
    enddo
    bvec(1,:)=0
    do m=0,min0(l,2)
        fact = 1.d0
        if ( m/=0 ) then
            do i=l-m+1,l+m
                fact = fact * dble(i)
            enddo
        endif
        coef = dsqrt( dble(2*l+1)/(4.d0*pi) / fact )
        expimp = cdexp( dcmplx( 0.d0, dble(m)*phi ) )
        bvec(2,m)  = dcmplx( 0.d0, dble(m) ) / dsin( theta )&
            * coef * plm(1,m) * expimp
        bvec(2,-m) = dconjg( bvec(2,m) )
        bvec(3,m) = - coef * ( dble(m) * x / dsin( theta ) * plm(1,m)&
            + plm(1,m+1) )* expimp
        bvec(3,-m) = dconjg( bvec(3,m) )
        if ( mod(m,2)==1 ) then
            bvec(2,-m) = - bvec(2,-m)
            bvec(3,-m) = - bvec(3,-m)
        endif
    enddo

    return
end

!----------------------------------------------------------
subroutine calplm( l,m,x,plm )
!----------------------------------------------------------
    implicit none
    integer:: l,m,i
    double precision:: x,plm(3),pmm,somx2,fact

    if ( m<0 .or. m>l .or. dabs(x)>1.d0 ) stop 'bad arguments'
    if ( l==m ) then
        pmm = 1.d0
        if ( m>0 ) then
            somx2 = dsqrt( (1.d0-x)*(1.d0+x) )
            fact = 1.d0
            do i=1,m
                pmm = -pmm * fact * somx2
                fact = fact + 2.d0
            enddo
        endif
        plm(2:3) = 0.d0
        plm(1) = pmm
    else
        plm(3) = plm(2)
        plm(2) = plm(1)
        if ( l==m+1 ) then
            plm(1) = x * dble(2*m+1) * plm(2)
        else
            plm(1) = ( x * dble(2*l-1) * plm(2)&
                - dble(l+m-1) * plm(3) ) / dble(l-m)
        endif
    endif
    return
end

module parameters
    integer, parameter :: dp = kind(1.d0) !selected_real_kind=12
    real(dp), parameter :: pi=4.d0*atan(1d0)

    integer, parameter :: maxnzone = 100
    integer, parameter :: maxnr = 1000
    integer, parameter :: maxlmax = 80000
    integer, parameter :: maxnlay = 88300
    integer, parameter :: maxnslay = 48840
    integer, parameter :: maxnllay = 32040
    integer, parameter :: ilog = 0
    real(dp), parameter :: lmaxdivf = 2.d4
    real(dp), parameter :: shallowdepth = 100.d0
    real(dp), parameter :: flattening = 1.d0 / 298.25d0
    ! specfem flattening is f = 1/299.8

end module parameters

subroutine pinput_tish(parameter_file, &
    re,ratc,ratl,tlen,np,omegai,imin,imax, &
    nzone,vrmin,vrmax,rho,vsv,vsh,qmu, &
    r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output)
!----------------------------------------------------------
! Parameter Input
!----------------------------------------------------------
    use parameters
    implicit none
    integer, parameter :: maxnline=2*maxnr+6*maxnzone+50
    character*160, intent(in) :: parameter_file
    integer, intent(out):: np,imin,imax,nzone,nr
    real(dp),intent(out) :: tlen,omegai,re,ratc,ratl
    real(dp),dimension(maxnzone), intent(out):: vrmin,vrmax,qmu
    real(dp),dimension(4,maxnzone), intent(out):: rho,vsv,vsh
    real(dp),dimension(maxnr), intent(out) :: theta,phi,lat,lon
    real(dp),intent(out) :: eqlat,eqlon,r0,mt(3,3)
    character*80,dimension(maxnr),intent(out) :: output
    real(dp):: stlat,stlon,eqlattmp
    integer i,linenum,io
    logical:: file_exists
    character*80:: buffer
    character*80,dimension(maxnline) :: lines

    inquire(file=parameter_file,exist=file_exists)
    if (.not. file_exists) stop 'parameter file does not exist.'

    linenum=0
    open(unit=1,file=parameter_file,status='old',action='read')
    do
        read(1,'(a)', iostat=io) buffer
        buffer = adjustl(buffer)
        if(buffer(1:1)=='c' .or. buffer(1:1)=='c' .or. buffer(1:1)=='!') cycle
        if(io/=0) exit
        linenum=linenum+1
        lines(linenum) = buffer
    enddo
    close(1)

    read(lines(1),*) tlen,np
    read(lines(2),*) re ! relative error (vertical grid)
    read(lines(3),*) ratc ! ampratio (vertical grid cut-off)
    read(lines(4),*) ratl ! ampratio (for l-cutoff)
    read(lines(5),*) omegai ! omegai
    omegai = -dlog(omegai)/tlen
    read(lines(6),*) imin,imax
    read(lines(7),*) nzone
    if (nzone > maxnzone) stop 'nzone is too large. (pinput)'

! structure
    do i=1,nzone
        read(lines(7+3*(i-1)+1),*) vrmin(i),vrmax(i),rho(1:4,i)
        read(lines(7+3*(i-1)+2),*) vsv(1:4,i)
        read(lines(7+3*(i-1)+3),*) vsh(1:4,i),qmu(i)
    enddo
! source parameter
    read(lines(3*nzone+8),*) r0,eqlat,eqlon
    eqlattmp=eqlat
    call translat(eqlattmp,eqlattmp)
    read(lines(3*nzone+9),*) mt(1,1:3), mt(2,2:3), mt(3,3)
    read(lines(3*nzone+10),*) nr
! station
    if (nr > maxnr) stop 'nr is too large. (pinput)'
    do i=1,nr
        read(lines(3*nzone+10+i), *) lat(i),lon(i)
        stlat = lat(i)
        stlon = lon(i)
        call translat(stlat,stlat)
        call calthetaphi(eqlattmp,eqlon,stlat,stlon,theta(i),phi(i))
    enddo
    theta(1:nr) = theta(1:nr) / 180 * pi
    phi(1:nr) = phi(1:nr) / 180 * pi
    do i=1,nr
        read(lines(3*nzone+10+nr+i),'(a)') output(i)
        output(i)=trim(output(i))
    enddo
    return
end

!----------------------------------------------------------
subroutine calthetaphi(ievla,ievlo,istla,istlo,theta,phi)
!----------------------------------------------------------
    use parameters
    implicit none
    double precision,intent(in):: ievla,ievlo,istla,istlo
    double precision:: evla,evlo,stla,stlo
    double precision,intent(out):: theta,phi
    double precision:: gcarc,az
    double precision:: tc,ts

    ! transformation to spherical coordinates

    evla = 90 - ievla
    stla = 90 - istla

    evla = evla / 180 * pi
    evlo = ievlo / 180 * pi
    stla = stla / 180 * pi
    stlo = istlo / 180 * pi

    gcarc=acos(cos(evla)*cos(stla)+sin(evla)*sin(stla)*cos(evlo-stlo))

    tc=(cos(stla)*sin(evla)-sin(stla)*cos(evla)*cos(stlo-evlo))/sin(gcarc)
    ts = sin(stla) * sin(stlo - evlo) / sin(gcarc)

    az = acos(tc)
    if( ts < 0 ) az = - az

    az = az * 180 / pi

    gcarc = gcarc * 180 / pi

    theta = gcarc
    phi   = 180 - az
    return
end

!----------------------------------------------------------
subroutine translat(geodetic,geocentric)
!----------------------------------------------------------
    use parameters
    implicit none
    double precision,intent(in):: geodetic
    double precision,intent(out):: geocentric
    double precision:: tmp_geodetic
    integer:: flag

    flag = 0
    tmp_geodetic=geodetic
    if(90<geodetic ) then
        tmp_geodetic = 180 - geodetic
        flag = 1
    endif

    tmp_geodetic = tmp_geodetic / 180 * pi
    geocentric = datan((1-flattening)*(1-flattening)*dtan(tmp_geodetic))
    geocentric = geocentric * 180 / pi
    if(flag == 1) geocentric = 180 - geocentric

    return
end

!----------------------------------------------------------
subroutine calgrid( nzone,vrmin,vrmax,vs,rmin,rmax,&
    imax,lmin,tlen,vmin,gridpar,dzpar )
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nzone,imax,lmin
    double precision:: vrmin(*),vrmax(*),vs(4,*)
    double precision:: rmin,rmax,tlen,vmin(*),gridpar(*),dzpar(*)
    integer:: izone,j
    double precision:: coef1,coef2,v(4),vs1,vs2,rh,omega,amax,gtmp

    do izone=1,nzone
        ! computing the S-velocity at each zone
        v(:) = vs(:,izone)
        vs1 = 0
        vs2 = 0
        do j=1,4
            if ( j==1 ) then
                coef1 = 1
            else
                coef1 = coef1 * ( vrmin(izone) / rmax )
            endif
            if ( j==1 ) then
                coef2 = 1
            else
                coef2 = coef2 * ( vrmax(izone) / rmax )
            endif
            vs1 = vs1 + v(j) * coef1
            vs2 = vs2 + v(j) * coef2
        enddo
        ! computing rh
        rh = vrmax(izone) - vrmin(izone)
        ! computing omega,amax
        omega = 2 * pi * imax / tlen
        if ( vs1>=vs2 ) then
            vmin(izone) = vs2
        else
            vmin(izone) = vs1
        endif
        amax = vrmax(izone)
        gtmp = ( omega * omega ) / ( vmin(izone) * vmin(izone) ) &
            - ( (lmin+0.5) * (lmin+0.5) ) / ( amax * amax )
        if ( gtmp>0 ) then
            dzpar(izone)   = dsqrt( 1/gtmp )
            gridpar(izone) = rh / dzpar(izone)
        else
            dzpar(izone)   = 0
            gridpar(izone) = 0
        endif
    enddo
    ! rearangement of gridpar
    gtmp = sum(gridpar(1:nzone))
    do izone=1,nzone
        if ( gridpar(izone)>0 ) then
            gridpar(izone) = gridpar(izone) / gtmp
        else
            rh = vrmax(izone) - vrmin(izone)
            gridpar(izone) = rh / ( rmax - rmin ) * 0.1
        endif
    enddo
    ! re-rearangement of gridpar
    gtmp = sum(gridpar(1:nzone))
    gridpar(1:nzone)=gridpar(1:nzone)/gtmp

    return
end

!----------------------------------------------------------
subroutine calra(nlayer,gridpar,dzpar,nzone,vrmin,vrmax,&
    rmin,rmax,nnl,ra,re )
!----------------------------------------------------------
!c Computing the number and the location of grid points.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    integer:: nzone,nnl(maxnzone)
    double precision:: gridpar(*),dzpar(*),vrmin(*),vrmax(*),rmin,rmax
    double precision:: ra(maxnlay+maxnzone+1)
    integer:: izone,itmp,i,ntmp
    double precision:: rh,re

    ! Initializing the data
    ra(1:maxnlay+maxnzone+1) = 0
    nnl(1:nzone) = 0

    ! computing the number and the location of the grid points
    ra(1) = rmin
    itmp = 1
    do  izone=1,nzone
        rh = vrmax(izone) - vrmin(izone)
        if(dzpar(izone)==0) then
            ntmp = 1
        else
            ntmp = int( sqrt(3.3 / re ) * rh / dzpar(izone) / 2 / pi  / 0.7 + 1 )
        endif
        ! ntmp (see Geller & Takeuchi 1995 6.2)
        nnl(izone) = ntmp
        if ( nnl(izone)<5 ) nnl(izone)=5
        do i=1,nnl(izone)
            itmp = itmp + 1
            ra(itmp) = vrmin(izone) + rh * i / nnl(izone)
        enddo
    enddo

    ! recouting the total number of grid points
    nlayer =sum(nnl(1:nzone))

    return
end

!----------------------------------------------------------
subroutine calra0( nlayer,nzone,vrmin,vrmax,nnl,ra )
!----------------------------------------------------------
! Computing the number and the location of grid points.
!----------------------------------------------------------
    implicit none
    integer:: nlayer
    integer,intent(in):: nzone
    integer,intent(out):: nnl(nzone)
    double precision,intent(in):: vrmin(*),vrmax(*)
    double precision,intent(out):: ra(*)
    integer:: izone,itmp,i
    double precision:: rmin,rmax,rh

    ! computing the number and the location of the grid points
    rmin = vrmin(1)
    rmax = vrmax(nzone)
    ra(1) = rmin
    itmp = 1
    do izone=1,nzone
        rh = vrmax(izone) - vrmin(izone)
        nnl(izone) = int( nlayer * rh / ( rmax - rmin ) ) + 1
        do i=1,nnl(izone)
            itmp = itmp + 1
            ra(itmp) = vrmin(izone) + rh * i / dble( nnl(izone) )
        enddo
    enddo
    ! recouting the total number of grid points
    nlayer = sum(nnl)

    return
end

!----------------------------------------------------------
subroutine calgra( isp,ra,r0,spn,spo,gra )
!----------------------------------------------------------
    implicit none
    integer,intent(in):: isp(*),spn
    integer:: itmp
    double precision,intent(in):: ra(*),r0,spo
    double precision,intent(out):: gra(3)

    itmp = isp(spn) + dint( spo )
    gra(1) = ra(itmp)
    gra(2) = r0
    gra(3) = ra(itmp+1)
    return
end

!----------------------------------------------------------
subroutine calsp( ndc,nlayer,isp,jsp )
!----------------------------------------------------------
! Computing the stack points.
!----------------------------------------------------------
    implicit none
    integer,intent(in):: ndc,nlayer(*)
    integer:: isp(*),jsp(*)
    integer:: i

    ! computation of isp,jsp,ksp,lsp
    isp(1) = 1
    jsp(1) = 1

    do i=1,ndc
        isp(i+1) = isp(i) + nlayer(i)
        jsp(i+1) = jsp(i) + 4 * nlayer(i)
    enddo

    return
end

!----------------------------------------------------------
subroutine calspo( ndc,rdc,nlayer,r0,rmin,rmax,ra,isp,spo,spn )
!----------------------------------------------------------
! Computing the source location.
    implicit none
    integer:: ndc,nlayer,isp(*),spn
    double precision:: rdc(*),r0,rmin,rmax,ra(*),spo
    integer:: itmp

    ! checking the parameter
    if ( r0<rmin .or. r0>rmax ) stop 'The source location is improper.(calspo)'
    ! computing 'spo'
    if ( r0==rmax ) then
        spo = nlayer - 0.01d0
        r0 = ra(nlayer) + (spo-dble(nlayer-1)) * ( ra(nlayer+1)-ra(nlayer) )
    else
        itmp = 2
        do
            if(r0<ra(itmp)) exit
            itmp=itmp+1
        enddo

        spo = dble(itmp-2) + ( r0-ra(itmp-1) ) / ( ra(itmp)-ra(itmp-1) )
        !c temporal handling
        if ( (spo-dble(itmp-2))<0.01d0 ) then
            spo = (itmp-2) + 0.01d0
            r0 = ra(itmp-1) + (spo-dble(itmp-2)) * ( ra(itmp)-ra(itmp-1) )
        endif
        if ( (spo-dble(itmp-2))>0.99d0 ) then
            spo = (itmp-2) + 0.99d0
            r0 = ra(itmp-1) + (spo-dble(itmp-2)) * ( ra(itmp)-ra(itmp-1) )
        endif

    endif
! computing 'spn'
    spn = 0
    itmp = 1

    do
        spn=spn+1
        if(r0<=rdc(itmp)) exit
        itmp=itmp+1
    enddo

    ! changing 'spo'
    spo = spo - ( isp(spn) - 1 )

    return
end


!----------------------------------------------------------
subroutine calstg( nzone,rrho,vsv,vsh,nlayer,nnl,ra,rmax,vnp,vra,rho,ecL,ecN )
!----------------------------------------------------------
!c Computing the structure grid points.
!----------------------------------------------------------
    implicit none
    integer:: nzone,nlayer,nnl(*),vnp
    double precision:: rrho(4,*),vsv(4,*),vsh(4,*),ra(*),rmax
    double precision:: vra(*),rho(*),ecL(*),ecN(*)
    double precision:: trho,tvsv,tvsh,coef
    integer:: izone,i,j,itmp,jtmp

    ! initializing the data
    vra(1:nlayer+nzone+1) = 0
    rho(1:nlayer+nzone+1) = 0
    ecL(1:nlayer+nzone+1) = 0
    ecN(1:nlayer+nzone+1) = 0

    !c computing the structure grid points
    itmp = 0
    jtmp = 0
    do izone=1,nzone
        do i=1,nnl(izone)+1
            itmp = itmp + 1
            jtmp = jtmp + 1
            vra(itmp) = ra(jtmp)
    !c --- evaluating the density and elastic constants at this point
            trho = 0
            tvsv = 0
            tvsh = 0
            do j=1,4
                if ( j==1 ) then
                    coef = 1
                else
                    coef = coef * ( vra(itmp) / rmax )
                endif
                trho = trho + rrho(j,izone) * coef
                tvsv = tvsv + vsv(j,izone) * coef
                tvsh = tvsh + vsh(j,izone) * coef
            enddo
            rho(itmp) = trho
            ecL(itmp) = rho(itmp) * tvsv * tvsv
            ecN(itmp) = rho(itmp) * tvsh * tvsh
        enddo
        jtmp = jtmp - 1
    enddo
    vnp = itmp
    return
end

!----------------------------------------------------------
subroutine calgstg( spn,rrho,vsv,vsh,ra,vra,rmax,rho,ecL,ecN,r0,mu0 )
!----------------------------------------------------------
!c Computing the structure grid points.
    implicit none
    integer:: spn
    double precision:: rrho(4,*),vsv(4,*),vsh(4,*)
    double precision:: ra(*),rmax
    double precision:: vra(*),rho(*),ecL(*),ecN(*),r0,mu0
    double precision:: trho,tvsv,tvsh,coef
    integer:: i,j

    ! initializing the data
    vra(1:3) = 0
    rho(1:3) = 0
    ecL(1:3) = 0
    ecN(1:3) = 0

    ! computing the structure grid points
    do i=1,3
        vra(i) = ra(i)
        ! --- evaluating the density and elastic constants at this point
        trho = 0
        tvsv = 0
        tvsh = 0
        do j=1,4
            if ( j==1 ) then
                coef = 1
            else
                coef = coef * ( vra(i) / rmax )
            endif
            trho = trho + rrho(j,spn) * coef
            tvsv = tvsv + vsv(j,spn) * coef
            tvsh = tvsh + vsh(j,spn) * coef
        enddo
        rho(i) = trho
        ecL(i) = rho(i) * tvsv * tvsv
        ecN(i) = rho(i) * tvsh * tvsh
    enddo

    mu0 = ecL(2)

    return
end

!----------------------------------------------------------
subroutine calcoef( nzone,omega,q,coef )
!----------------------------------------------------------
    use parameters
    implicit none

    integer:: izone
    integer,intent(in):: nzone
    double precision,intent(in):: omega,q(*)
    complex(dp),intent(out):: coef(*)
    double precision:: aa,bb

    do izone=1,nzone
        if ( omega==0 ) then
            aa = 1
        else
            aa = 1 + dlog( omega / ( 2 * pi ) ) / ( pi * Q(izone) )
        endif
        bb = 1 / ( 2 * Q(izone) )
        coef(izone) = dcmplx( aa, bb ) * dcmplx( aa, bb )
    enddo

    return
end

!----------------------------------------------------------
subroutine calcutd(nzone,nnl,tmpr,rat,nn,ra,kc)
!----------------------------------------------------------
    use parameters
    implicit none
    integer,intent(in):: nzone,nn,nnl(*)
    integer,intent(out)::kc
    complex(dp),intent(in):: tmpr(*)
    double precision:: rat,ra(*)
    integer:: nc

    double precision:: rc
    double precision:: maxamp,amp(nn)
    integer:: jz,jj,i,ml(nzone),tzone

    amp(1:nn) = tmpr(1:nn)

    maxamp = maxval(amp(1:nn))

    maxamp = maxamp * rat ! threshold value
    if(maxamp==0) then
        kc = 1
        return
    endif

    do i=1,nn
        if(amp(i)>maxamp) then
            nc = i
            exit
        endif
    enddo

    i = 1
    do jj=1,nzone
        i = i + nnl(jj)
        ml(jj) = i
    enddo

    do jj=nzone,1,-1
        if(ml(jj)>nc) tzone = jj
    enddo

    rc = ra(nc)
    kc = nc
    return
end

!----------------------------------------------------------
subroutine callsuf(omega,nzone,vrmax,vsv,lsuf)
!----------------------------------------------------------
    implicit none
    integer,intent(in):: nzone
    integer,intent(out)::lsuf
    double precision,intent(in):: omega,vrmax(*),vsv(4,*)
    double precision:: tvs
    integer:: i

    tvs = sum (vsv(1:4,nzone) )
    lsuf = int(omega * vrmax(nzone) / tvs - 0.5d0) + 1
    return
end

!----------------------------------------------------------
subroutine calamp(g,l,lsuf,maxamp,ismall,ratl)
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: l,lsuf,ismall
    double precision:: maxamp,ratl
    complex(dp),intent(in):: g

    double precision:: amp,ampratio

    ampratio = 0
    amp = cdabs(g)
    if( maxamp<amp ) maxamp = amp
    if ( amp /= 0 .and. maxamp /= 0 ) then
        ampratio = amp / maxamp
    endif
    if( ampratio<ratl .and. lsuf<l ) then
        ismall = ismall + 1
    else
        ismall = 0
    endif
    return
end

SUBROUTINE DCSYMBDL(A,M,N,NN,EPS,Z,W,L,LI,LJ,IER)
!**********************************************************************
!  GAUSS METHOD FOR A SYMMETRIC BAND MATRIX WITH A SHORT WIDTH.       *
!  THIS ROUTINE IS FOR A VECTOR COMPUTER.                             *
!                                                                     *
!  PARAMETERS:                                                        *
!   ON ENTRY:                                                         *
!     A      THE ARRAY WITH DIMENSION (M+1)*N WHICH CONTAINS          *
!            THE LOWER BAND MATRIX IN ROW-WISE.                       *
!     M      THE HALF BAND WIDTH OF THE MATRIX A, EXCLUDING DIADONALS.*
!     N      THE ORDER OF THE MATRIX A.                               *
!     NN     THE ORDER OF WORKING ARRAYS L, LI, AND LJ.               *
!     EPS    THE TOLERANCE FOR PIVOTAL ELEMENTS.                      *
!   ON RETURN:                                                        *
!     A      THE LOWER TRIANGULAR MATRIX L AFTER DECOMPOSITION.       *
!     IER    ERROR CODE. IF IER=0, NORMAL RETURN.                     *
!   OTHERS: WORKING PARAMETERS.                                       *
!                                                                     *
!  COPYRIGHT:       FUMIKO NAGAHORI    1 SEP. 1991      VER. 1        *
!    modified: Kensuke Konishi 2018 in Paris
!**********************************************************************
    use parameters
    implicit none
    INTEGER:: N,M,MM,NN
    INTEGER:: L(NN),LI(NN),LJ(NN),IER
    double precision::EPS
    COMPLEX(dp):: A((M+1)*N),Z(M+1),W(M+1)
    INTEGER:: I,J,K,IJ,KK,NK,NKK,NKI
    COMPLEX(dp):: PIV

    IER = 0
    IJ = 0
    DO I=1,M
        IJ = IJ + 1
        LI(IJ) = I + 1
        LJ(IJ) = 2
        L(IJ) = M * (I-1) + 1
        DO J=I+1,M
            IJ = IJ + 1
            L(IJ) = L(IJ-1) + M + 1
            LI(IJ) = LI(IJ-1) + 1
            LJ(IJ) = LJ(IJ-1) + 1
        enddo
    enddo
    MM = (M+1) * M / 2
    DO K=1,N-M
        NK = (M+1) * (K-1) + 1
        IF (cdabs(A(NK+M)) < EPS) THEN
            WRITE(*,*) '(SUBR. SYMBDL) SINGULAR AT STEP = ', K
            IER = 1
            RETURN
        ENDIF
        PIV = 1 / A(NK+M)
        DO J=2,M+1
            Z(J) = -A(NK+M*J)
            W(J) = A(NK+M*J) * PIV
            A(NK+M*J) = W(J)
        enddo

        KK = NK + M + M
        !VORTION VEC
        A(KK+L(1:mm)) = A(KK+L(1:mm)) + W(LJ(1:mm)) * Z(LI(1:mm))
    enddo

    DO K=N-M+1,N-1
        NK = (M+1) * (K-1) + 1
        NKK = (M+1) * K - 1
        IF (cdabs(A(NK+M)) < EPS) THEN
            WRITE(*,*) '(SUBR. SYMBDL) SINGULAR AT STEP = ', K
            IER = 1
            RETURN
        ENDIF
        PIV = 1 / A(NK+M)
        DO  J=2,N-K+1
            Z(J) = -A(NK+M*J)
            W(J) = A(NK+M*J) * PIV
            A(NK+M*J) = W(J)
            NKI = NKK + M * (J-1)
            A(NKI+2:nki+j) = A(NKI+2:nki+j) + W(J) * Z(2:j)
        enddo
    enddo
    RETURN
END SUBROUTINE DCSYMBDL

SUBROUTINE DCSBDLV(A,B,M,N,NP,Z)
!**********************************************************************
!  GAUSS METHOD FOR A SYMMETRIC BAND MATRIX WITH A SHORT WIDTH.       *
!  THIS ROUTINE IS FOR A VECTOR COMPUTER.                             *
!                                                                     *
!  PARAMETERS:                                                        *
!   ON ENTRY:                                                         *
!     A      THE ARRAY WITH DIMENSION (M+1),N WHICH CONTAINS          *
!            THE LEFT HAND SIDE LOWER BAND MATRIX.                    *
!     M      THE HALF BAND WIDTH OF THE MATRIX A, EXCLUDING DIADONALS.*
!     N      THE ORDER OF THE MATRIX A.                               *
!     EPS    THE TOLERANCE FOR PIVOTAL ELEMENTS.                      *
!     B      RIGHT HAND SIDE VECTOR                                   *
!   ON RETURN:                                                        *
!     B      SOLUTION.                                                *
!     IER    ERROR CODE. IF IER=0, NORMAL RETURN.                     *
!   OTHERS: WORKING PARAMETERS.                                       *
!                                                                     *
!  COPYRIGHT:       FUMIKO NAGAHORI    1 SEP. 1991      VER. 1        *
! modified: Kensuke Konishi 2018 in Paris
!**********************************************************************
    use parameters
    implicit none
    INTEGER:: M,N
    integer,intent(in):: NP
    COMPLEX(dp):: A(M+1,N),B(N),Z(N)
    INTEGER:: MM,J,K,I1
    COMPLEX(dp):: SUM

    ! FORWARD SUBSTITUTION
    MM = M + 1
    IF (MM < 3) THEN
        Z(NP) = B(NP)
        DO J=NP+1,N
            Z(J) = B(J) - A(1,J) * Z(J-1)
        enddo
        B(N) = Z(N) / A(M+1,N)
    ELSE
        Z(NP) = B(NP)
        Z(NP+1) = B(NP+1) - A(MM-1,NP+1) * Z(NP)
        DO J=NP+2,N
            IF (J > NP-1+MM) THEN
                I1 = 1
            ELSE
                I1 = NP-1+MM - J + 1
            ENDIF
            SUM = 0
            DO K=I1,MM-1
                SUM = SUM + A(K,J) * Z(J-MM+K)
            enddo
            Z(J) = B(J) - SUM
        enddo

        Z(n-1:n) = Z(n-1:n) / A(M+1,n-1:n)

        B(N) = Z(N)
        B(N-1) = Z(N-1) - A(MM-1,N) * Z(N)
    ENDIF
    RETURN
END SUBROUTINE DCSBDLV

SUBROUTINE DCSBDLV0(A,B,M,N,Z)
!**********************************************************************
!  GAUSS METHOD FOR A SYMMETRIC BAND MATRIX WITH A SHORT WIDTH.       *
!  THIS ROUTINE IS FOR A VECTOR COMPUTER.                             *
!                                                                     *
!  PARAMETERS:                                                        *
!   ON ENTRY:                                                         *
!     A      THE ARRAY WITH DIMENSION (M+1),N WHICH CONTAINS          *
!            THE LEFT HAND SIDE LOWER BAND MATRIX.                    *
!     M      THE HALF BAND WIDTH OF THE MATRIX A, EXCLUDING DIADONALS.*
!     N      THE ORDER OF THE MATRIX A.                               *
!     EPS    THE TOLERANCE FOR PIVOTAL ELEMENTS.                      *
!     B      RIGHT HAND SIDE VECTOR                                   *
!   ON RETURN:                                                        *
!     B      SOLUTION.                                                *
!     IER    ERROR CODE. IF IER=0, NORMAL RETURN.                     *
!   OTHERS: WORKING PARAMETERS.                                       *
!                                                                     *
!  COPYRIGHT:       FUMIKO NAGAHORI    1 SEP. 1991      VER. 1        *
!**********************************************************************
    use parameters
    IMPLICIT NONE
    integer:: M,N
    complex(dp):: A(M+1,N),B(N),Z(N)
    integer:: MM,J,K,I1,J1
    complex(dp):: SUM

    ! FORWARD SUBSTITUTION
    MM = M + 1
    IF (MM < 3) THEN
        Z(1) = B(1)
        DO J=2,N
            Z(J) = B(J) - A(1,J) * Z(J-1)
        enddo
        DO J=1,N
            Z(J) = Z(J) / A(M+1,J)
        enddo
        B(N) = Z(N)
        DO J=1,N-1
            B(N-J) = Z(N-J) - A(1,N-J+1) * B(N-J+1)
        enddo
    ELSE
        Z(1) = B(1)
        Z(2) = B(2) - A(M-1,2) * Z(1)
        DO J=3,N
            IF (J > MM) THEN
                I1 = 1
            ELSE
                I1 = MM - J + 1
            ENDIF
            SUM = 0
            DO K=I1,MM-1
                SUM = SUM + A(K,J) * Z(J-MM+K)
            enddo
            Z(J) = B(J) - SUM
        enddo

        Z(1:n) = Z(1:n) / A(M+1,1:n)

        B(N) = Z(N)
        B(N-1) = Z(N-1) - A(MM-1,N) * Z(N)
        DO J=3,N
            J1 = N - J + 1
            I1 = 1
            IF (J < MM) I1 = MM - J + 1
            SUM = 0
            DO K=I1,MM-1
                SUM = SUM + A(K,MM-K+J1) * B(MM-K+J1)
            enddo
            B(J1) = Z(J1) - SUM
        enddo
    ENDIF
    RETURN
END

SUBROUTINE RK3(NEQ,X0,XE,N,Y0,YN,N1,WORK)
!*********************************************************************
!     SUBROUTINE RK NUMERICALLY INTEGRATES A SYSTEM OF NEQ           *
!     FIRST ORDER ORDINARY DIFFERENTIAL EQUATIONS OF THE FORM        *
!             DY(I)/DX = F(X, Y(1),..., Y(NEQ)),                     *
!     BY THE CLASSICAL RUNGE-KUTTA FORMULA.                          *
!                                                                    *
!     PARAMETERS                                                     *
!  === INPUT ===                                                     *
!     (1) NEQ: NUMBER OF EQUATIONS TO BE INTEGRATED                  *
!     (2) FUNC: SUBROUTINE FUNC(X,Y,F) TO EVALUATE DERIVATIVES       *
!                F(I)=DY(I)/DX                                       *
!     (3) X0: INITIAL VALUE OF INDEPENDENT VARIABLE                  *
!     (4) XE: OUTPUT POINT AT WHICH THE SOLUTION IS DESIRED          *
!     (5) N: NUMBER OF DIVISIONS                                     *
!        THE INTERVAL (X0, XE) IS DIVIDED INTO N SUBINTERVALS        *
!        WITH THE LENGTH (XE-X0)/N AND IN EACH SUBINTERVAL           *
!        THE CLASSICAL RUNGE-KUTTA FORMULA IS USED.                  *
!     (6) Y0(I) (I=1,..,NEQ): INITIAL VALUE AT X0                    *
!  === OUTPUT ===                                                    *
!     (7) YN(I) (I=1,..,NEQ): APPROXIMATE SOLUTION AT XE             *
!  === OTHER ===                                                     *
!     (8) WORK(): TWO-DIMENTIONAL ARRAY (SIZE=(NEQ,2)) TO BE         *
!                 USED INSIDE RK                                     *
!     COPYRIGHT: M. SUGIHARA, NOVEMBER 15, 1989, V. 1                *
! modified: Kensuke Konishi 2018 in Paris 2020 in Taiwan
!*********************************************************************
    use parameters
    implicit none
    !EXTERNAL FUNC
    INTEGER:: NEQ,N,I,J,N1
    double precision:: X0,XE
    complex(dp):: Y0(NEQ),YN(NEQ),WORK(N1,2)
    double precision:: H
    H = (XE - X0) / DBLE(N)
    do I = 1,N
        CALL RKSTEP(NEQ,X0,H,Y0,YN,WORK(1,1),WORK(1,2))
        X0 = X0 + H
        Y0(1:neq) = YN(1:neq)
    enddo
    X0 = XE
    RETURN
    END

SUBROUTINE RKSTEP(NEQ,X,H,Y0,YN,AK,W)
    use parameters
    implicit none

    INTEGER,intent(in):: NEQ
    double precision:: X,H
    complex(dp):: Y0(NEQ),YN(NEQ),AK(NEQ),W(NEQ)

    integer:: i
    double precision:: A2,A3,B2,B3,C1,C2,C3,C4
    PARAMETER(A2 = 0.5D0, A3 = A2)
    PARAMETER(B2 = 0.5D0, B3 = B2)
    PARAMETER(C1 = 1.D0/6.D0, C2 = 1.D0/3.D0, C3 = C2, C4 = C1)
    !EXTERNAL FUNC
    CALL eqmotion1(X,Y0,AK)

    YN(1:NEQ) = Y0(1:NEQ) + DCMPLX( H * C1 ) * AK(1:NEQ)

    W(1:NEQ) = Y0(1:NEQ) + DCMPLX( H * B2 ) * AK(1:NEQ)

    CALL eqmotion1(X + A2 * H,W,AK)

    YN(1:NEQ) = YN(1:NEQ) + DCMPLX( H * C2 ) * AK(1:NEQ)

    W(1:NEQ) = Y0(1:NEQ) + DCMPLX( H * B3 ) * AK(1:NEQ)

    CALL eqmotion1(X + A3 * H,W,AK)
    YN(1:NEQ) = YN(1:NEQ) + DCMPLX( H * C3 ) * AK(1:NEQ)

    W(1:NEQ) = Y0(1:NEQ) + DCMPLX( H ) * AK(1:NEQ)
    CALL eqmotion1(X + H,W,AK)

    YN(1:NEQ) = YN(1:NEQ) + DCMPLX( H * C4 ) * AK(1:NEQ)

    RETURN
    END

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
subroutine pinput_tipsv(parameter_file,&
    re,ratc,ratl,tlen,np,omegai,imin,imax,&
    nzone,vrmin,vrmax,rho,vpv,vph,vsv,vsh,eta,qmu,qkappa,&
    r0,eqlat,eqlon,mt,nr,theta,phi,lat,lon,output)
    use parameters
    implicit none
    integer, parameter :: maxnline=2*maxnr+6*maxnzone+50
    character*160, intent(in):: parameter_file
    integer,intent(out):: np,imin,imax,nzone,nr
    real(dp),intent(out):: tlen,omegai,re,ratc,ratl
    real(dp),dimension(maxnzone),intent(out):: vrmin,vrmax,qmu,qkappa
    real(dp),dimension(4,maxnzone),intent(out)::rho,vpv,vph,vsv,vsh,eta
    real(dp),dimension(maxnr),intent(out)::theta,phi,lat,lon
    real(dp),intent(out):: eqlat,eqlon,r0,mt(3,3)
    character*80,dimension(maxnr),intent(out):: output
    integer:: i,linenum,io
    real(dp):: eqlattmp,stlat,stlon
    logical:: file_exists
    character*80::buffer
    character*80,dimension(maxnline):: lines

    inquire(file=parameter_file, exist=file_exists)

    if (.not. file_exists) stop 'parameter file does not exist.'

    linenum=0
    open(1,file=parameter_file,status='old',action='read')
    do
        read (1,'(a)', iostat=io) buffer
        buffer = adjustl(buffer)
        if(buffer(1:1) =='#'.or.buffer(1:1) =='c' .or. buffer(1:1) == '!') cycle
        if (io/=0) exit
        linenum = linenum+1
        lines(linenum) = buffer
    enddo
    close(1)

! reading the parameter
    read(lines(1),*) tlen,np
    read(lines(2),*) re! relative error (vertical grid)
    read(lines(3),*) ratc! ampratio (vertical grid cut-off)
    read(lines(4),*) ratl! ampratio (for l-cutoff)
    read(lines(5),*) omegai! artificial damping
    omegai = - dlog(omegai) / tlen
    read(lines(6),*) imin,imax
    read(lines(7),*) nzone
    if ( nzone>maxnzone ) stop 'nzone is too large. (pinput)'
! structure
    do i=1, nzone
        read(lines(7+6*(i-1)+1),*) vrmin(i),vrmax(i),rho(1:4,i)
        read(lines(7+6*(i-1)+2),*) vpv(1:4,i)
        read(lines(7+6*(i-1)+3),*) vph(1:4,i)
        read(lines(7+6*(i-1)+4),*) vsv(1:4,i)
        read(lines(7+6*(i-1)+5),*) vsh(1:4,i)
        read(lines(7+6*(i-1)+6),*) eta(1:4,i),qmu(i),qkappa(i)
    enddo
! source
    read(lines(8+6*nzone),*) r0,eqlat,eqlon
    eqlattmp = eqlat
    call translat(eqlattmp,eqlattmp)
    read(lines(9+6*nzone),*) mt(1,1:3),mt(2,2:3),mt(3,3)
    read(lines(10+6*nzone),*) nr
!station
    if ( nr>maxnr ) stop 'nr is too large. (pinput)'
    do  i=1,nr
        read(lines(10+6*nzone+i),*) lat(i),lon(i)
        stlat = lat(i)
        stlon = lon(i)
        call translat(stlat,stlat)
        call calthetaphi(eqlattmp,eqlon,stlat,stlon,theta(i),phi(i))
    enddo
    theta(1:nr) = theta(1:nr) / 1.8d2 * pi
    phi(1:nr) = phi(1:nr) / 1.8d2 * pi
    do i=1,nr
        read(lines(10+6*nzone+nr+i),'(a)') output(i)
        output(i)=trim(output(i))
    enddo
    return
end subroutine

!----------------------------------------------------------
subroutine calthetaphi(ievla,ievlo,istla,istlo,theta,phi)
!----------------------------------------------------------
    use parameters
    implicit none
    double precision,intent(in):: ievla,ievlo,istla,istlo
    double precision,intent(out):: theta,phi
    double precision:: evla,evlo,stla,stlo
    double precision:: gcarc,az,tc,ts

    ! transformation to spherical coordinates
    evla = 90 - ievla
    stla = 90 - istla

    evla = evla / 180 * pi
    evlo = ievlo / 180 * pi
    stla = stla / 180 * pi
    stlo = istlo / 180 * pi

    gcarc = dacos(dcos(evla) * dcos(stla)+dsin(evla)*dsin(stla)*dcos(evlo-stlo))

    tc = (dcos(stla)*dsin(evla)-dsin(stla)*dcos(evla)*dcos(stlo-evlo))/dsin(gcarc)
    ts = dsin(stla) * dsin(stlo - evlo) / dsin(gcarc)

    az = dacos(tc)
    if( ts < 0 ) az = - az

    az = az * 180 / pi

    gcarc = gcarc * 180 / pi

    theta = gcarc
    phi = 180 - az
    return
end

!----------------------------------------------------------
subroutine translat(geodetic,geocentric)
!----------------------------------------------------------
    use parameters
    implicit none
    double precision,intent(in):: geodetic
    double precision,intent(out):: geocentric
    double precision:: tmp_geodetic
    integer:: flag

    flag = 0
    tmp_geodetic=geodetic
    if(90<geodetic ) then
        tmp_geodetic = 180 - geodetic
        flag = 1
    endif

    tmp_geodetic = tmp_geodetic / 180 * pi
    geocentric = datan((1-flattening)*(1-flattening)*dtan(tmp_geodetic))
    geocentric = geocentric * 180 / pi
    if(flag == 1) geocentric = 180 - geocentric

    return
end

!----------------------------------------------------------
subroutine calnl( nzone,vs,iphase,nsl,nll )
!----------------------------------------------------------
! counting of nsl and nll.
!----------------------------------------------------------
    implicit none
    integer,intent(in):: nzone
    integer:: nsl,nll,iphase(nzone)
    double precision,intent(in):: vs(4,*)
    integer:: i

    nsl = 0
    nll = 0
    do i=1,nzone
        if ( vs(1,i)== 0 .and. vs(2,i)==0 .and. vs(3,i)==0 .and. vs(4,i)==0 ) then
            nll = nll + 1
            iphase(i) = 2
        else
            nsl = nsl + 1
            iphase(i) = 1
        endif
    enddo
    return
end

!----------------------------------------------------------
subroutine calgrid( nzone,vrmin,vrmax,vp,vs,rmin,rmax,&
    imax,lmin,tlen,vmin,gridpar,dzpar )
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nzone,imax,lmin
    double precision:: vrmin(*),vrmax(*),vp(4,*),vs(4,*)
    double precision:: rmin,rmax,tlen,vmin(*),gridpar(*),dzpar(*)
    integer:: izone,i,j
    double precision:: coef1,coef2,v(4),vs1,vs2,rh,omega,amax,gtmp

    do izone=1,nzone
        ! computing the S-velocity at each zone
        if ( vs(1,izone)==0 ) then
            v(1:4) = vp(1:4,izone)
        else
            v(1:4) = vs(1:4,izone)
        endif
        vs1 = 0
        vs2 = 0
        do j=1,4
            if ( j==1 ) then
                coef1 = 1
                coef2 = 1
            else
                coef1 = coef1 * ( vrmin(izone) / rmax )
                coef2 = coef2 * ( vrmax(izone) / rmax )
            endif
            vs1 = vs1 + v(j) * coef1
            vs2 = vs2 + v(j) * coef2
        enddo
        ! computing rh
        rh = vrmax(izone) - vrmin(izone)
        ! computing omega,amax
        omega = 2 * pi * imax / tlen
        if ( vs1>=vs2 ) then
            vmin(izone) = vs2
        else
            vmin(izone) = vs1
        endif
        amax = vrmax(izone)
        gtmp = ( omega * omega ) / ( vmin(izone) * vmin(izone) ) &
            -  (lmin+0.5d0) * (lmin+0.5d0)  / ( amax * amax )
        if ( gtmp>0 ) then
            dzpar(izone)   = dsqrt( 1/gtmp )
            gridpar(izone) = rh / dzpar(izone)
        else
            dzpar(izone)   = 0
            gridpar(izone) = 0
        endif
    enddo
    ! rearangement of gridpar
    gtmp = sum(gridpar(1:nzone))

    do izone=1,nzone
        if ( gridpar(izone)>0 ) then
            gridpar(izone) = gridpar(izone) / gtmp
        else
            rh = vrmax(izone) - vrmin(izone)
            gridpar(izone) = rh / ( rmax - rmin ) * 0.1d0
        endif
    enddo
    ! re-rearangement of gridpar
    gtmp = sum(gridpar(1:nzone))

    gridpar(1:nzone) = gridpar(1:nzone) / gtmp

    return
end

!----------------------------------------------------------
subroutine calra(inlayer,jnlayer,jnslay,jnllay,&
    dzpar,nzone,vrmin,vrmax,iphase,rmin,nslay,nllay,nnl,ra,re )
!----------------------------------------------------------
! Computing the number and the location of grid points.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: inlayer,jnlayer,jnslay,jnllay
    integer:: nzone,iphase(*),nslay,nllay,nnl(maxnzone)
    double precision:: dzpar(*),vrmin(*),vrmax(*),rmin
    double precision:: ra(maxnlay+maxnzone+1)
    integer:: izone,itmp,i,ntmp
    double precision:: rh,re

    ! Initializing the data
    nslay = 0
    nllay = 0

    ra(1:maxnlay+maxnzone+1)=0

    nnl(1:nzone)=0

    jnlayer = 0
    jnslay = 0
    jnllay = 0

    ! tnlayer = nlayer / (2**(idr-1))
    ! computing the number and the location of the grid points
    ra(1) = rmin
    itmp = 1
    do izone=1,nzone
        rh = vrmax(izone) - vrmin(izone)
        if(dzpar(izone)==0) then
            ntmp = 1
        else
            ntmp = int( sqrt(3.3d0 / re ) * rh / dzpar(izone)&
                / 2.d0 / pi  / 7.d-1 + 1 )
        endif
        ! ntmp (see Geller & Takeuchi 1995 6.2)
        !	  nnl(izone) = dint( dble(nlayer) * gridpar(izone) ) + 1
        nnl(izone) = ntmp
        if ( nnl(izone)<5 ) nnl(izone)=5
        if ( iphase(izone)==1 ) nslay = nslay + nnl(izone)
        if ( nslay>maxnslay ) stop  'nslay is too large. (calra)'
        if ( iphase(izone)==2 ) nllay = nllay + nnl(izone)
        if ( nllay>maxnllay ) stop  'nllay is too large. (calra)'
        do  i=1,nnl(izone)
            itmp = itmp + 1
            if ( itmp>maxnlay ) stop  'nlay is too large. (calra)'
            ra(itmp) = vrmin(izone) + rh * dble(i) / dble( nnl(izone) )
        enddo
    enddo

    ! recouting the total number of grid points
    inlayer = sum(nnl(1:nzone))

    jnlayer = jnlayer + inlayer
    jnslay  = jnslay  + nslay
    jnllay  = jnllay  + nllay

    return
end

!----------------------------------------------------------
subroutine calsp(ndc,nsl,nll,iphase,nlayer,nllay,&
    isp,jsp,ksp,issp,ilsp,lsp,jssp,isdr,jsdr,ildr,jdr,kdr )
!----------------------------------------------------------
! Computing the stack points.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: ndc,nsl,nll,iphase(*),nlayer(maxnzone)
    integer:: nllay
    integer:: isp(maxnzone),jsp(maxnzone),ksp(maxnzone)
    integer:: issp(maxnzone),ilsp(maxnzone)
    integer:: lsp(maxnzone),jssp(maxnzone)
    integer:: isdr,jsdr,ildr,jdr,kdr
    integer:: i,isl,ill

    ! Initialization of the data
    isp = 0
    jsp = 0
    ksp = 0
    issp = 0
    ilsp = 0
    lsp  = 0
    jssp = 0

    isdr = 0
    jsdr = 0
    ildr = 0
    jdr = 0
    kdr = 0
    ! computation of isp,jsp,ksp,issp,ilsp,lsp
    isp(1)  = 1
    jsp(1)  = 1
    ksp(1)  = 1
    issp(1) = 1
    ilsp(1) = 1
    lsp(1)  = 1
    jssp(1) = 1
    isl = 0
    ill = 0
    do i=1,ndc
        isp(i+1) = isp(i) + nlayer(i)
        if ( iphase(i)==1 ) then
            jsp(i+1) = jsp(i) + 16 * nlayer(i)
            ksp(i+1) = ksp(i) + 2 * ( nlayer(i) + 1 )
            lsp(i+1) = lsp(i) + 4 * nlayer(i)
            isl = isl + 1
            if ( isl/=nsl ) then
                issp(isl+1) = issp(isl) + 4 * nlayer(i)
                jssp(isl+1) = jssp(isl) + nlayer(i) + 1
            endif
        else
            jsp(i+1) = jsp(i) + 4 * nlayer(i)
            ksp(i+1) = ksp(i) + ( nlayer(i) + 1 )
            lsp(i+1) = lsp(i) + 2 * nlayer(i)
            ill = ill + 1
            if ( ill/=nll )  ilsp(ill+1) = ilsp(ill) + 4 * nlayer(i)
        endif
    enddo
    isdr = 0
    jsdr = 0
    ildr = 0
    jdr = 0
    isdr = isdr + issp(nsl)-1 + 4 * nlayer(ndc+1)
    jsdr = jsdr + jssp(nsl)-1 + nlayer(ndc+1) + 1
    ildr = ildr + 4 * nllay
    jdr =  jdr  + jsp(ndc+1)-1 + 16 * nlayer(ndc+1)
    kdr =  kdr + ksp(ndc+1)-1 + 2 * ( nlayer(ndc+1)+1 )
    return
    end

!----------------------------------------------------------
subroutine calspo( rdc,iphase,inlayer,r0,rmin,rmax,ra,isp,spo,spn )
    use parameters
    implicit none
!----------------------------------------------------------
! Computing the source location.
!----------------------------------------------------------
    integer:: iphase(*)
    integer:: inlayer,isp(maxnzone),spn
    double precision:: rdc(*),r0,rmin,rmax,ra(maxnlay+maxnzone+1),spo
    integer:: itmp

    ! checking the parameter
    if ( r0<rmin .or. r0>rmax ) stop 'The source location is improper.(calspo)'
    spo = 0
    ! computing 'spo'
    if ( r0==rmax ) then
        spo = inlayer - 0.01d0
        r0 = ra(inlayer) + (spo-dble(inlayer-1)) * ( ra(inlayer+1) -ra(inlayer) )
    else
        itmp = 2
        do
            if ( r0<ra(itmp) ) exit
            itmp = itmp + 1
        enddo
        spo = dble(itmp-2)+ ( r0-ra(itmp-1) )   / ( ra(itmp)-ra(itmp-1) )
    ! temporal handling
        if ( (spo-dble(itmp-2))<0.01d0 ) then
            spo = dble(itmp-2) + 0.01d0
            r0 = ra(itmp-1)+ (spo-dble(itmp-2)) * ( ra(itmp)-ra(itmp-1) )
        endif
        if ( (spo-dble(itmp-2))>0.99d0 ) then
            spo = dble(itmp-2) + 0.99d0
            r0 = ra(itmp-1) + (spo-dble(itmp-2)) * ( ra(itmp)-ra(itmp-1) )
        endif
    endif
! computing 'spn'
    spn = 0
    itmp = 1

    do
        if ( iphase(itmp)==1 ) then
            spn = spn + 1
            if ( r0<=rdc(itmp) ) exit
            itmp = itmp + 1
        else
            spn = spn + 1
            if ( r0<=rdc(itmp) ) stop 'The source is in the liquid layer.(calspo)'
            itmp = itmp + 1
        endif
    enddo
! changing 'spo'
    spo = spo - dble( isp(spn) - 1 )

    return
    end

!----------------------------------------------------------
subroutine calstg( nzone,rrho,vpv,vph,vsv,vsh,eta,nnl,ra,rmax,&
    vnp,vra,rho,kappa,ecKx,ecKy,ecKz,&
    mu,ecL,ecN, r0,spn,ecC0,ecF0,ecL0 )
! Computing the structure grid points.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nzone,nnl(*),vnp,spn
    double precision:: rrho(4,*),vpv(4,*),vph(4,*),vsv(4,*),vsh(4,*),eta(4,*)
    double precision:: ra(*),rmax
    double precision:: vra(*),rho(*),kappa(*),ecKx(*),ecKy(*),ecKz(*)
    double precision:: mu(*),ecL(*),ecN(*)
    double precision:: ecA,ecC,ecF
    double precision:: r0,ecA0,ecC0,ecF0,ecL0
    double precision:: trho,tvpv,tvph,tvsv,tvsh,teta,coef
    integer:: izone,i,j,itmp,jtmp

    ! initializing the data
    vra(1:maxnlay+2*maxnzone+1)=0
    rho(1:maxnlay+2*maxnzone+1)=0
    kappa(1:maxnlay+2*maxnzone+1)=0
    ecKx(1:maxnlay+2*maxnzone+1)=0
    ecKy(1:maxnlay+2*maxnzone+1)=0
    ecKz(1:maxnlay+2*maxnzone+1)=0
    mu(1:maxnlay+2*maxnzone+1)=0
    ecL(1:maxnlay+2*maxnzone+1)=0
    ecN(1:maxnlay+2*maxnzone+1)=0
    ! computing the structure grid points
    itmp = 0
    jtmp = 0
    do  izone=1,nzone
        do  i=1,nnl(izone)+1
            itmp = itmp + 1
            jtmp = jtmp + 1
            vra(itmp) = ra(jtmp)
            ! --- evaluating the density and elastic constants at this point
            trho = 0
            tvpv = 0
            tvph = 0
            tvsv = 0
            tvsh = 0
            teta = 0
            do j=1,4
                if ( j==1 ) then
                    coef = 1.d0
                else
                    coef = coef * ( vra(itmp) / rmax )
                endif
                trho  = trho  + rrho(j,izone)  * coef
                tvpv  = tvpv  + vpv(j,izone)   * coef
                tvph  = tvph  + vph(j,izone)   * coef
                tvsv  = tvsv  + vsv(j,izone)   * coef
                tvsh  = tvsh  + vsh(j,izone)   * coef
                teta  = teta  + eta(j,izone)   * coef
            enddo
            rho(itmp) = trho
            ecL(itmp)  = rho(itmp) * tvsv * tvsv
            ecN(itmp)  = rho(itmp) * tvsh * tvsh
            ecA = trho * tvph * tvph
            ecC = trho * tvpv * tvpv
            ecF = teta * ( ecA - 2.d0 * ecL(itmp) )
            kappa(itmp) = ( 4.d0 * ecA + ecC + 4.d0 * ecF - 4.d0 * ecN(itmp) ) / 9.d0
            ecKx(itmp) = ecA - 4.d0 / 3.d0 * ecN(itmp)
            ecKy(itmp) = ecF + 2.d0 / 3.d0 * ecN(itmp)
            ecKz(itmp) = ( ecC + 2.d0 * ecF ) / 3.d0
        enddo
        jtmp = jtmp - 1
    enddo
    vnp = itmp

    trho = 0
    tvpv = 0
    tvph = 0
    tvsv = 0
    tvsh = 0
    teta = 0
    do j=1,4
        if ( j==1 ) then
            coef = 1
        else
            coef = coef * ( r0 / rmax )
        endif
        trho = trho + rrho(j,spn) * coef
        tvpv = tvpv + vpv(j,spn)  * coef
        tvph = tvph + vph(j,spn)  * coef
        tvsv = tvsv + vsv(j,spn)  * coef
        tvsh = tvsh + vsh(j,spn)  * coef
        teta = teta + eta(j,spn)  * coef
    enddo
    ecL0 = trho * tvsv * tvsv
    ecA0 = trho * tvph * tvph
    ecC0 = trho * tvpv * tvpv
    ecF0 = teta * ( ecA0 - 2 * ecL0 )
    return
end

!----------------------------------------------------------
subroutine caltstg( nzone,rrho,vpv,vph,vsv,vsh,eta,nnl,ra,rmax,tvra,tkappa,tecKx,tecKy,tecKz,tmu,tecL,tecN)
! Computing the structure grid points.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nzone,nnl(*)
    double precision:: rrho(4,*),vpv(4,*),vph(4,*),vsv(4,*),vsh(4,*),eta(4,*)
    double precision:: ra(*),rmax
    double precision:: tvra(*),tkappa(*),tmu(*)
    double precision:: tecKx(*),tecKy(*),tecKz(*),tecL(*),tecN(*)
    double precision:: trho,tvpv,tvph,tvsv,tvsh,teta,coef
    double precision:: ecA,ecC,ecF
    integer:: izone,i,j,itmp,jtmp
    !
    tvra(1:maxnlay+2*maxnzone+1)=0
    tkappa(1:maxnlay+2*maxnzone+1)=0
    tecKx(1:maxnlay+2*maxnzone+1)=0
    tecKy(1:maxnlay+2*maxnzone+1)=0
    tecKz(1:maxnlay+2*maxnzone+1)=0
    tmu(1:maxnlay+2*maxnzone+1)=0
    tecL(1:maxnlay+2*maxnzone+1)=0
    tecN(1:maxnlay+2*maxnzone+1)=0
    ! computing the structure grid points
    itmp = 0
    jtmp = 0
    do izone=1,nzone
        do i=1,nnl(izone)+1
            itmp = itmp + 1
            jtmp = jtmp + 1
            tvra(itmp) = ra(jtmp)
            ! --- evaluating the density and elastic constants at this point
            trho = 0
            tvpv = 0
            tvph = 0
            tvsv = 0
            tvsh = 0
            teta = 0
            do j=1,4
                if ( j==1 ) then
                    coef = 1
                else
                    coef = coef * ( tvra(itmp) / rmax)
                endif
                trho = trho + rrho(j,izone) * coef
                tvpv  = tvpv  + vpv(j,izone)   * coef
                tvph  = tvph  + vph(j,izone)   * coef
                tvsv  = tvsv  + vsv(j,izone)   * coef
                tvsh  = tvsh  + vsh(j,izone)   * coef
                teta  = teta  + eta(j,izone)   * coef
            enddo
            tecL(itmp)  = trho * tvsv * tvsv
            tecN(itmp)  = trho * tvsh * tvsh
            ecA = trho * tvph * tvph
            ecC = trho * tvpv * tvpv
            ecF = teta * ( ecA - 2.d0 * tecL(itmp) )
            tkappa(itmp) = ( 4 * ecA + ecC  + 4 * ecF - 4 * tecN(itmp) )/ 9d0
            tecKx(itmp) = ecA - 4 / 3 * tecN(itmp)
            tecKy(itmp) = ecF + 2d0 / 3 * tecN(itmp)
            tecKz(itmp) = ( ecC + 2 * ecF ) / 3.d0
        enddo
        jtmp = jtmp - 1
    enddo
    return
end

!----------------------------------------------------------
subroutine calspdr( nzone,iphase,nlayer,jjdr,kkdr )
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nzone,iphase(*)
    integer:: nlayer(maxnzone),jjdr(*),kkdr(*)
    integer:: izone
    jjdr(1) = 1
    kkdr(1) = 1
    do izone=1,nzone-1
        if ( iphase(izone)==1 ) then
            jjdr(izone+1) = jjdr(izone) + 16 * nlayer(izone)
            if ( iphase(izone+1)==1 ) then
                kkdr(izone+1)  = kkdr(izone) + 2 * nlayer(izone)
            else
                kkdr(izone+1) = kkdr(izone) + 2 * ( nlayer(izone)+1 )
            endif
        else
            jjdr(izone+1) = jjdr(izone) + 4 * nlayer(izone)
            if ( iphase(izone+1)==1 ) then
                kkdr(izone+1)   = kkdr(izone) + ( nlayer(izone)+1 )
            else
                kkdr(izone+1)  = kkdr(izone) + nlayer(izone)
            endif
        endif
    enddo
    return
end

!----------------------------------------------------------
subroutine calamp( g,l,lsuf,maxamp,ismall,ratl )
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: ismall
    integer,intent(in)::l,lsuf
    double precision:: maxamp,ratl
    complex(dp),intent(in):: g(2)
    double precision:: amp,ampratio

    ampratio = 0
    amp = dsqrt( cdabs( g(1) )**2 + cdabs( g(2) )**2 )
    if ( amp>maxamp ) maxamp = amp
    if ( amp/=0 .and. maxamp/=0 )   ampratio = amp / maxamp
    if ( ampratio<ratl .and. l>=lsuf ) then
        ismall = ismall + 1
    else
        ismall = 0
    endif
    return
end

!----------------------------------------------------------
subroutine calcutd(nzone,nnl,tmpc,rat,nn,iphase,ra,kkdr,kc)
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nzone,nn,kkdr(*),kc,iphase(*),nnl(*)
    complex(dp) ::tmpc(*)
    double precision:: rat,ra(*)
    integer:: nc
    double precision:: cU(nn),cV(nn),rc
    double precision:: maxamp,amp(nn)
    integer:: iz,jz,jj,i,ml(nzone),tzone

    cU = 0
    cV = 0

    iz = 2
    jz = 1
    do  jj=1,nn
        if(jj==kkdr(iz)) then
            if(iphase(iz)/=iphase(iz-1)) jz = jz - 1
            iz = iz + 1
        endif
        if(iphase(iz-1)==1) then
            if(mod((jj-kkdr(iz-1)),2)==1) then ! U
                cU(jz) = cdabs(tmpc(jj))
                jz = jz + 1
                ! V nothing
            endif
        else ! U in fluid
            cU(jz) = cdabs(tmpc(jj))
            jz = jz + 1
        endif
    enddo

    amp(1:jz-1) = cU(1:jz-1)
    maxamp=maxval(amp(1:jz-1))



    maxamp = maxamp * rat ! threshold value

    nc = 1
    do i=1,jz-1
        if(amp(i)>maxamp) then
            nc = i
            exit
        endif
    enddo

    i = 1
    do jj=1,nzone
        i = i + nnl(jj)
        ml(jj) = i
    enddo

    do jj=nzone,1,-1
        if(ml(jj)>nc) tzone = jj
    enddo

    rc = ra(nc)

    do i=1,jz-1
        if( ra(i)<=rc .and. rc<ra(i+1) ) then
            nc = i
            if(tzone==1) then ! case(tzone is innermost zone)
                if(iphase(tzone)==1) kc = 1 + 2 * nc
                if(iphase(tzone)==2) kc = 1 + nc
            else
                if(iphase(tzone)==1) then
                    kc = kkdr(tzone) + 2 * (nc - ml(tzone-1))
                elseif(iphase(tzone)==2) then
                    kc = kkdr(tzone) + nc - ml(tzone-1)
                endif
            endif
        endif
    enddo

    return
end

!----------------------------------------------------------
subroutine callsuf(omega,nzone,vrmax,vsv,lsuf)
!----------------------------------------------------------
    implicit none
    integer:: nzone,lsuf
    double precision:: omega,vrmax(*),vsv(4,*)

    double precision:: tvs,coef
    integer:: i

    tvs = sum(vsv(1:4,nzone))

    lsuf = int(omega * vrmax(nzone) / tvs - 0.5d0) + 1
    return
end

! calmat.f for wcalprem.f
!----------------------------------------------------------
subroutine calmatc(nlayer,vnp,vra,con,rpow,w1dn,w2dn,ra,m,work)
!----------------------------------------------------------
! Computing \int r^rpow con W_p^(w1dn) W_q^(w2dn) dr.
!----------------------------------------------------------
    implicit none
    integer:: maxrpow
    parameter ( maxrpow = 2 )
    integer,intent(in):: nlayer,vnp,rpow,w1dn,w2dn
    double precision:: vra(vnp),con(vnp),ra(*),m(*),work(*)
    integer:: i,j,k,l,nn,snp
    double precision:: a(2,2),b(2,2),c(5),rh
    ! parameter check
    if (maxrpow<rpow) stop 'Invalid arguments.(calmatc)'
    ! computing of the matrix elements
    snp = 1
    do i=1,nlayer
        rh = ra(i+1) - ra(i)
        if ( w1dn == 0 ) then
            a(2,1) = -1.d0 / rh
            a(1,1) = ra(i+1) / rh
            a(2,2) = 1.d0 / rh
            a(1,2) = -ra(i) / rh
        elseif ( w1dn == 1 ) then
                a(2,1) = 0.d0
                a(1,1) = -1.d0 / rh
                a(2,2) = 0.d0
                a(1,2) = 1.d0 / rh
        else
            stop 'Invalid arguments.(calmatc)'
        endif

        if ( w2dn == 0 ) then
            b(2,1) = -1.d0 / rh
            b(1,1) = ra(i+1) / rh
            b(2,2) = 1.d0 / rh
            b(1,2) = -ra(i) / rh
        elseif ( w2dn == 1 ) then
                b(2,1) = 0.d0
                b(1,1) = -1.d0 / rh
                b(2,2) = 0.d0
                b(1,2) = 1.d0 / rh
        else
            stop 'Invalid arguments.(calmatc)'
        endif

        do j=1,2
            do k=1,2
                c(1:5) = 0.d0

                call pmulti( 2,a(1,j),2,b(1,k),3,c )
                do l=3,1,-1
                    c(l+rpow) = c(l)
                    if ( rpow>0 ) c(l)=0.d0
                enddo
                nn = 4 * (i-1) + 2 * (j-1) + k
                call pinteg(snp,5,c,ra(i),ra(i+1),vnp,vra,con,work(nn))
            enddo
        enddo
    enddo
    if ( w1dn /= w2dn ) then
        m(1:nlayer*4-3:4)=2*work(1:nlayer*4-3:4)
        m(2:nlayer*4-2:4)=work(2:nlayer*4-2:4)+work(3:nlayer*4-1:4)
        m(3:nlayer*4-1:4)=work(2:nlayer*4-2:4)+work(3:nlayer*4-1:4)
        m(4:nlayer*4:4)=2*work(4:nlayer*4:4)
    else
        m(1:4*nlayer) = work(1:4*nlayer)
    endif
    return
end

!----------------------------------------------------------
subroutine caltl( nlayer,vnp,vra,rho,ra,tl)
!----------------------------------------------------------
! Computing of lumped mass matrix.
!----------------------------------------------------------
    implicit none
    integer:: nlayer,vnp
    double precision:: vra(vnp),rho(vnp),ra(*),tl(*)
    integer:: i,nn,snp
    double precision:: c(3),from,to

    snp = 1
    do i=1,nlayer
        c(1:2) = 0.d0
        c(3) = 1.d0

        from = ra(i)
        to = ( ra(i) + ra(i+1) ) / 2.d0
        nn = 4 * (i-1)
        call pinteg( snp,3,c,from,to,vnp,vra,rho,tl(nn+1) )

        tl(nn+2:nn+3) = 0.d0

        from = to
        to = ra(i+1)
        call pinteg( snp,3,c,from,to,vnp,vra,rho,tl(nn+4) )

    enddo
    return
end

!----------------------------------------------------------
subroutine calhl( nlayer,vnp,vra,mu,ra,hl)
!----------------------------------------------------------
! Computing of lumped rigidity matrix.
!----------------------------------------------------------
    implicit none
    integer:: nlayer,vnp
    double precision:: vra(vnp),mu(vnp),ra(*),hl(*)
    integer:: i,nn,snp
    double precision:: c(1),from,to

    snp = 1
    do  i=1,nlayer
        c(1) = 1.d0

        from = ra(i)
        to = ( ra(i) + ra(i+1) ) / 2.d0
        nn = 4 * (i-1)
        call pinteg( snp,1,c,from,to,vnp,vra,mu,hl(nn+1) )

        hl(nn+2:nn+3) = 0.d0

        from = to
        to = ra(i+1)
        call pinteg( snp,1,c,from,to,vnp,vra,mu,hl(nn+4) )

    enddo
    return
end

!----------------------------------------------------------
subroutine pmulti(n,a,m,b,l,c)
!----------------------------------------------------------
! Computing the (l-1) degrees polynomial c(n) which is the product of
! (n-1) degrees polynomial a(n) and (m-1) degrees polynomial b(n).
!----------------------------------------------------------
    integer:: n,m,l,i,j
    double precision:: a(n),b(m),c(l)

    if (n+m-1/=l) stop 'Invalid arguments.(pmulti)'

    c(1:l)=0.d0

    do i=1,n
        do j=1,m
            c(i+j-1) = c(i+j-1) + a(i)*b(j)
        enddo
    enddo

    return
end

!----------------------------------------------------------
subroutine pinteg(snp,n,p,from,to,vnp,vra,con,pint)
!----------------------------------------------------------
! Evaluating the integrated value pint from 'from' to 'to' of p(n)*con
! which is the product of (n-1) degrees polynomial 'p(n)' and 'con'.
!----------------------------------------------------------
    implicit none
    integer:: maxn
    parameter ( maxn = 5 )

    integer:: snp,n,vnp
    double precision:: from,to,p(n),vra(vnp),con(vnp),pint
    double precision:: x1,x2,q(2),pq(maxn+1),psint

    if ( maxn<n )stop 'Degrees of a polynomial is too large.(pinteg)'
    if ( snp>=vnp ) snp = 1

    pint = 0.d0
    x1 = from
    do
        if (  vra(snp)<=x1 .and. vra(snp+1)>x1  ) then
            x2 = dmin1( to, vra(snp+1) )
        else
            snp = snp + 1
            if ( snp==vnp ) snp = 1
            cycle
        endif
        ! evaluating the integrated value
        q(2) = ( con(snp+1)-con(snp) ) / ( vra(snp+1)-vra(snp) )
        q(1) = - q(2) * vra(snp) + con(snp)
        call pmulti( n,p,2,q,n+1,pq )
        call polint( n+1,pq,x1,x2,psint )
        pint = pint + psint

        if ( x2==to ) exit
        x1 = x2
    enddo
    return
end

!----------------------------------------------------------
subroutine polint( n,p,x1,x2,pint )
!----------------------------------------------------------
!c Evaluating the integrated value 'pint' from 'x1' to 'x2'
!c of (n-1) degrees polynomial 'p(n)'.
!----------------------------------------------------------
    implicit none
    integer,parameter:: maxn=6
    integer:: n
    double precision:: p(*),x1,x2,pint
    integer:: i,j
    double precision:: a(maxn),b(maxn),dx,xx

    if (maxn<n) stop 'Degrees of a polynomial is too large.(polint)'

    a(1) = 1.d0
    b(1) = 1.d0
    if ( n>=2 ) then
        do i=2,n
            a(i) = a(i-1) * x1
            b(i) = b(i-1) * x2
        enddo
    endif
    dx = x2 - x1

    pint = 0.d0
    do i=1,n
        xx = 0.d0
        do j=1,i
            xx = xx + a(j) * b(i-j+1) / dble(i)
        enddo
        pint = pint + p(i) * dx * xx
    enddo
    return
end

!----------------------------------------------------------
subroutine overlap( nlayer,a,a2 )
!----------------------------------------------------------
! Overlapping the coefficient matrix elements in the solid part.
!----------------------------------------------------------
    use parameters
    implicit none
    integer,intent(in):: nlayer
    complex(dp):: a(*),a2(2,*)
    integer:: i,j,k,mu,m,i1,i2,k1,k2,nsize

    nsize = nlayer+1
    mu = 1
    m = mu + 1
    do j=1,nsize
        i1 = max0(1,j-mu)
        i2 = j
        do i=i1,i2
            k = i - j + m
            if ( i==j ) then
                if ( i==1 ) then
                    a2(k,j) = a2(k,j) + a(1)
                else
                    if ( i==nsize ) then
                        a2(k,j) = a2(k,j) + a( 4*nlayer )
                    else
                        k1 = 4 * i - 4
                        k2 = k1 + 1
                        a2(k,j) = a2(k,j) + a(k1) + a(k2)
                    endif
                endif
            endif
            if (i+1==j) then
                k1 = 4 * i - 2
                a2(k,j) = a2(k,j) + a(k1)
            endif
        enddo
    enddo
    return
end

!----------------------------------------------------------
subroutine calg2( l,m,spo,r0,mt,mu0,coef,ga,a,ga2,dr,g2 )
!----------------------------------------------------------
    use parameters
    implicit none

    integer:: l,m
    double precision:: spo,r0,mt(3,3),mu0
    complex(dp) coef,ga(*),a(*),ga2(2,*),g2(*)
    integer:: i,itmp
    double precision:: b1,sgn,eps,ier
    complex(dp) dd,cg2(3),dr(3),z(3)

    data eps/ -1.d0 /

    ! computing of particular solution with free surface boundary conditions
    cg2=0
    dd = 0
    if ( m>=0 ) then
        sgn = 1.d0
    else
        sgn = - 1.d0
    endif
    if ( iabs(m)==1 ) then
        b1 = dsqrt( dble( 2*l+1 ) / ( 16.d0 * pi ) )
        !c
        dd = dcmplx( b1 ) * ( dcmplx( sgn * mt(1,3), mt(1,2) ) )/ ( dcmplx( r0 * r0 * mu0 ) * coef )
        itmp = 4
        cg2=0
        do  i=2,3
            cg2(i) = - dd * ( ga(itmp+1) + ga(itmp+2) )
            itmp = itmp + 2
        enddo
    else
        if ( iabs(m)==2 ) then
            b1 = dsqrt( dble(2*l+1)*dble(l-1)*dble(l+2)/(64.d0*pi) )
            cg2(2) = dcmplx( b1 / r0 ) * dcmplx( 2.d0*mt(2,3), sgn*( mt(2,2)-mt(3,3) ) )
        endif
    endif
    if ( m==-2 .or. m==-l ) then
        call dclisb0( ga2,3,1,2,cg2,eps,dr,z,ier)
    else
        call dcsbsub0( ga2,3,1,2,cg2,eps,dr,z,ier)
    endif
    cg2(3) = cg2(3) + dd
    ! computation of the excitation vector
    itmp = dint(spo)
    g2(itmp+1) = a(1) * cg2(1) + a(2) * cg2(3)
    g2(itmp+2) = a(3) * cg2(1) + a(4) * cg2(3)

    return
end

! calmat.f for wcalprem.f
!----------------------------------------------------------
subroutine calmatc( nlayer,vnp,vra,con,rpow,w1dn,w2dn,ra,m )
!----------------------------------------------------------
! Computing \int r^rpow con W_p^(w1dn) W_q^(w2dn) dr.
!----------------------------------------------------------
    implicit none
    integer,parameter:: maxrpow= 2
    integer,intent(in):: nlayer,vnp,rpow,w1dn,w2dn
    double precision,intent(in):: vra(vnp),con(vnp),ra(nlayer+1)
    double precision,intent(out)::m(4*nlayer)
    integer:: i,j,k,l,nn,snp
    double precision:: a(2,2),b(2,2),c(5),rh
    ! parameter check
    if (maxrpow<rpow ) stop 'Invalid arguments.(calmatc)'
    ! computing of the matrix elements
    snp = 1
    do i=1,nlayer
        rh = ra(i+1) - ra(i)
        if ( w1dn == 0 ) then
            a(2,1) = -1 / rh
            a(1,1) = ra(i+1) / rh
            a(2,2) = 1 / rh
            a(1,2) = -ra(i) / rh
        else
            if ( w1dn == 1 ) then
                a(2,1) = 0
                a(1,1) = -1 / rh
                a(2,2) = 0
                a(1,2) = 1 / rh
            else
                stop 'Invalid arguments.(calmatc)'
            endif
        endif
        if ( w2dn == 0 ) then
            b(2,1) = -1 / rh
            b(1,1) = ra(i+1) / rh
            b(2,2) = 1 / rh
            b(1,2) = -ra(i) / rh
        else
            if ( w2dn == 1 ) then
                b(2,1) = 0
                b(1,1) = -1 / rh
                b(2,2) = 0
                b(1,2) = 1 / rh
            else
                stop 'Invalid arguments.(calmatc)'
            endif
        endif
        do j=1,2
            do k=1,2
                c(1:5) = 0
                call pmulti( 2,a(1,j),2,b(1,k),3,c )
                do l=3,1,-1
                    c(l+rpow) = c(l)
                    if ( rpow>0 ) c(l)=0
                enddo
                nn = 4 * (i-1) + 2 * (j-1) + k
                call pinteg( snp,5,c,ra(i),ra(i+1),&
                    vnp,vra,con,m(nn) )
            enddo
        enddo
    enddo
    return
end

!----------------------------------------------------------
subroutine pmulti(n,a,m,b,l,c)
!----------------------------------------------------------
! Computing the (l-1) degrees polynomial c(n) which is the product of
! (n-1) degrees polynomial a(n) and (m-1) degrees polynomial b(n).
!----------------------------------------------------------
    implicit none
    integer,intent(in):: n,m,l
    integer:: i,j
    double precision:: a(n),b(m),c(l)

    if (n+m-1/=l) stop 'Invalid arguments.(pmulti)'
    c=0
    do i=1,n
        do j=1,m
            c(i+j-1) = c(i+j-1) + a(i)*b(j)
        enddo
    enddo
    return
end

!----------------------------------------------------------
subroutine pinteg(snp,n,p,from,to,vnp,vra,con,pint)
!----------------------------------------------------------
! Evaluating the integrated value pint from 'from' to 'to' of p(n)*con
! which is the product of (n-1) degrees polynomial 'p(n)' and 'con'.
!----------------------------------------------------------
    implicit none
    integer,parameter::maxn = 5
    integer:: snp,n,vnp
    double precision:: from,to,p(n),vra(vnp),con(vnp),pint
    double precision:: x1,x2,q(2),pq(maxn+1),psint

    if ( maxn<n ) stop 'Degrees of a polynomial is too large.(pinteg)'
    if ( vnp <=snp ) snp = 1

    pint = 0
    x1 = from

    do
        if ( vra(snp)<=x1 .and. vra(snp+1)>x1 ) then
            x2 = dmin1( to, vra(snp+1) )
        else
            snp = snp + 1
            if ( snp==vnp ) snp = 1
            cycle
        endif
        ! evaluating the integrated value
        q(2) = ( con(snp+1)-con(snp) ) / ( vra(snp+1)-vra(snp) )
        q(1) = - q(2) * vra(snp) + con(snp)
        call pmulti( n,p,2,q,n+1,pq )
        call polint( n+1,pq,x1,x2,psint )
        pint = pint + psint

        if ( x2==to ) then
            exit
        else
            x1 = x2
        endif
    enddo
    return
end

!----------------------------------------------------------
subroutine polint( n,p,x1,x2,pint )
!----------------------------------------------------------
! Evaluating the integrated value 'pint' from 'x1' to 'x2'
! of (n-1) degrees polynomial 'p(n)'.
!----------------------------------------------------------
    implicit none
    integer,parameter :: maxn = 6
    integer:: i,j,n
    double precision:: p(*),x1,x2,pint
    double precision:: a(maxn),b(maxn),dx,xx

    if (maxn<n ) stop 'Degree of a polynomial is too large.(polint)'

    a(1) = 1
    b(1) = 1
    if ( 2<=n ) then
        do i=2,n
            a(i) = a(i-1) * x1
            b(i) = b(i-1) * x2
        enddo
    endif
    dx = x2 - x1

    pint = 0
    do i=1,n
        xx = 0
        do j=1,i
            xx = xx + a(j) * b(i-j+1) / dble(i)
        enddo
        pint = pint + p(i) * dx * xx
    enddo
    return
end

!----------------------------------------------------------
subroutine caltl( nlayer,vnp,vra,rho,ra,tl)
!----------------------------------------------------------
! Computing of lumped mass matrix.
!----------------------------------------------------------
    implicit none
    integer:: nlayer,vnp
    double precision:: vra(vnp),rho(vnp),ra(nlayer+1),tl(4*nlayer)
    integer:: i,nn,snp
    double precision:: c(3),from,to

    snp = 1
    do i=1,nlayer
        c(1) = 0
        c(2) = 0
        c(3) = 1

        from = ra(i)
        to = ( ra(i) + ra(i+1) ) / 2
        nn = 4 * (i-1)
        call pinteg( snp,3,c,from,to,vnp,vra,rho,tl(nn+1) )

        tl(nn+2) = 0
        tl(nn+3) = 0

        from = to
        to = ra(i+1)
        call pinteg( snp,3,c,from,to,vnp,vra,rho,tl(nn+4) )
    enddo
    return
end

!----------------------------------------------------------
subroutine calhl( nlayer,vnp,vra,mu,ra,hl)
!----------------------------------------------------------
! Computing of lumped rigidity matrix.
!----------------------------------------------------------
    implicit none
    integer:: nlayer,vnp
    double precision:: vra(vnp),mu(vnp),ra(nlayer+1),hl(4*nlayer)
    integer:: i,nn,snp
    double precision:: c(1),from,to

    snp = 1
    do i=1,nlayer
        c(1) = 1
        from = ra(i)
        to = ( ra(i) + ra(i+1) ) / 2
        nn = 4 * (i-1)
        call pinteg( snp,1,c,from,to,vnp,vra,mu,hl(nn+1) )

        hl(nn+2) = 0
        hl(nn+3) = 0

        from = to
        to = ra(i+1)
        call pinteg( snp,1,c,from,to,vnp,vra,mu,hl(nn+4) )
    enddo
    return
end

!----------------------------------------------------------
subroutine calh5( nlayer,vra,con,ra,h5 )
!----------------------------------------------------------
! Computation of the submatrix `h5'.
!----------------------------------------------------------
    implicit none
    integer:: nlayer
    double precision:: vra(*),con(*),ra(nlayer+1),h5(4*nlayer)
    integer:: itmp,i

    ! Data initialization
    h5(1:4*nlayer)=0

    itmp = 0
    do
        itmp = itmp + 1
        if ( vra(itmp)==ra(1) ) then
            if ( vra(itmp+1)==vra(itmp) ) itmp = itmp + 1
            exit
        endif
    enddo
    itmp = itmp - 1

    do i=1,nlayer
        itmp = itmp + 1
        h5(4*i-3) = - 3.d0 / 8.d0 * con(itmp) * ra(i) - 1.d0 / 8.d0 * con(itmp+1) * ra(i+1)
        h5(4*i-2) = - h5(4*i-3)
        h5(4*i-1) = - 1.d0 / 8.d0 * con(itmp) * ra(i) - 3.d0 / 8.d0 * con(itmp+1) * ra(i+1)
        h5(4*i)   = - h5(4*i-1)
    enddo
    return
end

!----------------------------------------------------------
subroutine calhm1( nlayer,vra,con,ra,hm1 )
!----------------------------------------------------------
! Computing the modified submatrix `hm1'.
!----------------------------------------------------------
    implicit none
    integer:: nlayer
    double precision:: vra(nlayer),con(nlayer+1),ra(nlayer+1),hm1(-1:2,nlayer+1)
    integer:: itmp,i

    hm1=0
    itmp = 0
    do
        itmp = itmp + 1
        if ( vra(itmp)==ra(1) ) then
            if ( vra(itmp+1)==vra(itmp) ) itmp = itmp + 1
            exit
        endif
    enddo
    hm1(0,1) = hm1(0,1) - 7.d0 / 12.d0 * con(itmp) * ra(1)
    hm1(1,1) = hm1(1,1) + 8.d0 / 12.d0 * con(itmp) * ra(1)
    hm1(2,1) = hm1(2,1) - 1.d0 / 12.d0 * con(itmp) * ra(1)
    do i=2,nlayer-1
        itmp = itmp + 1
        hm1(-1,i) = hm1(-1,i) - 5.d0 / 12.d0 * con(itmp) * ra(i)
        hm1( 0,i) = hm1( 0,i) - 3.d0 / 12.d0 * con(itmp) * ra(i)
        hm1( 1,i) = hm1( 1,i) + 9.d0 / 12.d0 * con(itmp) * ra(i)
        hm1( 2,i) = hm1( 2,i) - 1.d0 / 12.d0 * con(itmp) * ra(i)
    enddo
    itmp = itmp + 1
    hm1(-1,nlayer) = hm1(-1,nlayer) - 5.d0 / 12.d0 * con(itmp) * ra(nlayer)
    hm1( 0,nlayer) = hm1( 0,nlayer) - 3.d0 / 12.d0 * con(itmp) * ra(nlayer)
    hm1( 1,nlayer) = hm1( 1,nlayer) + 8.d0 / 12.d0 * con(itmp) * ra(nlayer)
    itmp = itmp + 1
    hm1(-1,nlayer+1) = hm1(-1,nlayer+1) - 5.d0 / 12.d0 * con(itmp) * ra(nlayer+1)
    hm1( 0,nlayer+1) = hm1( 0,nlayer+1) + 5.d0 / 12.d0 * con(itmp) * ra(nlayer+1)
    return
end

!----------------------------------------------------------
subroutine calhm2( nlayer,vra,con,ra,hm2 )
!----------------------------------------------------------
! Computing the modified submatrix `hm2'.
!----------------------------------------------------------
    implicit none
    integer ::nlayer
    double precision:: vra(nlayer),con(nlayer+1),ra(nlayer+1),hm2(-2:1,nlayer+1)
    integer ::itmp,i
    hm2=0
    itmp = 0
    do
        itmp = itmp + 1
        if ( vra(itmp)==ra(1) ) then
            if ( vra(itmp+1)==vra(itmp) ) itmp = itmp + 1
            exit
        endif
    enddo
    hm2(0,1) = hm2(0,1) - 5.d0 / 12.d0 * con(itmp) * ra(1)
    hm2(1,1) = hm2(1,1) + 5.d0 / 12.d0 * con(itmp) * ra(1)
    itmp = itmp + 1
    hm2(-1,2) = hm2(-1,2) - 8.d0 / 12.d0 * con(itmp) * ra(2)
    hm2( 0,2) = hm2( 0,2) + 3.d0 / 12.d0 * con(itmp) * ra(2)
    hm2( 1,2) = hm2( 1,2) + 5.d0 / 12.d0 * con(itmp) * ra(2)
    do i=3,nlayer
        itmp = itmp + 1
        hm2(-2,i) = hm2(-2,i) + 1.d0 / 12.d0 * con(itmp) * ra(i)
        hm2(-1,i) = hm2(-1,i) - 9.d0 / 12.d0 * con(itmp) * ra(i)
        hm2( 0,i) = hm2( 0,i) + 3.d0 / 12.d0 * con(itmp) * ra(i)
        hm2( 1,i) = hm2( 1,i) + 5.d0 / 12.d0 * con(itmp) * ra(i)
    enddo
    itmp = itmp + 1
    hm2(-2,nlayer+1) = hm2(-2,nlayer+1) + 1.d0 / 12.d0 * con(itmp) * ra(nlayer+1)
    hm2(-1,nlayer+1) = hm2(-1,nlayer+1) - 8.d0 / 12.d0 * con(itmp) * ra(nlayer+1)
    hm2( 0,nlayer+1) = hm2( 0,nlayer+1) + 7.d0 / 12.d0 * con(itmp) * ra(nlayer+1)
    return
end

!----------------------------------------------------------
subroutine mtrnp(nlayer,a1,a2)
!----------------------------------------------------------
! Computing 'a2' which is the transpose of 'a1'.
!----------------------------------------------------------
    implicit none
    integer:: nlayer
    double precision,intent(in):: a1(4*nlayer)
    double precision,intent(out):: a2(4*nlayer)
    integer:: i,nn

    nn = 4 * nlayer

    a2(1:nn-3:4) = a1(1:nn-3:4)
    a2(2:nn-2:4) = a1(3:nn-1:4)
    a2(3:nn-1:4) = a1(2:nn-2:4)
    a2(4:nn:4) = a1(4:nn:4)

    return
end

!----------------------------------------------------------
subroutine mtrnp2( nlayer,p,q,hm1,hm2 )
!----------------------------------------------------------
    implicit none
    integer::nlayer,p,q
    double precision,intent(in):: hm1(-p:q,nlayer+1)
    double precision,intent(out)::hm2(-q:p,nlayer+1)
    integer::i,j,m,n

    do i=-q,p
        do j=1,nlayer+1
            m = -i
            n = i + j
            if ( n>=1 .and. n<=nlayer+1 ) hm2(i,j) = hm1(m,n)
        enddo
    enddo

    return
end

!----------------------------------------------------------
subroutine calcoef( nzone,omega,qmu,qkappa,coef1,coef2,coef )
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nzone
    double precision,intent(in):: omega,qmu(nzone),qkappa(nzone)
    complex(dp),intent(out):: coef1(nzone),coef2(nzone),coef(nzone)
    integer:: i
    double precision:: aa,bb

    ! evaluating the effect of anelasticity
    do i=1,nzone
        if ( qmu(i)<=0 ) then
            coef1(i) = 1
        else
            if ( omega==0 ) then
                aa = 1
            else
                aa = 1  + dlog( omega / ( 2.d0 * pi ) ) / ( pi * qmu(i) )
            endif
            bb = 1 / ( 2 * qmu(i) )
            coef1(i) = dcmplx( aa, bb ) * dcmplx( aa, bb )
        endif
        if ( qkappa(i)<=0.d0 ) then
            coef2(i) =  1
            coef(i) =  1  / coef2(i)
        else
            if ( omega==0.d0 ) then
                aa = 1.d0
            else
                aa = 1.d0  + dlog( omega / ( 2.d0 * pi ) ) / ( pi * qkappa(i) )
            endif
            bb = 1 / ( 2 * qkappa(i) )
            coef2(i) = dcmplx( aa, bb ) * dcmplx( aa, bb )
            coef(i) =  1  / coef2(i)
        endif
    enddo
    return
end

!----------------------------------------------------------
subroutine cala0( nlayer,omega,omegai,t,h1x,h2L,h2N,&
    h3ay,h4aL,h4aN,h5ay,h6aL,h6aN,&
    h7y,h7z,h8L,h8N,coef1,coef2,a0 )
    use parameters
    implicit none
!----------------------------------------------------------
! Computing the coefficient matrix 'a' in the solid part.
!----------------------------------------------------------
    integer:: nlayer
    double precision,intent(in):: omega,omegai
    double precision,intent(in):: t(4*nlayer)
    double precision,intent(in):: h1x(4*nlayer),h2L(4*nlayer),h2N(4*nlayer)
    double precision,intent(in):: h3ay(4*nlayer),h4aL(4*nlayer),h4aN(4*nlayer)
    double precision,intent(in):: h5ay(4*nlayer),h6aL(4*nlayer),h6aN(4*nlayer)
    double precision,intent(in):: h7y(4*nlayer),h7z(4*nlayer),h8L(4*nlayer),h8N(4*nlayer)
    complex(dp),intent(in):: coef1,coef2
    complex(dp),intent(out):: a0(16*nlayer)
    integer:: i,nnn
    double precision:: tt
    complex(dp)::hh0,comega2
    !
    a0( 1:16*nlayer)=0
    comega2 = dcmplx( omega, -omegai ) * dcmplx( omega, -omegai )
    do i=1,16*nlayer-3,4
        nnn = ( i + 3 ) / 4
        if ( mod(nnn,4)==3 ) cycle
        tt = t(nnn)
        hh0 = coef2 *  4.d0 * h1x(nnn) & !4A
            + coef1 *  16.d0/3.d0 * h2N(nnn) & !4A
            - coef1 *  4.d0 * h2N(nnn) & !-4N
            + coef2 *  2.d0 * ( h3ay(nnn) + h5ay(nnn) ) & !2F
            - coef1 *  4.d0/3.d0 * ( h4aN(nnn) + h6aN(nnn) ) &
            + coef2 * ( 3.d0 *h7z(nnn) -2.d0*h7y(nnn) )& !C
            + coef1 *  4.d0/3.d0 * h8N(nnn)  !C
        a0(i) = comega2 * tt  - hh0
    enddo
    do i=4,16*nlayer,4
        nnn = i / 4
        if ( mod(nnn,4)==3 ) cycle
        tt = t(nnn)
        hh0 = coef1 *    h2L(nnn)  &!L
            + coef1 * ( -2.d0 * h2N(nnn) )& !-2N
            - coef1 *  (h4aL(nnn) + h6aL(nnn) )& !-L
            + coef1 *  h8L(nnn)  !L
        a0(i) = comega2 *  tt  - hh0
    enddo
    return
end

!----------------------------------------------------------
subroutine cala1( nlayer,h1x,h2L,h2N,h3y,&
    h4L,h4N,h5y,h6L,h6N,coef1,coef2,a1 )
!----------------------------------------------------------
! Computing the coefficient matrix 'a' in the solid part.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    double precision,intent(in):: h1x(4*nlayer),h2L(4*nlayer),h2N(4*nlayer)
    double precision,intent(in):: h3y(4*nlayer),h4L(4*nlayer),h4N(4*nlayer)
    double precision,intent(in):: h5y(4*nlayer),h6L(4*nlayer),h6N(4*nlayer)
    complex(dp):: coef1,coef2
    complex(dp),intent(out):: a1(16*nlayer)
    integer:: i,nnn
    complex(dp):: hh1

    a1( 1:16*nlayer )=0
    do i=2,16*nlayer-2,4
        nnn = ( i + 2 ) / 4
        if ( mod(nnn,4)==3 ) cycle
        hh1 = - coef2 * ( 2.d0 * h1x(nnn) )&  !2A
            - coef1 * ( 8.d0/3.d0 * h2N(nnn) ) &!2A
            - coef1 * ( h2L(nnn) )& !L
            - coef1 * ( -2.d0 * h2N(nnn) ) &!-2N
            - coef2 * ( h3y(nnn) )& !F
            - coef1 * ( -2.d0/3.d0 * h4N(nnn) ) &!F
            + coef1 * ( h6L(nnn) ) !-L
        a1(i) = - hh1
    enddo
    do i=3,16*nlayer-1,4
        nnn = ( i + 1 ) / 4
        if ( mod(nnn,4)/=2 ) cycle
        hh1 = - coef2 * ( 2.d0 * h1x(nnn) )& !2A
            - coef1 * ( 8.d0/3.d0 * h2N(nnn) ) & !2A
            - coef1 * ( -2.d0 * h2N(nnn) )& !-2N
            - coef1 *   h2L(nnn)  & !L
            + coef1 *  h4L(nnn)  & !-L
            - coef2 *  h5y(nnn) & !F
            + coef1 * ( 2.d0/3.d0 * h6N(nnn) ) !F
        a1(i) = - hh1
    enddo
    return
end

!----------------------------------------------------------
subroutine cala2( nlayer,h1x,h2L,h2N,coef1,coef2,a2 )
!----------------------------------------------------------
! Computing the coefficient matrix 'a' in the solid part.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    double precision,intent(in):: h1x(4*nlayer),h2L(4*nlayer),h2N(4*nlayer)
    complex(dp),intent(in):: coef1,coef2
    complex(dp),intent(out):: a2(16*nlayer)
    integer:: i,nnn
    complex(dp):: hh2

    a2( 1:16*nlayer)=0
    do i=1,16*nlayer-3,4
        nnn = ( i + 3 ) / 4
        if ( mod(nnn,4)==3 ) cycle
        hh2 = coef1 * h2L(nnn)
        a2(i) = - hh2
    enddo

    do i=4,16*nlayer,4
        nnn = i / 4
        if ( mod(nnn,4)==3 ) cycle
        hh2 = coef2 *  h1x(nnn) + coef1 * ( 4.d0/3.d0 * h2N(nnn) )
        a2(i) = - hh2
    enddo
    return
end

!----------------------------------------------------------
subroutine calb0( nlayer,omega,omegai,p1,p3,coef,b0 )
!----------------------------------------------------------
! Computing the coefficient matrix 'b' in the solid part.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    double precision,intent(in):: omega,omegai,p1(4*nlayer),p3(4*nlayer)
    complex(dp),intent(in):: coef
    complex(dp),intent(out)::b0(4*nlayer)
    integer:: i
    complex(dp):: comega2

    b0( 1:4*nlayer )=0
    comega2 = dcmplx( omega, -omegai ) * dcmplx( omega, -omegai )

    do i=1,nlayer
        b0(i*4-3) = -  p1(i*4-3)  / comega2  + coef * p3(i*4-3)
        b0(i*4-2) = -  p1(i*4-2)  / comega2  + coef * p3(i*4-2)
        b0(i*4) = - p1(i*4)  / comega2  + coef * p3(i*4)
    enddo
    return
end

!----------------------------------------------------------
subroutine calb2( nlayer,omega,omegai,p2,b2 )
!----------------------------------------------------------
! Computing the coefficient matrix 'b' in the solid part.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    double precision,intent(in):: omega,omegai,p2(4*nlayer)
    complex(dp),intent(out):: b2(4*nlayer)
    integer:: i
    complex(dp):: comega2

    b2( 1:4*nlayer )=0
    comega2 = dcmplx( omega, -omegai ) * dcmplx( omega, -omegai )

    do i=1,nlayer
        b2(i*4-3) = - p2(i*4-3) / comega2
        b2(i*4-2) = - p2(i*4-2) / comega2
        b2(i*4) = - p2(i*4) / comega2
    enddo
    return
end

!----------------------------------------------------------
subroutine calhml( nlayer,coef1,coef2,h3my,h5my,h4m1L,h4m2N,h6m1N,h6m2L,a1 )
!----------------------------------------------------------
! Summing up the modified first derivatives matrix operators.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    double precision,intent(in):: h3my(-2:1,nlayer+1),h5my(-1:2,nlayer+1)
    double precision,intent(in):: h4m1L(-1:2,nlayer+1),h4m2N(-2:1,nlayer+1)
    double precision,intent(in):: h6m1N(-1:2,nlayer+1),h6m2L(-2:1,nlayer+1)
    complex(dp),intent(in):: coef1,coef2
    complex(dp),intent(out)::a1(4,2*nlayer+2)
    integer:: i,j,m,n

    do j=2,2*(nlayer+1),2
        do i=1,3,2
            if ( i==1 .and. j==2 ) cycle
            m = (-i+3)/2
            n = (i+j-3)/2
            a1(i,j) = a1(i,j)&
                - ( - coef2 *  h3my(m,n) & !-F
                + coef1 * ( 2.d0/3.d0 * h4m2N(m,n) )&
                + coef1 * ( h6m2L(m,n) ) )!L
        enddo
    enddo
    do j=3,2*nlayer+1,2
        do i=1,3,2
            if ( i==1 .and. j==3 ) cycle
            m = (-i+5)/2
            n = (i+j-4)/2
            a1(i,j) = a1(i,j)&
                - (   coef1 * ( h4m1L(m,n) ) &!L
                - coef2 * ( h5my(m,n) ) &!-F
                + coef1 * ( 2.d0/3.d0 * h6m1N(m,n) ) )
        enddo
    enddo
    return
end

!----------------------------------------------------------
subroutine overlapa(nlayer,a,a2)
!----------------------------------------------------------
! Overlapping the coefficient matrix elements in the solid part.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    complex(dp),intent(in):: a(16*nlayer)
    complex(dp),intent(out)::a2(4,2*nlayer+2)
    integer:: i,nsize,msize,n1,n2

    nsize = 2 * ( nlayer + 1 )
    msize = 16 * nlayer

    a2(1:4,1:nsize)=0

    a2(4,1) = a(1)
    a2(3,2)  = a(2)
    a2(4,2)  = a(4)
    a2(4,nsize-1) = a(msize-3)
    a2(3,nsize)   = a(msize-2)
    a2(4,nsize)   = a(msize)
    do i=3,nsize-1,2
        n1 = 16 * (i-3)/2 + 5
        a2(2,i) = a(n1)
        n1 = n1 + 2
        a2(3,i) = a(n1)
        if ( i/=nsize-1 ) then
            n1 = n1 + 6
            n2 = n1 + 4
            a2(4,i) = a(n1) + a(n2)
        endif
    enddo
    do i=4,nsize,2
        n1 = 16 * (i-4)/2 + 6
        a2(1,i) = a(n1)
        n1 = n1 + 2
        a2(2,i) = a(n1)
        if ( i/=nsize ) then
            n1 = n1 + 6
            n2 = n1 + 4
            a2(3,i) = a(n1) + a(n2)
            n1 = n1 + 2
            n2 = n1 + 4
            a2(4,i) = a(n1) + a(n2)
        endif
    enddo
    return
end

!----------------------------------------------------------
subroutine overlapb(nlayer,b,b2)
!----------------------------------------------------------
! Overlapping the coefficient matrix elements in the liquid part.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: nlayer
    complex(dp)::b(4*nlayer),b2(4,nlayer+1)
    integer:: i,n1,n2

    b2(1:4,1:nlayer+1)=0

    b2(4,1) = b(1)
    do i=2,nlayer
        b2(4,i) = b( 4 * ( i - 1 )) + b( 4 * ( i - 1 )+1)
    enddo
    b2(4,nlayer+1) = b(4*nlayer)

    do i=2,nlayer+1
        b2(3,i) = b(4 * ( i - 2 ) + 2)
    enddo
    return
end

!----------------------------------------------------------
subroutine cala( ndc,iphase,nlayer,kkdr,kdr,ksp,&
        l2,lsq,nn,a0,a1,a2,a )
!----------------------------------------------------------
    use parameters
    implicit none
    integer,intent(in):: ndc,iphase(ndc+1)
    integer,intent(in):: nlayer(maxnzone)
    integer,intent(in):: kkdr(ndc+1),kdr,ksp(maxnzone),nn
    double precision,intent(in):: l2,lsq
    complex(dp),intent(in):: a0(4,*),a1(4,*),a2(4,*)
    complex(dp),intent(out)::a(4,nn)
    integer:: j,isl,ill,ii,jj,mtmp,i1,i2
    ! --- Initializing the matrix elements
    a(1:4,1:nn)=0

    isl = 0
    ill = 0
    do j=1,ndc+1
        if ( iphase(j)==1 ) then
            isl = isl + 1
            i1 = kkdr(j)
            i2 = kkdr(j)+2*nlayer(j)+1
            do jj=i1,i2
                mtmp = kdr+ksp(j)+jj-kkdr(j)
                a(2:4:2,jj) = a(2:4:2,jj) + a0(2:4:2,mtmp)+ l2*a2(2:4:2,mtmp)
                a(1:3:2,jj) = a(1:3:2,jj) + lsq*a1(1:3:2,mtmp)
            enddo
        else
            ill = ill + 1
            i1 = kkdr(j)
            i2 = kkdr(j)+nlayer(j)
            do jj=i1,i2
                mtmp = kdr+ksp(j)+jj-kkdr(j)
                a(3:4,jj)=a(3:4,jj)+a0(3:4,mtmp)+l2*a2(3:4,mtmp)
            enddo
        endif
    enddo
    return
end

!----------------------------------------------------------
subroutine calbc( ndc,rdc,iphase,kkdr,a )
!----------------------------------------------------------
! Computing the boundary condition elements.
!----------------------------------------------------------
    use parameters
    implicit none
    integer:: ndc,iphase(ndc+1),kkdr(ndc+1)
    double precision,intent(in):: rdc(ndc+1)
    complex(dp),intent(out):: a(4,*)
    integer:: i

    do i=1,ndc
        if ( iphase(i)==1 .and. iphase(i+1)==2 )  a( 2,kkdr(i+1) ) =   rdc(i) * rdc(i)
        if ( iphase(i)==2 .and. iphase(i+1)==1 )  a( 3,kkdr(i+1) ) = -  rdc(i) * rdc(i)
    enddo
    return
end

!----------------------------------------------------------
subroutine calabnum( omega,omegai,rmax,rrho,vpv,vph,vsv,vsh,eta,&
    ra,r0,coef1,coef2,anum,bnum )
!----------------------------------------------------------
    use parameters
    implicit none
    double precision:: omega,omegai,rmax
    double precision:: rrho(4),vpv(4),vph(4),vsv(4),vsh(4),eta(4)
    double precision:: ra(2),r0
    complex(dp):: coef1,coef2,anum(4,4,10),bnum(4,4,10)
    integer:: i,j,k
    double precision:: trho,tmu,tecA,tecC,tecL,tecN,tAkappa,tCkappa
    double precision:: tvpv,tvph,tvsv,tvsh,teta,coef,r,r2
    complex(dp):: xrho,xecA,xecC,xecF,xecL,xecN
    complex(dp):: xmu,xFdC,xAmF2dC
    complex(dp):: xAkappa,xCkappa,comega2

    anum(1:4,1:4,1:10) =  0
    bnum(1:4,1:4,1:10) =  0
    ! computation of mu,lam and rho at r
    do i=1,10
        if ( i<=5 ) then
            r = ra(1) + (i-1) / 4.d0 * ( r0 - ra(1) )
        else
            r = ra(2) - (10-i) / 4.d0 * ( ra(2) - r0 )
        endif
        trho = 0
        tvpv = 0
        tvph = 0
        tvsv = 0
        tvsh = 0
        teta = 0
        do j=1,4
            if ( j==1 ) then
                coef = 1
            else
                coef = coef * ( r / rmax )
            endif
            trho = trho + rrho(j) * coef
            tvpv = tvpv + vpv(j) * coef
            tvph = tvph + vph(j) * coef
            tvsv = tvsv + vsv(j) * coef
            tvsh = tvsh + vsh(j) * coef
            teta = teta + eta(j) * coef
        enddo
        tecA = trho * tvph * tvph
        tecC = trho * tvpv * tvpv
        tecL = trho * tvsv * tvsv
        tecN = trho * tvsh * tvsh
        tmu  = trho * tvsv * tvsv

        tAkappa = tecA - tmu * 4.d0 / 3.d0
        tCkappa = tecC - tmu * 4.d0 / 3.d0
        xAkappa = tAkappa * coef2
        xCkappa = tCkappa * coef2
        xrho = trho
        xmu  = tmu *coef1
        xecL = tecL * coef1
        xecN = tecN * coef1
        xecA = xAkappa + 4.d0 / 3.d0*xmu
        xecC = xCkappa + 4.d0 / 3.d0*xmu
        xecF = teta * ( xecA - 2 * xecL )
        xFdC = xecF / xecC
        xAmF2dC = xecA - xecF * xFdC

        r2 = r * r
        comega2 = dcmplx( omega, -omegai ) * dcmplx( omega, -omegai )

        anum(1,1,i) = -  2 / r  * xFdC
        anum(1,2,i) =    1 / xecC
        anum(2,1,i) = - xrho * comega2   +  4 / r2  * ( xAmF2dC - xecN )
        anum(2,2,i) =   2 / r  * ( xFdC - 1 )
        anum(3,1,i) = - 1 / r
        anum(3,3,i) =   1 / r
        anum(3,4,i) =   1 / xecL
        anum(4,1,i) = - 2 / r2  * ( xAmF2dC - xecN )
        anum(4,2,i) = - xFdC / r
        anum(4,3,i) = - xrho * comega2 -  2 / r2  * xecN
        anum(4,4,i) = - 3 / r
        bnum(1,3,i) =   xFdC / r
        bnum(2,3,i) = - 2 / r2  * ( xAmF2dC - xecN )
        bnum(2,4,i) =   1 / r
        bnum(4,3,i) =   xAmF2dC / r2
    enddo
    return
end

!----------------------------------------------------------
subroutine calya( aa,bb,l2,ra,r0,ya,yb,yc,yd )
!----------------------------------------------------------
! Computing the excitation vector using Geller and Hatori(1995).
!                                1995.7     N.Takeuchi
! 2020.5 K.Konishi
!----------------------------------------------------------
    use parameters
    implicit none
    common a,b,cl2,itmp
    external eqmotion1
! ---------------------------<< variables >>---------------------------
! variables for the source
    double precision:: r0
! variables for the numerical integration
    integer:: i,k,itmp
    double precision:: l2,cl2
    complex(dp):: ya(4),yb(4),yc(4),yd(4),yn(4)
    double precision:: xs,xe,dr,ra(2)
    complex(dp):: work(4,2),aa(160),bb(160),a(64),b(64)
    integer ktmp1,ktmp2,ktmp3,ktmp4

    ! -----------------------<< common variables >>-----------------------
    cl2 = l2
    ! ---------------------<< numerical integration >>---------------------
    ! integration from the lower boundary
    ya=0
    ya(2) = 1
    yb=0
    yb(4) = 1
    dr = ( r0 - ra(1) ) / 2.d0
    if ( dr>0.d0 ) then
        xs = ra(1)
        do  k=1,2
            ktmp1 = 32 * ( k-1 )
            ktmp2 = ktmp1 - 16
            do i=1,64
                if ( i<=32 ) then
                    a(i) = aa(i+ktmp1)
                    b(i) = bb(i+ktmp1)
                else
                    a(i) = aa(i+ktmp2)
                    b(i) = bb(i+ktmp2)
                endif
            enddo
            itmp = 0
            xe = xs + dr
            call rk3(4,xs,xe,1,ya,yn,4,work)
            itmp = 0
            xs = xe - dr
            call rk3(4,xs,xe,1,yb,yn,4,work)
        enddo
    endif
! integration from the upper boundary
    yc = 0
    yc(2) = 1
    yd = 0
    yd(4) = 1
    dr = ( ra(2) - r0 ) / 2.d0
    if ( dr>0 ) then
        xs = ra(2)
        do k=1,2
            ktmp1 = 144 - 32 * ( k-1 )
            ktmp2 = ktmp1 - 32
            ktmp3 = ktmp1 - 48
            ktmp4 = ktmp1 - 80
            do i=1,64
                if ( i<=32 ) then
                    if ( i<=16 ) then
                        a(i) = aa(i+ktmp1)
                        b(i) = bb(i+ktmp1)
                    else
                        a(i) = aa(i+ktmp2)
                        b(i) = bb(i+ktmp2)
                    endif
                else
                    if ( i<=48 ) then
                        a(i) = aa(i+ktmp3)
                        b(i) = bb(i+ktmp3)
                    else
                        a(i) = aa(i+ktmp4)
                        b(i) = bb(i+ktmp4)
                    endif
                endif
            enddo
            itmp = 0
            xe = xs - dr
            call rk3(4,xs,xe,1,yc,yn,4,work)
            itmp = 0
            xs = xe + dr
            call rk3(4,xs,xe,1,yd,yn,4,work)
        enddo
    endif
end

!----------------------------------------------------------
subroutine calg( l,m,coef1,coef2,lsq,ecC0,ecF0,ecL0,ya,yb,yc,yd,ra,r0,mt,g )
!----------------------------------------------------------
! Computing the excitation vector using Geller and Hatori(1995).
!                                1995.7     N.Takeuchi
! changed 2020,5 K.Konishi
!----------------------------------------------------------
    use parameters
    implicit none
! ---------------------------<< variables >>---------------------------
! variables for the structure
    complex(dp),intent(in):: coef1,coef2
! variables for the source
    double precision:: r0,mt(3,3),ecC0,ecF0,ecL0
    complex(dp):: dd,ee,s1,s2,s(4)
! variables for the numerical integration
    integer l,m
    complex(dp):: ya(4),yb(4),yc(4),yd(4)
    complex(dp),intent(out):: g(4)
    double precision:: ra(2)
    ! other variables
    integer ip(4),ier,i
    complex(dp):: a(4,4),b(4),wk(4),xtmp
    double precision:: eps,sgn,b1,b2,lsq,r03,dtmp(4)
    data eps / -1.d0 /

! ---------------------<< parameter computation >>---------------------
! computation of the discontinuity
    if ( m>=0 ) then
        sgn = 1
    else
        sgn = -1
    endif
    b1 = dsqrt( (2*l+1)/pi/16 )
    if ( l/=0 ) b2 = dsqrt( (2*l+1d0)*(l-1)*(l+2)/pi/64 )

    if ( iabs(m)==2 ) then
        dd = 0
        ee = 0
    endif
    if ( iabs(m)==1 ) then
        dd = 0
        ee = dcmplx( - b1 * sgn * mt(1,2), b1 * mt(1,3) ) / ( r0 * r0 * ecL0 * coef1 )
    endif
    if ( m==0 ) then
        dd = dcmplx( 2.d0 * b1 * mt(1,1) / ( r0 * r0 ) ) &
            / ( ( ecC0 - 4.d0 / 3.d0 * ecL0 ) * coef2 + 4.d0/3.d0*ecL0 * coef1 )
        ee = 0
    endif

    if ( m==0 ) then
        r03 = r0 * r0 * r0
        xtmp = ( ( ecF0 + 2.d0 / 3.d0 * ecL0) * coef2 &
            - 2.d0 / 3.d0 * ecL0 * coef1 )&
            / ( (ecC0 - 4.d0 / 3.d0 * ecL0)* coef2 &
            + 4.d0 / 3.d0 * ecL0 * coef1 )
        s1 = - 2.d0 * b1 * ( mt(2,2) + mt(3,3) ) / r03  +  4.d0 * b1 * mt(1,1) / r03 * xtmp
        s2 =  b1 * lsq * ( mt(2,2) + mt(3,3) ) / r03  -  2.d0 * b1 * lsq * mt(1,1) / r03 * xtmp
    endif
    if ( iabs(m)==1 ) then
        s1 =  0
        s2 =  0
    endif
    if ( iabs(m)==2 ) then
        r03 = r0 * r0 * r0
        s1 = 0
        s2 = b2*dcmplx( mt(3,3)- mt(2,2), sgn * 2.d0 * mt(2,3) ) /r03
    endif
    s(1) = dd
    s(2) = s1
    if ( l/=0 ) then
        s(3) = ee/lsq
        s(4) = s2/lsq
    else
        s(3:4) =  0
    endif
! consideration of the boundary conditions
! determination of the analytical solution
    if ( l/=0 ) then
        call sab1( ya,yb,yc,yd,s,a,b )
        call glu(a,4,4,b,eps,wk,ip,ier)
    else
        call sab2( ya,yc,s,a,b )
        call glu(a,2,4,b,eps,wk,ip,ier)
        b(3) = b(2)
        b(2) = 0
        b(4) = 0
    endif
! computation of the excitation vector
    dtmp(1) = - ra(1) * ra(1)
    dtmp(2) = dtmp(1) * lsq
    dtmp(3) = ra(2) * ra(2)
    dtmp(4) = dtmp(3) * lsq

    g(1:4) = b(1:4)*dtmp(1:4)

end

!----------------------------------------------------------
subroutine eqmotion1(r,y,f)
!----------------------------------------------------------
! Equation of the motion of the solid medium.
!----------------------------------------------------------
    use parameters
    implicit none
    common a,b,l2,itmp
    double precision:: r,l2
    complex(dp):: y(4),f(4)
    integer i,j,itmp,mtmp
    complex(dp):: a(64),b(64),c(4,4)

! computation of itmp
    itmp = itmp + 1
! computation of the differential coefficients
    mtmp = 16 * ( itmp - 1 )
    do j=1,4
        do i=1,4
            mtmp = mtmp + 1
            c(i,j) = a(mtmp) + l2*b(mtmp)
        enddo
    enddo
    do i=1,4
        f(i) = 0
        do j=1,4
            f(i) = f(i) + c(i,j) * y(j)
        enddo
    enddo
    return
end

!----------------------------------------------------------
subroutine sab1( ya,yb,yc,yd,s,a,b )
!----------------------------------------------------------
! determination of the matrix imposing the boundary conditions.
!----------------------------------------------------------
    use parameters
    implicit none
    complex(dp),intent(in):: ya(4),yb(4),yc(4),yd(4),s(4)
    complex(dp),intent(out):: a(4,4),b(4)
    integer i

    a(1:4,1) = - ya(1:4)
    a(1:4,2) = - yb(1:4)
    a(1:4,3) =   yc(1:4)
    a(1:4,4) =   yd(1:4)
    b(1:4) = s(1:4)
    return
end

!----------------------------------------------------------
subroutine sab2( ya,yc,s,a,b )
!----------------------------------------------------------
! determination of the matrix imposing the boundary conditions.
!----------------------------------------------------------
    use parameters
    implicit none
    complex(dp),intent(in):: ya(4),yc(4),s(4)
    complex(dp),intent(out):: a(4,4),b(4)
    integer i

    a(1:2,1) = - ya(1:2)
    a(1:2,2) =   yc(1:2)
    b(1:2) = s(1:2)
    return
end

!----------------------------------------------------------
subroutine rea2( nn,a,g,c,d,nzone,iphase,kkdr,spn,kkdr0,nn0 )
!----------------------------------------------------------
! rearranging the matrix elements for l=0.
!----------------------------------------------------------
    use parameters
    implicit none
    integer,intent(in):: nn,nzone
    integer,intent(in):: iphase(nzone),kkdr(nzone),spn
    integer,intent(out)::kkdr0,nn0
    complex(dp):: a(4,*),c(2,*),g(nn),d(nn)
    integer:: izone,i1,i2,itmp,mtmp,i
!
    itmp = 0
    do izone=1,nzone
        if ( iphase(izone)==1 ) then
            if ( izone==spn ) kkdr0 = itmp + 1
            i1 = itmp + 1
            if ( izone/=nzone ) then
                i2 = i1 + ( kkdr(izone+1) - kkdr(izone) ) / 2 - 1
            else
                i2 = i1 + ( nn + 1 - kkdr(izone) ) / 2 - 1
            endif
            d(i1) = g(kkdr(izone))
            if ( izone/=1 ) then
                if ( iphase(izone-1)==2 ) then
                    c(1,i1) = a(3,kkdr(izone))
                else
                    c(1,i1) = a(2,kkdr(izone))
                endif
            endif
            c(2,i1) = a(4,kkdr(izone))
            do i=i1+1,i2
                mtmp = kkdr(izone) + 2 * ( i - i1 )
                d(i) = g(mtmp)
                c(1,i) = a(2,mtmp)
                c(2,i) = a(4,mtmp)
            enddo
            itmp = i2
        else
            i1 = itmp + 1
            i2 = i1 + ( kkdr(izone+1) - kkdr(izone) ) - 1
            d(i1) = g(kkdr(izone))
            if ( izone/=1 ) then
                if ( iphase(izone-1)==1 ) then
                    c(1,i1) = a(2,kkdr(izone))
                else
                    c(1,i1) = a(3,kkdr(izone))
                endif
            endif
            c(2,i1) = a(4,kkdr(izone))
            do i=i1+1,i2
                mtmp = kkdr(izone) + ( i - i1 )
                d(i) = g(mtmp)
                c(1,i) = a(3,mtmp)
                c(2,i) = a(4,mtmp)
            enddo
            itmp = i2
        endif
    enddo
    nn0 = itmp
    return
end

SUBROUTINE dclisb0_pretreatment(A, N, NUD, N1, B, EPS, DR, Z, IER)
!************************************************************************
!*  SIMULTANEOUS LINEAR EQUATIONS WITH REAL SYMMETRIC POSITIVE DEFINITE *
!*      BAND MATRIX BY CHOLESKY METHOD.                                 *
!*  PARAMETERS                                                          *
!*    (1) A : 2-DIM. ARRAY CONTAINING THE MATRIX.                       *
!*    (2) N : ORDER OF THE MATRIX.                                      *
!*    (3) NUD : SIZE OF BAND'S HALF WIDTH.                              *
!*    (4) N1 : ROW SIZE OF THE ARRAY A IN THE 'DIMENSION' STATEMENT.    *
!*    (5) B : 1-DIM. ARRAY CONTAINING THE RIGHT HAND SIDE VECTOR.       *
!*    (6) EPS : PARAMETER TO CHECK SINGURARITY OFF THE MATRIX           *
!*              STANDARD VALUE = 1.0D-14                                *
!*    (7) DR : 1-DIM. WORKING ARRAY.                                    *
!*    (8) Z : 1-DIM. WORKING ARRAY.                                     *
!*    (9) IER : ERROR CODE.                                             *
!*  COPY RIGHT   T. OGUNI   JULY 30 1989   VERSION 1.0                  *
!* modified Kensuke Konishi 2018 in Paris
!************************************************************************
    use parameters
    implicit none
    COMPLEX(dp):: A(N1,N), B(N), DR(N), Z(N)
    double precision:: EPS
    INTEGER:: N, NUD, N1 ,IER
    COMPLEX(dp)::XX, S, SUM, AU, T
    double precision:: EPS1
    INTEGER:: I ,M, J, K1, MJ, K
    ! CHECK THE INPUT DATA
    IER = 0
    EPS1 = 1.0D-14
    M = NUD + 1
    IF ( N <= 0 .OR. NUD <= 0 .OR. N1 < M ) THEN
        IER = 2
        WRITE(*,*) '(SUBR. LISB) INVALID ARGUMENT. ', N, NUD, N1
        RETURN
    ENDIF
    IF (EPS <= 0.0) EPS = EPS1
    ! MODIFIED CHOLESKY DECOMPOSITION
    J = 1
    IF (CDABS(A(M,1)) <= EPS) THEN
        IER = 1
        WRITE(*,*) '(SUBR. LISB) SINGULAR AT STEP # ', J
        RETURN
    ENDIF
    DR(1) = DCMPLX(1.0D0) / A(M,1)
    XX = A(M-1,2)
    A(M-1,2) = A(M-1,2) * DR(1)
    S = A(M,2) - XX * A(M-1,2)
    J = 2
    IF (CDABS(S) <= EPS) THEN
        IER = 1
        WRITE(*,*) '(SUBR. LISB) SINGULAR AT STEP # ', J
        RETURN
    ENDIF
    DR(2) = 1 / S
    IF (M < 3) THEN
        DO J=3,N
            XX = A(1,J)
            A(1,J) = XX * DR(J-1)
            S = A(2,J) - XX * A(1,J)
            IF (CDABS(S) <= EPS) THEN
                IER = 1
                WRITE(*,*) ' (SUBR. LISB) SINGULAR AT STEP # ', J
                RETURN
            ENDIF
            DR(J) = 1 / S
        enddo
    ELSE
        DO J=3,N
            K1 = 1
            IF (J >= M) K1 = J - M + 1
            MJ = M - J
            DO I=K1+1,J-1
                SUM = 0
                DO K=K1,I-1
                    SUM = SUM + A(M-I+K,I) * A(MJ+K,J)
                enddo
                A(MJ+I,J) = A(MJ+I,J) - SUM
            enddo
            SUM = 0
            DO I=K1,J-1
                XX = A(MJ+I,J)
                AU = XX * DR(I)
                SUM = SUM + XX *AU
                A(MJ+I,J) = AU
            enddo
            T = A(M,J) - SUM
            IF (CDABS(T) <= EPS) THEN
                IER = 1
                WRITE(*,*) ' (SUBR. LISB) SINGULAR AT STEP # ', J
                RETURN
            ENDIF
            DR(J) = 1 / T
        enddo
    ENDIF
    RETURN
END

SUBROUTINE DCLISB0(A, N, NUD, N1, B, EPS, DR, Z, IER)
!************************************************************************
!*  SIMULTANEOUS LINEAR EQUATIONS WITH REAL SYMMETRIC POSITIVE DEFINITE *
!*      BAND MATRIX BY CHOLESKY METHOD.                                 *
!*  PARAMETERS                                                          *
!*    (1) A : 2-DIM. ARRAY CONTAINING THE MATRIX.                       *
!*    (2) N : ORDER OF THE MATRIX.                                      *
!*    (3) NUD : SIZE OF BAND'S HALF WIDTH.                              *
!*    (4) N1 : ROW SIZE OF THE ARRAY A IN THE 'DIMENSION' STATEMENT.    *
!*    (5) B : 1-DIM. ARRAY CONTAINING THE RIGHT HAND SIDE VECTOR.       *
!*    (6) EPS : PARAMETER TO CHECK SINGURARITY OFF THE MATRIX           *
!*              STANDARD VALUE = 1.0D-14                                *
!*    (7) DR : 1-DIM. WORKING ARRAY.                                    *
!*    (8) Z : 1-DIM. WORKING ARRAY.                                     *
!*    (9) IER : ERROR CODE.                                             *
!*  COPY RIGHT   T. OGUNI   JULY 30 1989   VERSION 1.0                  *
!* modified Kensuke Konishi 2018 in Paris
!************************************************************************
    use parameters
    implicit none
    COMPLEX(dp):: A(N1,N), B(N), DR(N), Z(N)
    double precision:: EPS
    INTEGER:: N, NUD, N1 ,IER

    call dclisb0_pretreatment(A, N, NUD, N1, B, EPS, DR, Z, IER)
    ENTRY DCSBSUB0(A, N, NUD, N1, B, EPS, DR, Z, IER)
    !  FORWARD SUBSTITUTION
    call dclisb0_kenja(A, N, NUD, N1, B, EPS, DR, Z, IER)
    RETURN
END

SUBROUTINE dclisb0_kenja(A, N, NUD, N1, B, EPS, DR, Z, IER)
!************************************************************************
!*  SIMULTANEOUS LINEAR EQUATIONS WITH REAL SYMMETRIC POSITIVE DEFINITE *
!*      BAND MATRIX BY CHOLESKY METHOD.                                 *
!*  PARAMETERS                                                          *
!*    (1) A : 2-DIM. ARRAY CONTAINING THE MATRIX.                       *
!*    (2) N : ORDER OF THE MATRIX.                                      *
!*    (3) NUD : SIZE OF BAND'S HALF WIDTH.                              *
!*    (4) N1 : ROW SIZE OF THE ARRAY A IN THE 'DIMENSION' STATEMENT.    *
!*    (5) B : 1-DIM. ARRAY CONTAINING THE RIGHT HAND SIDE VECTOR.       *
!*    (6) EPS : PARAMETER TO CHECK SINGURARITY OFF THE MATRIX           *
!*              STANDARD VALUE = 1.0D-14                                *
!*    (7) DR : 1-DIM. WORKING ARRAY.                                    *
!*    (8) Z : 1-DIM. WORKING ARRAY.                                     *
!*    (9) IER : ERROR CODE.                                             *
!*  COPY RIGHT   T. OGUNI   JULY 30 1989   VERSION 1.0                  *
!* modified Kensuke Konishi 2018 in Paris
!************************************************************************
    use parameters
    implicit none
    COMPLEX(dp):: A(N1,N), B(N), DR(N), Z(N)
    double precision:: EPS
    INTEGER:: N, NUD, N1 ,IER
    COMPLEX (dp)::SUM
    INTEGER:: M, J, I1, K, J1
    !  FORWARD SUBSTITUTION
    M = NUD + 1
    IF (M < 3) THEN
        Z(1) = B(1)
        DO J=2,N
            Z(J) = B(J) - A(1,J) * Z(J-1)
        enddo
        DO J=1,N
            Z(J) = Z(J) * DR(J)
        enddo
        B(N) = Z(N)
        DO J=1,N-1
            B(N-J) = Z(N-J) - A(1,N-J+1) * B(N-J+1)
        enddo
    ELSE
        Z(1) = B(1)
        Z(2) = B(2) - A(M-1,2) * Z(1)
        DO J=3,N
            IF (J > M) THEN
                I1 = 1
            ELSE
                I1 = M - J + 1
            ENDIF
            SUM = 0
            DO K=I1,M-1
                SUM = SUM + A(K,J) * Z(J-M+K)
            enddo
            Z(J) = B(J) - SUM
        enddo
        DO  J=1,N
            Z(J) = Z(J) * DR(J)
        enddo

        B(N) = Z(N)
        B(N-1) = Z(N-1) - A(M-1,N) * Z(N)
        DO J=3,N
            J1 = N - J + 1
            I1 = 1
            IF (J < M) I1 = M - J + 1
            SUM = 0
            DO K=I1,M-1
                SUM = SUM + A(K,M-K+J1) * B(M-K+J1)
            enddo
            B(J1) = Z(J1) - SUM
        enddo
    ENDIF
    RETURN
END


SUBROUTINE dclisb_pretreatment(A, N, NUD, N1, NP, B, EPS, DR, Z, IER)
!************************************************************************
!*  SIMULTANEOUS LINEAR EQUATIONS WITH REAL SYMMETRIC POSITIVE DEFINITE *
!*      BAND MATRIX BY CHOLESKY METHOD.                                 *
!*  PARAMETERS                                                          *
!*    (1) A : 2-DIM. ARRAY CONTAINING THE MATRIX.                       *
!*    (2) N : ORDER OF THE MATRIX.                                      *
!*    (3) NUD : SIZE OF BAND'S HALF WIDTH.                              *
!*    (4) N1 : ROW SIZE OF THE ARRAY A IN THE 'DIMENSION' STATEMENT.    *
!*    (5) B : 1-DIM. ARRAY CONTAINING THE RIGHT HAND SIDE VECTOR.       *
!*    (6) EPS : PARAMETER TO CHECK SINGURARITY OFF THE MATRIX           *
!*              STANDARD VALUE = 1.0D-14                                *
!*    (7) DR : 1-DIM. WORKING ARRAY.                                    *
!*    (8) Z : 1-DIM. WORKING ARRAY.                                     *
!*    (9) IER : ERROR CODE.                                             *
!*  COPY RIGHT   T. OGUNI   JULY 30 1989   VERSION 1.0                  *
!* modified Kensuke Konishi 2018 in Paris
!************************************************************************
    use parameters
    implicit none
    COMPLEX(dp):: A(N1,N), B(N), DR(N), Z(N)
    double precision:: EPS, EPS1
    INTEGER:: N, NUD, N1, NP, IER
    DOUBLE COMPLEX:: XX, S, SUM, AU, T
    INTEGER:: I ,M, J, K1, MJ, K
    !  CHECK THE INPUT DATA
    IER = 0
    EPS1 = 1.0D-14
    M = NUD + 1
    IF ( N <= 0 .OR. NUD <= 0 .OR. N1 < M)  THEN
        IER = 2
        WRITE(*,*) '(SUBR. LISB) INVALID ARGUMENT. ', N, NUD, N1
        RETURN
    ENDIF
    IF (EPS <= 0.0) EPS = EPS1
    ! MODIFIED CHOLESKY DECOMPOSITION
    J = 1
    IF (CDABS(A(M,1)) <= EPS) THEN
        IER = 1
        WRITE(*,*) '(SUBR. LISB) SINGULAR AT STEP # ', J
        RETURN
    ENDIF
    DR(1) = 1 / A(M,1)
    XX = A(M-1,2)
    A(M-1,2) = A(M-1,2) * DR(1)
    S = A(M,2) - XX * A(M-1,2)
    J = 2
    IF (CDABS(S) <= EPS) THEN
        IER = 1
        WRITE(*,*) '(SUBR. LISB) SINGULAR AT STEP # ', J
        RETURN
    ENDIF
    DR(2) = 1 / S
    IF (M < 3) THEN
        DO J=3,N
            XX = A(1,J)
            A(1,J) = XX * DR(J-1)
            S = A(2,J) - XX * A(1,J)
            IF (CDABS(S) <= EPS) THEN
                IER = 1
                WRITE(*,*) ' (SUBR. LISB) SINGULAR AT STEP # ', J
                RETURN
            ENDIF
            DR(J) = 1 / S
        enddo
    ELSE
        DO J=3,N
            K1 = 1
            IF (J >= M) K1 = J - M + 1
            MJ = M - J
            DO  I=K1+1,J-1
                SUM = 0
                DO K=K1,I-1
                    SUM = SUM + A(M-I+K,I) * A(MJ+K,J)
                enddo
                A(MJ+I,J) = A(MJ+I,J) - SUM
            enddo
            SUM = 0
            DO  I=K1,J-1
                XX = A(MJ+I,J)
                AU = XX * DR(I)
                SUM = SUM + XX *AU
                A(MJ+I,J) = AU
            enddo
            T = A(M,J) - SUM
            IF (CDABS(T) <= EPS) THEN
                IER = 1
                WRITE(*,*) ' (SUBR. LISB) SINGULAR AT STEP # ', J
                RETURN
            ENDIF
            DR(J) = 1 / T
        enddo
    ENDIF

    RETURN
END

SUBROUTINE DCLISB(A, N, NUD, N1, NP, B, EPS, DR, Z, IER)
!************************************************************************
!*  SIMULTANEOUS LINEAR EQUATIONS WITH REAL SYMMETRIC POSITIVE DEFINITE *
!*      BAND MATRIX BY CHOLESKY METHOD.                                 *
!*  PARAMETERS                                                          *
!*    (1) A : 2-DIM. ARRAY CONTAINING THE MATRIX.                       *
!*    (2) N : ORDER OF THE MATRIX.                                      *
!*    (3) NUD : SIZE OF BAND'S HALF WIDTH.                              *
!*    (4) N1 : ROW SIZE OF THE ARRAY A IN THE 'DIMENSION' STATEMENT.    *
!*    (5) B : 1-DIM. ARRAY CONTAINING THE RIGHT HAND SIDE VECTOR.       *
!*    (6) EPS : PARAMETER TO CHECK SINGURARITY OFF THE MATRIX           *
!*              STANDARD VALUE = 1.0D-14                                *
!*    (7) DR : 1-DIM. WORKING ARRAY.                                    *
!*    (8) Z : 1-DIM. WORKING ARRAY.                                     *
!*    (9) IER : ERROR CODE.                                             *
!*  COPY RIGHT   T. OGUNI   JULY 30 1989   VERSION 1.0                  *
!* modified Kensuke Konishi 2018 in Paris
!************************************************************************
    use parameters
    COMPLEX(dp):: A(N1,N), B(N), DR(N), Z(N)
    double precision:: EPS
    INTEGER:: N, NUD, N1, NP, IER

    call dclisb_pretreatment(A, N, NUD, N1, NP, B, EPS, DR, Z, IER)
    ! SUBTITUTION
    ENTRY DCSBSUB(A, N, NUD, N1, NP, B, EPS, DR, Z, IER)
    call dclisb_kenja(A, N, NUD, N1, NP, B, EPS, DR, Z, IER)

    RETURN
END

SUBROUTINE dclisb_kenja(A, N, NUD, N1, NP, B, EPS, DR, Z, IER)
!************************************************************************
!*  SIMULTANEOUS LINEAR EQUATIONS WITH REAL SYMMETRIC POSITIVE DEFINITE *
!*      BAND MATRIX BY CHOLESKY METHOD.                                 *
!*  PARAMETERS                                                          *
!*    (1) A : 2-DIM. ARRAY CONTAINING THE MATRIX.                       *
!*    (2) N : ORDER OF THE MATRIX.                                      *
!*    (3) NUD : SIZE OF BAND'S HALF WIDTH.                              *
!*    (4) N1 : ROW SIZE OF THE ARRAY A IN THE 'DIMENSION' STATEMENT.    *
!*    (5) B : 1-DIM. ARRAY CONTAINING THE RIGHT HAND SIDE VECTOR.       *
!*    (6) EPS : PARAMETER TO CHECK SINGURARITY OFF THE MATRIX           *
!*              STANDARD VALUE = 1.0D-14                                *
!*    (7) DR : 1-DIM. WORKING ARRAY.                                    *
!*    (8) Z : 1-DIM. WORKING ARRAY.                                     *
!*    (9) IER : ERROR CODE.                                             *
!*  COPY RIGHT   T. OGUNI   JULY 30 1989   VERSION 1.0                  *
!* modified Kensuke Konishi 2018 in Paris
!************************************************************************
    use parameters
    COMPLEX(dp):: A(N1,N), B(N), DR(N), Z(N)
    double precision:: EPS
    INTEGER:: N, NUD, N1, NP, IER
    DOUBLE COMPLEX:: SUM
    INTEGER:: M, J, I1, K
    ! FORWARD SUBSTITUTION
    M = NUD + 1
    IF (M < 3) THEN
        Z(NP) = B(NP)
        DO J=NP+1,N
            Z(J) = B(J) - A(1,J) * Z(J-1)
        enddo
        B(N) = Z(N) * DR(N)
    ELSE
        Z(NP) = B(NP)
        Z(NP+1) = B(NP+1) - A(M-1,NP+1) * Z(NP)
        DO J=NP+2,N
            IF (J > NP-1+M) THEN
                I1 = 1
            ELSE
                I1 = NP-1+M - J + 1
            ENDIF
            SUM = 0
            DO K=I1,M-1
                SUM = SUM + A(K,J) * Z(J-M+K)
            enddo
            Z(J) = B(J) - SUM
        enddo
        DO J=N-1,N
            Z(J) = Z(J) * DR(J)
        enddo

        B(N) = Z(N)
        B(N-1) = Z(N-1) - A(M-1,N) * Z(N)
    ENDIF

    RETURN
END
